#include "ppeexnmnmx04.header.cxx"
void ppeexnmnmx04_list_subprocess_born(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeexnmnmx04_list_subprocess_born");
  logger << LOG_DEBUG << "called" << endl;
  if (contribution_order_alpha_s == 0 && contribution_order_alpha_e == 4 && contribution_order_interference == 0){
    subprocess.resize(3);
    subprocess[1] = "dd~_emepvmvm~";
    subprocess[2] = "uu~_emepvmvm~";
    int member_0[] = {1, 2};
    subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  }
  else if (contribution_order_alpha_s == 2 && contribution_order_alpha_e == 4 && contribution_order_interference == 0){
    subprocess.resize(2);
    subprocess[1] = "gg_emepvmvm~";
    int member_0[] = {1};
    subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  }
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeexnmnmx04_list_subprocess_C_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeexnmnmx04_list_subprocess_C_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(3);
  subprocess[1] = "dd~_emepvmvm~";
  subprocess[2] = "uu~_emepvmvm~";
  int member_0[] = {1, 2};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeexnmnmx04_list_subprocess_V_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeexnmnmx04_list_subprocess_V_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(3);
  subprocess[1] = "dd~_emepvmvm~";
  subprocess[2] = "uu~_emepvmvm~";
  int member_0[] = {1, 2};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeexnmnmx04_list_subprocess_R_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeexnmnmx04_list_subprocess_R_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_emepvmvm~d";
  subprocess[2] = "gu_emepvmvm~u";
  subprocess[3] = "gd~_emepvmvm~d~";
  subprocess[4] = "gu~_emepvmvm~u~";
  subprocess[5] = "dd~_emepvmvm~g";
  subprocess[6] = "uu~_emepvmvm~g";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeexnmnmx04_list_subprocess_RC_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeexnmnmx04_list_subprocess_RC_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_emepvmvm~d";
  subprocess[2] = "gu_emepvmvm~u";
  subprocess[3] = "gd~_emepvmvm~d~";
  subprocess[4] = "gu~_emepvmvm~u~";
  subprocess[5] = "dd~_emepvmvm~g";
  subprocess[6] = "uu~_emepvmvm~g";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeexnmnmx04_list_subprocess_RV_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeexnmnmx04_list_subprocess_RV_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_emepvmvm~d";
  subprocess[2] = "gu_emepvmvm~u";
  subprocess[3] = "gd~_emepvmvm~d~";
  subprocess[4] = "gu~_emepvmvm~u~";
  subprocess[5] = "dd~_emepvmvm~g";
  subprocess[6] = "uu~_emepvmvm~g";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeexnmnmx04_list_subprocess_RR_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeexnmnmx04_list_subprocess_RR_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(35);
  subprocess[1] = "gg_emepvmvm~dd~";
  subprocess[2] = "gg_emepvmvm~uu~";
  subprocess[3] = "gd_emepvmvm~gd";
  subprocess[4] = "gu_emepvmvm~gu";
  subprocess[5] = "gd~_emepvmvm~gd~";
  subprocess[6] = "gu~_emepvmvm~gu~";
  subprocess[7] = "dd_emepvmvm~dd";
  subprocess[8] = "du_emepvmvm~du";
  subprocess[9] = "ds_emepvmvm~ds";
  subprocess[10] = "dc_emepvmvm~dc";
  subprocess[11] = "dd~_emepvmvm~gg";
  subprocess[12] = "dd~_emepvmvm~dd~";
  subprocess[13] = "dd~_emepvmvm~uu~";
  subprocess[14] = "dd~_emepvmvm~ss~";
  subprocess[15] = "dd~_emepvmvm~cc~";
  subprocess[16] = "du~_emepvmvm~du~";
  subprocess[17] = "ds~_emepvmvm~ds~";
  subprocess[18] = "dc~_emepvmvm~dc~";
  subprocess[19] = "uu_emepvmvm~uu";
  subprocess[20] = "uc_emepvmvm~uc";
  subprocess[21] = "ud~_emepvmvm~ud~";
  subprocess[22] = "uu~_emepvmvm~gg";
  subprocess[23] = "uu~_emepvmvm~dd~";
  subprocess[24] = "uu~_emepvmvm~uu~";
  subprocess[25] = "uu~_emepvmvm~ss~";
  subprocess[26] = "uu~_emepvmvm~cc~";
  subprocess[27] = "us~_emepvmvm~us~";
  subprocess[28] = "uc~_emepvmvm~uc~";
  subprocess[29] = "d~d~_emepvmvm~d~d~";
  subprocess[30] = "d~u~_emepvmvm~d~u~";
  subprocess[31] = "d~s~_emepvmvm~d~s~";
  subprocess[32] = "d~c~_emepvmvm~d~c~";
  subprocess[33] = "u~u~_emepvmvm~u~u~";
  subprocess[34] = "u~c~_emepvmvm~u~c~";
  int member_0[] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
