{
  if (sd == 1){
    // invariant mass m of the colourless system
    temp_mu_central = (PARTICLE("lep")[0].momentum + PARTICLE("lep")[1].momentum + PARTICLE("nua")[0].momentum + PARTICLE("nua")[1].momentum).m();
    // takes sum of momenta of hardest lepton PARTICLE("lep")[0].momentum, second-hardest lepton PARTICLE("lep")[1].momentum, etc. 
    // and computes their invariant mass (***).m()
  }
  else if (sd == 2){
    // transverse mass of the colourless system
    double m  = (PARTICLE("lep")[0].momentum + PARTICLE("lep")[1].momentum + PARTICLE("nua")[0].momentum + PARTICLE("nua")[1].momentum).m();
    double pT = (PARTICLE("lep")[0].momentum + PARTICLE("lep")[1].momentum + PARTICLE("nua")[0].momentum + PARTICLE("nua")[1].momentum).pT();
    temp_mu_central = sqrt(pow(m, 2) + pow(pT, 2));
    // quadratic sum of invariant mass (***).m() and transverse momentum (***).pT()
  }
  else if (sd == 3){
    // sum of transverse masses of the two W bosons with the invariant mass replaced by the W-boson pole mass
    fourvector wplus = PARTICLE("lp")[0].momentum + PARTICLE("nu")[0].momentum;
    fourvector wminus = PARTICLE("lm")[0].momentum + PARTICLE("nux")[0].momentum;
    double wplus_ET = sqrt(osi_msi.M2_W + wplus.pT2());
    double wminus_ET = sqrt(osi_msi.M2_W + wminus.pT2());
    temp_mu_central = wplus_ET + wminus_ET;
  }
  else if (sd == 4){
    // sum of transverse masses of the two W bosons
    double wplus_ET  = (PARTICLE("lp")[0].momentum + PARTICLE("nu")[0].momentum).ET();
    double wminus_ET = (PARTICLE("lm")[0].momentum + PARTICLE("nux")[0].momentum).ET();
    temp_mu_central = wplus_ET + wminus_ET;
  }
}
