#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppaa02/header/ppaa02.phasespace.h"
void ppaa02_optimize_minv_doublereal(phasespace_set & psi){
  static Logger logger("ppaa02_optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppaa02_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppaa02_determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 86;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 30;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 30;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 30;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 30;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 30;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 30;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 40;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 20;}
  else if (psi_no_map[no_ps] == 10){n_channel = 20;}
  else if (psi_no_map[no_ps] == 11){n_channel = 20;}
  else if (psi_no_map[no_ps] == 13){n_channel = 30;}
  else if (psi_no_map[no_ps] == 14){n_channel = 40;}
  else if (psi_no_map[no_ps] == 15){n_channel = 20;}
  else if (psi_no_map[no_ps] == 16){n_channel = 20;}
  else if (psi_no_map[no_ps] == 17){n_channel = 20;}
  else if (psi_no_map[no_ps] == 18){n_channel = 20;}
  else if (psi_no_map[no_ps] == 20){n_channel = 20;}
  else if (psi_no_map[no_ps] == 22){n_channel = 20;}
  else if (psi_no_map[no_ps] == 23){n_channel = 40;}
  else if (psi_no_map[no_ps] == 24){n_channel = 20;}
  else if (psi_no_map[no_ps] == 25){n_channel = 20;}
  else if (psi_no_map[no_ps] == 27){n_channel = 30;}
  else if (psi_no_map[no_ps] == 28){n_channel = 20;}
  else if (psi_no_map[no_ps] == 29){n_channel = 40;}
  else if (psi_no_map[no_ps] == 30){n_channel = 20;}
  else if (psi_no_map[no_ps] == 31){n_channel = 20;}
  else if (psi_no_map[no_ps] == 32){n_channel = 20;}
  else if (psi_no_map[no_ps] == 34){n_channel = 20;}
  else if (psi_no_map[no_ps] == 35){n_channel = 40;}
  else if (psi_no_map[no_ps] == 36){n_channel = 20;}
  else if (psi_no_map[no_ps] == 37){n_channel = 20;}
  else if (psi_no_map[no_ps] == 38){n_channel = 20;}
  else if (psi_no_map[no_ps] == 40){n_channel = 40;}
  else if (psi_no_map[no_ps] == 41){n_channel = 20;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppaa02_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppaa02_ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 18){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 20){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 22){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 23){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 24){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 25){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 27){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 28){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 29){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 30){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 31){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 32){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 34){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 35){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 36){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 37){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 38){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 40){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 41){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppaa02_ax_psp_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppaa02_ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  2){ppaa02_ax_psp_220_gg_aaddx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppaa02_ax_psp_220_gg_aauux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppaa02_ax_psp_220_gd_aagd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppaa02_ax_psp_220_gu_aagu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppaa02_ax_psp_220_gdx_aagdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppaa02_ax_psp_220_gux_aagux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppaa02_ax_psp_220_dd_aadd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppaa02_ax_psp_220_du_aadu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppaa02_ax_psp_220_ds_aads(no_ps, psi);}
  else if (psi_no_map[no_ps] == 11){ppaa02_ax_psp_220_dc_aadc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 13){ppaa02_ax_psp_220_ddx_aagg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 14){ppaa02_ax_psp_220_ddx_aaddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 15){ppaa02_ax_psp_220_ddx_aauux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 16){ppaa02_ax_psp_220_ddx_aassx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 17){ppaa02_ax_psp_220_ddx_aaccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 18){ppaa02_ax_psp_220_dux_aadux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 20){ppaa02_ax_psp_220_dsx_aadsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 22){ppaa02_ax_psp_220_dcx_aadcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 23){ppaa02_ax_psp_220_uu_aauu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 24){ppaa02_ax_psp_220_uc_aauc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 25){ppaa02_ax_psp_220_udx_aaudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 27){ppaa02_ax_psp_220_uux_aagg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 28){ppaa02_ax_psp_220_uux_aaddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 29){ppaa02_ax_psp_220_uux_aauux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 30){ppaa02_ax_psp_220_uux_aassx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 31){ppaa02_ax_psp_220_uux_aaccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 32){ppaa02_ax_psp_220_usx_aausx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 34){ppaa02_ax_psp_220_ucx_aaucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 35){ppaa02_ax_psp_220_dxdx_aadxdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 36){ppaa02_ax_psp_220_dxux_aadxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 37){ppaa02_ax_psp_220_dxsx_aadxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 38){ppaa02_ax_psp_220_dxcx_aadxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 40){ppaa02_ax_psp_220_uxux_aauxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 41){ppaa02_ax_psp_220_uxcx_aauxcx(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
