#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeexa03/header/ppeexa03.phasespace.h"
void ppeexa03_ax_psp_230_dd_emepadd(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexa03_ax_psp_230_dd_emepadd");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(21);
  psi_needed_v_smin[no_ps].resize(21);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   12,   13,   14,   15,   24,   25,   26,   27,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   52,   53,   54,   55,   60,   61,   62,   63,   64,   65,   66,   67,   72,   73,   74,   75,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,  108,  109,  110,  111}; //  80
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 80);
  int needed_v_smin_1[] = {   8,    9,   10,   11,   20,   21,   22,   23,   48,   49,   50,   51,   68,   69,   70,   71}; //  16
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 16);
  int needed_v_smin_2[] = {   8,    9,   10,   11,   20,   21,   22,   23,   48,   49,   50,   51,   68,   69,   70,   71}; //  16
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 16);
  int needed_v_smin_3[] = {  12,   13,   24,   25,   40,   41,   44,   45,   54,   55,   72,   73,   92,   93,  104,  105,   38,   39,   64,   65,  100,  101}; //  22
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 22);
  int needed_v_smin_4[] = {  14,   15,   26,   27,   42,   43,   46,   47,   52,   53,   74,   75,   94,   95,  106,  107,   36,   37,   66,   67,  102,  103}; //  22
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 22);
  int needed_v_smin_5[] = {  16,   17,   18,   19,   28,   29,   30,   31,   56,   57,   58,   59,   76,   77,   78,   79}; //  16
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 16);
  int needed_v_smin_6[] = {  16,   17,   18,   19,   28,   29,   30,   31,   56,   57,   58,   59,   76,   77,   78,   79}; //  16
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 16);
  int needed_v_smin_7[] = {  20,   21,   28,   29,   48,   49,   56,   57,   10,   11,   18,   19,   68,   69,   76,   77}; //  16
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 16);
  int needed_v_smin_8[] = {  22,   23,   30,   31,   50,   51,   58,   59,    8,    9,   16,   17,   70,   71,   78,   79}; //  16
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 16);
  int needed_v_smin_9[] = {  24,   25,   54,   55,   40,   41,   64,   65}; //   8
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 8);
  int needed_v_smin_10[] = {  26,   27,   52,   53,   42,   43,   66,   67}; //   8
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 8);
  int needed_v_smin_11[] = {  32,   33,   60,   61,   88,   89,   92,   93,   96,   97,  100,  101,  104,  105,  108,  109,    0,    1,   86,   87}; //  20
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 20);
  int needed_v_smin_12[] = {  32,   33,   60,   61,    0,    1,   86,   87,   88,   89,  108,  109}; //  12
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 12);
  int needed_v_smin_13[] = {  34,   35,   62,   63,   90,   91,   94,   95,   98,   99,  102,  103,  106,  107,  110,  111,    2,    3,   84,   85}; //  20
  psi_needed_v_smin[no_ps][ 13] = get_vector_from_array_int(needed_v_smin_13, 20);
  int needed_v_smin_14[] = {  34,   35,   62,   63,    2,    3,   84,   85,   90,   91,  110,  111}; //  12
  psi_needed_v_smin[no_ps][ 14] = get_vector_from_array_int(needed_v_smin_14, 12);
  int needed_v_smin_15[] = {   4,    5,    6,    7,   80,   81,   82,   83}; //   8
  psi_needed_v_smin[no_ps][ 15] = get_vector_from_array_int(needed_v_smin_15, 8);
  int needed_v_smin_16[] = {   4,    5,    6,    7,   80,   81,   82,   83}; //   8
  psi_needed_v_smin[no_ps][ 16] = get_vector_from_array_int(needed_v_smin_16, 8);
  int needed_v_smin_17[] = {  12,   13,   38,   39,   44,   45,   72,   73}; //   8
  psi_needed_v_smin[no_ps][ 17] = get_vector_from_array_int(needed_v_smin_17, 8);
  int needed_v_smin_18[] = {  14,   15,   36,   37,   46,   47,   74,   75}; //   8
  psi_needed_v_smin[no_ps][ 18] = get_vector_from_array_int(needed_v_smin_18, 8);
  int needed_v_smin_19[] = {  96,   97}; //   2
  psi_needed_v_smin[no_ps][ 19] = get_vector_from_array_int(needed_v_smin_19, 2);
  int needed_v_smin_20[] = {  98,   99}; //   2
  psi_needed_v_smin[no_ps][ 20] = get_vector_from_array_int(needed_v_smin_20, 2);

  psi_v_smax[no_ps].resize(21);
  psi_needed_v_smax[no_ps].resize(21);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   12,   13,   14,   15,   24,   25,   26,   27,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   52,   53,   54,   55,   64,   65,   66,   67,   72,   73,   74,   75,   80,   81,   82,   83,   84,   85,   86,   87,   92,   93,   94,   95,  100,  101,  102,  103,  108,  109,  110,  111}; //  60
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 60);
  int needed_v_smax_1[] = {   8,    9,   10,   11,   20,   21,   22,   23,   48,   49,   50,   51,   68,   69,   70,   71}; //  16
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 16);
  int needed_v_smax_2[] = {   8,    9,   10,   11,   16,   17,   18,   19,   20,   21,   22,   23,   28,   29,   30,   31,   48,   49,   50,   51,   56,   57,   58,   59,   68,   69,   70,   71,   76,   77,   78,   79}; //  32
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 32);
  int needed_v_smax_3[] = {  12,   13,   24,   25,   40,   41,   44,   45,   54,   55,   72,   73,   92,   93,   38,   39,   64,   65}; //  18
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 18);
  int needed_v_smax_4[] = {  14,   15,   26,   27,   42,   43,   46,   47,   52,   53,   74,   75,   94,   95,   36,   37,   66,   67}; //  18
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 18);
  int needed_v_smax_5[] = {  16,   17,   18,   19,   28,   29,   30,   31,   56,   57,   58,   59,   76,   77,   78,   79}; //  16
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 16);
  int needed_v_smax_6[] = {  20,   21,   24,   25,   28,   29,   34,   35,   48,   49,   54,   55,   56,   57,   62,   63,    2,    3,   10,   11,   18,   19,   40,   41,   64,   65,   68,   69,   76,   77,   84,   85,   90,   91,  110,  111}; //  36
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 36);
  int needed_v_smax_7[] = {  22,   23,   26,   27,   30,   31,   32,   33,   50,   51,   52,   53,   58,   59,   60,   61,    0,    1,    8,    9,   16,   17,   42,   43,   66,   67,   70,   71,   78,   79,   86,   87,   88,   89,  108,  109}; //  36
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 36);
  int needed_v_smax_8[] = {  32,   33,   60,   61,   88,   89,   96,   97,  104,  105}; //  10
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 10);
  int needed_v_smax_9[] = {  32,   33,   60,   61,   88,   89,   96,   97,  104,  105}; //  10
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 10);
  int needed_v_smax_10[] = {  34,   35,   62,   63,   90,   91,   98,   99,  106,  107}; //  10
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 10);
  int needed_v_smax_11[] = {  34,   35,   62,   63,   90,   91,   98,   99,  106,  107}; //  10
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 10);
  int needed_v_smax_12[] = {  92,   93}; //   2
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 2);
  int needed_v_smax_13[] = {  94,   95}; //   2
  psi_needed_v_smax[no_ps][ 13] = get_vector_from_array_int(needed_v_smax_13, 2);
  int needed_v_smax_14[] = { 100,  101,  108,  109,    0,    1,   86,   87}; //   8
  psi_needed_v_smax[no_ps][ 14] = get_vector_from_array_int(needed_v_smax_14, 8);
  int needed_v_smax_15[] = { 102,  103,  110,  111,    2,    3,   84,   85}; //   8
  psi_needed_v_smax[no_ps][ 15] = get_vector_from_array_int(needed_v_smax_15, 8);
  int needed_v_smax_16[] = { 104,  105,  100,  101}; //   4
  psi_needed_v_smax[no_ps][ 16] = get_vector_from_array_int(needed_v_smax_16, 4);
  int needed_v_smax_17[] = { 106,  107,  102,  103}; //   4
  psi_needed_v_smax[no_ps][ 17] = get_vector_from_array_int(needed_v_smax_17, 4);
  int needed_v_smax_18[] = {   4,    5,    6,    7,   80,   81,   82,   83}; //   8
  psi_needed_v_smax[no_ps][ 18] = get_vector_from_array_int(needed_v_smax_18, 8);
  int needed_v_smax_19[] = {   4,    5,    6,    7,   12,   13,   14,   15,   36,   37,   38,   39,   44,   45,   46,   47,   72,   73,   74,   75,   80,   81,   82,   83}; //  24
  psi_needed_v_smax[no_ps][ 19] = get_vector_from_array_int(needed_v_smax_19, 24);
  int needed_v_smax_20[] = {  96,   97,   98,   99}; //   4
  psi_needed_v_smax[no_ps][ 20] = get_vector_from_array_int(needed_v_smax_20, 4);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(28);
  psi_needed_g_p[no_ps].resize(28);
  int needed_g_p_0[] = {   0,    2,    4,    6,   12,   14,   24,   26,   36,   38,   40,   42,   44,   46,   52,   54,   64,   66,   72,   74,   80,   82,   84,   86,   92,   94,  100,  102,  108,  110}; //  30
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 30);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_1[] = {   1,    3,    5,    7,   13,   15,   25,   27,   37,   39,   41,   43,   45,   47,   53,   55,   65,   67,   73,   75,   81,   83,   85,   87,   93,   95,  101,  103,  109,  111}; //  30
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 30);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_2[] = {   8,    9,   10,   11,   20,   21,   22,   23,   48,   49,   50,   51,   68,   69,   70,   71}; //  16
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 16);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_3[] = {   8,   10,   20,   22,   48,   50,   68,   70}; //   8
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 8);
  psi_container_IS_name.push_back("propagator_0_smin2_smax2");
  int needed_g_p_4[] = {   9,   11,   21,   23,   49,   51,   69,   71}; //   8
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 8);
  psi_container_IS_name.push_back("propagator_23_smin2_smax2");
  int needed_g_p_5[] = {  12,   13,   24,   25,   40,   41,   44,   45,   54,   55,   72,   73,   92,   93}; //  14
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 14);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_6[] = {  14,   15,   26,   27,   42,   43,   46,   47,   52,   53,   74,   75,   94,   95}; //  14
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 14);
  psi_container_IS_name.push_back("propagator_0_smin4_smax4");
  int needed_g_p_7[] = {  16,   17,   18,   19,   28,   29,   30,   31,   56,   57,   58,   59,   76,   77,   78,   79}; //  16
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 16);
  psi_container_IS_name.push_back("propagator_0_smin5_smax5");
  int needed_g_p_8[] = {  16,   18,   28,   30,   56,   58,   76,   78}; //   8
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 8);
  psi_container_IS_name.push_back("propagator_0_smin6_smax2");
  int needed_g_p_9[] = {  17,   19,   29,   31,   57,   59,   77,   79}; //   8
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 8);
  psi_container_IS_name.push_back("propagator_23_smin6_smax2");
  int needed_g_p_10[] = {  20,   21,   28,   29,   48,   49,   56,   57}; //   8
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 8);
  psi_container_IS_name.push_back("propagator_0_smin7_smax6");
  int needed_g_p_11[] = {  22,   23,   30,   31,   50,   51,   58,   59}; //   8
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 8);
  psi_container_IS_name.push_back("propagator_0_smin8_smax7");
  int needed_g_p_12[] = {  24,   25,   54,   55}; //   4
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 4);
  psi_container_IS_name.push_back("propagator_0_smin9_smax6");
  int needed_g_p_13[] = {  26,   27,   52,   53}; //   4
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 4);
  psi_container_IS_name.push_back("propagator_0_smin10_smax7");
  int needed_g_p_14[] = {  32,   33,   60,   61,   88,   89,   96,   97,  104,  105}; //  10
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 10);
  psi_container_IS_name.push_back("propagator_0_smin11_smax8");
  int needed_g_p_15[] = {  32,   60,   88,   96,  104}; //   5
  psi_needed_g_p[no_ps][15] = get_vector_from_array_int(needed_g_p_15, 5);
  psi_container_IS_name.push_back("propagator_0_smin0_smax9");
  int needed_g_p_16[] = {  32,   33,   60,   61}; //   4
  psi_needed_g_p[no_ps][16] = get_vector_from_array_int(needed_g_p_16, 4);
  psi_container_IS_name.push_back("propagator_0_smin12_smax7");
  int needed_g_p_17[] = {  33,   61,   89,   97,  105}; //   5
  psi_needed_g_p[no_ps][17] = get_vector_from_array_int(needed_g_p_17, 5);
  psi_container_IS_name.push_back("propagator_23_smin0_smax9");
  int needed_g_p_18[] = {  34,   35,   62,   63,   90,   91,   98,   99,  106,  107}; //  10
  psi_needed_g_p[no_ps][18] = get_vector_from_array_int(needed_g_p_18, 10);
  psi_container_IS_name.push_back("propagator_0_smin13_smax10");
  int needed_g_p_19[] = {  34,   62,   90,   98,  106}; //   5
  psi_needed_g_p[no_ps][19] = get_vector_from_array_int(needed_g_p_19, 5);
  psi_container_IS_name.push_back("propagator_0_smin0_smax11");
  int needed_g_p_20[] = {  34,   35,   62,   63}; //   4
  psi_needed_g_p[no_ps][20] = get_vector_from_array_int(needed_g_p_20, 4);
  psi_container_IS_name.push_back("propagator_0_smin14_smax6");
  int needed_g_p_21[] = {  35,   63,   91,   99,  107}; //   5
  psi_needed_g_p[no_ps][21] = get_vector_from_array_int(needed_g_p_21, 5);
  psi_container_IS_name.push_back("propagator_23_smin0_smax11");
  int needed_g_p_22[] = {  92,   93}; //   2
  psi_needed_g_p[no_ps][22] = get_vector_from_array_int(needed_g_p_22, 2);
  psi_container_IS_name.push_back("propagator_0_smin11_smax12");
  int needed_g_p_23[] = {  94,   95}; //   2
  psi_needed_g_p[no_ps][23] = get_vector_from_array_int(needed_g_p_23, 2);
  psi_container_IS_name.push_back("propagator_0_smin13_smax13");
  int needed_g_p_24[] = { 100,  101,  108,  109}; //   4
  psi_needed_g_p[no_ps][24] = get_vector_from_array_int(needed_g_p_24, 4);
  psi_container_IS_name.push_back("propagator_0_smin11_smax14");
  int needed_g_p_25[] = { 102,  103,  110,  111}; //   4
  psi_needed_g_p[no_ps][25] = get_vector_from_array_int(needed_g_p_25, 4);
  psi_container_IS_name.push_back("propagator_0_smin13_smax15");
  int needed_g_p_26[] = { 104,  105}; //   2
  psi_needed_g_p[no_ps][26] = get_vector_from_array_int(needed_g_p_26, 2);
  psi_container_IS_name.push_back("propagator_0_smin3_smax16");
  int needed_g_p_27[] = { 106,  107}; //   2
  psi_needed_g_p[no_ps][27] = get_vector_from_array_int(needed_g_p_27, 2);
  psi_container_IS_name.push_back("propagator_0_smin4_smax17");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(18);
  psi_needed_g_f[no_ps].resize(18);
  int needed_g_f_0[] = {   0,    1,   86,   87}; //   4
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin11_smax14");
  int needed_g_f_1[] = {   0,    1,   86,   87,   88,   89,  108,  109}; //   8
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin12_smax7");
  int needed_g_f_2[] = {   2,    3,   84,   85}; //   4
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin13_smax15");
  int needed_g_f_3[] = {   2,    3,   84,   85,   90,   91,  110,  111}; //   8
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin14_smax6");
  int needed_g_f_4[] = {   4,    5,    6,    7,   80,   81,   82,   83}; //   8
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin15_smax18");
  int needed_g_f_5[] = {   4,    5,    6,    7,   80,   81,   82,   83}; //   8
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin16_smax19");
  int needed_g_f_6[] = {   8,    9,   16,   17,   70,   71,   78,   79}; //   8
  psi_needed_g_f[no_ps][6] = get_vector_from_array_int(needed_g_f_6, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin8_smax7");
  int needed_g_f_7[] = {  10,   11,   18,   19,   68,   69,   76,   77}; //   8
  psi_needed_g_f[no_ps][7] = get_vector_from_array_int(needed_g_f_7, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin7_smax6");
  int needed_g_f_8[] = {  12,   13,   38,   39,   44,   45,   72,   73}; //   8
  psi_needed_g_f[no_ps][8] = get_vector_from_array_int(needed_g_f_8, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin17_smax19");
  int needed_g_f_9[] = {  14,   15,   36,   37,   46,   47,   74,   75}; //   8
  psi_needed_g_f[no_ps][9] = get_vector_from_array_int(needed_g_f_9, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin18_smax19");
  int needed_g_f_10[] = {  36,   37,   66,   67}; //   4
  psi_needed_g_f[no_ps][10] = get_vector_from_array_int(needed_g_f_10, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin4_smax4");
  int needed_g_f_11[] = {  38,   39,   64,   65}; //   4
  psi_needed_g_f[no_ps][11] = get_vector_from_array_int(needed_g_f_11, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin3_smax3");
  int needed_g_f_12[] = {  40,   41,   64,   65}; //   4
  psi_needed_g_f[no_ps][12] = get_vector_from_array_int(needed_g_f_12, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin9_smax6");
  int needed_g_f_13[] = {  42,   43,   66,   67}; //   4
  psi_needed_g_f[no_ps][13] = get_vector_from_array_int(needed_g_f_13, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin10_smax7");
  int needed_g_f_14[] = {  96,   97}; //   2
  psi_needed_g_f[no_ps][14] = get_vector_from_array_int(needed_g_f_14, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin19_smax20");
  int needed_g_f_15[] = {  98,   99}; //   2
  psi_needed_g_f[no_ps][15] = get_vector_from_array_int(needed_g_f_15, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin20_smax20");
  int needed_g_f_16[] = { 100,  101}; //   2
  psi_needed_g_f[no_ps][16] = get_vector_from_array_int(needed_g_f_16, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin3_smax16");
  int needed_g_f_17[] = { 102,  103}; //   2
  psi_needed_g_f[no_ps][17] = get_vector_from_array_int(needed_g_f_17, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin4_smax17");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(45);
  psi_needed_g_t[no_ps].resize(45);
  int needed_g_t_0[] = {   0,    1,    8,    9,   16,   17,   22,   23,   26,   27,   30,   31,   32,   33,   88,   89}; //  16
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 16);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__64_60");
  int needed_g_t_1[] = {   0,    1,   88,   89}; //   4
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_66__12_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_66__12_48");
  int needed_g_t_2[] = {   0,    1}; //   2
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__66_13__32_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__66_13__32_16");
  int needed_g_t_3[] = {   2,    3,   10,   11,   18,   19,   20,   21,   24,   25,   28,   29,   34,   35,   90,   91}; //  16
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 16);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__32_92");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__32_92");
  int needed_g_t_4[] = {   2,    3,   90,   91}; //   4
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_34__12_80");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_34__12_80");
  int needed_g_t_5[] = {   2,    3}; //   2
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__34_13__64_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__34_13__64_16");
  int needed_g_t_6[] = {   4,    5,    6,    7,   12,   13,   14,   15}; //   8
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 8);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__16_108");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__16_108");
  int needed_g_t_7[] = {   4,    5,    6,    7}; //   4
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_18__12_96");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_18__12_96");
  int needed_g_t_8[] = {   4,    5}; //   2
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__18_13__64_32");
  psi_container_IS_name.push_back("phi_of_tchannel_0__18_13__64_32");
  int needed_g_t_9[] = {   6,    7}; //   2
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__18_13__32_64");
  psi_container_IS_name.push_back("phi_of_tchannel_0__18_13__32_64");
  int needed_g_t_10[] = {   8,    9,   16,   17}; //   4
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__66_1__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__66_1__32_28");
  int needed_g_t_11[] = {  10,   11,   18,   19}; //   4
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__34_1__64_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__34_1__64_28");
  int needed_g_t_12[] = {  12,   13}; //   2
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__18_1__32_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__18_1__32_76");
  int needed_g_t_13[] = {  14,   15}; //   2
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__18_1__64_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__18_1__64_44");
  int needed_g_t_14[] = {  36,   37,   38,   39,   44,   45,   46,   47,   72,   73,   74,   75,   80,   81,   82,   83}; //  16
  psi_needed_g_t[no_ps][14] = get_vector_from_array_int(needed_g_t_14, 16);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__16_108");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__16_108");
  int needed_g_t_15[] = {  36,   37,   46,   47}; //   4
  psi_needed_g_t[no_ps][15] = get_vector_from_array_int(needed_g_t_15, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__64_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__64_44");
  int needed_g_t_16[] = {  36,   37}; //   2
  psi_needed_g_t[no_ps][16] = get_vector_from_array_int(needed_g_t_16, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__66_17__32_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__66_17__32_12");
  int needed_g_t_17[] = {  38,   39,   44,   45}; //   4
  psi_needed_g_t[no_ps][17] = get_vector_from_array_int(needed_g_t_17, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__32_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__32_76");
  int needed_g_t_18[] = {  38,   39}; //   2
  psi_needed_g_t[no_ps][18] = get_vector_from_array_int(needed_g_t_18, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__34_17__64_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__34_17__64_12");
  int needed_g_t_19[] = {  40,   41,   48,   49,   54,   55,   56,   57,   62,   63,   64,   65,   68,   69,   76,   77,   84,   85,  110,  111}; //  20
  psi_needed_g_t[no_ps][19] = get_vector_from_array_int(needed_g_t_19, 20);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__32_92");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__32_92");
  int needed_g_t_20[] = {  40,   41,   64,   65}; //   4
  psi_needed_g_t[no_ps][20] = get_vector_from_array_int(needed_g_t_20, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__16_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__16_76");
  int needed_g_t_21[] = {  42,   43,   50,   51,   52,   53,   58,   59,   60,   61,   66,   67,   70,   71,   78,   79,   86,   87,  108,  109}; //  20
  psi_needed_g_t[no_ps][21] = get_vector_from_array_int(needed_g_t_21, 20);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__64_60");
  int needed_g_t_22[] = {  42,   43,   66,   67}; //   4
  psi_needed_g_t[no_ps][22] = get_vector_from_array_int(needed_g_t_22, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__16_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__16_44");
  int needed_g_t_23[] = {  64,   65}; //   2
  psi_needed_g_t[no_ps][23] = get_vector_from_array_int(needed_g_t_23, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_18__64_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_18__64_12");
  int needed_g_t_24[] = {  66,   67}; //   2
  psi_needed_g_t[no_ps][24] = get_vector_from_array_int(needed_g_t_24, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__65_18__32_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__65_18__32_12");
  int needed_g_t_25[] = {  68,   69,   76,   77}; //   4
  psi_needed_g_t[no_ps][25] = get_vector_from_array_int(needed_g_t_25, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__33_2__64_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__33_2__64_28");
  int needed_g_t_26[] = {  70,   71,   78,   79}; //   4
  psi_needed_g_t[no_ps][26] = get_vector_from_array_int(needed_g_t_26, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__65_2__32_28");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__65_2__32_28");
  int needed_g_t_27[] = {  72,   73}; //   2
  psi_needed_g_t[no_ps][27] = get_vector_from_array_int(needed_g_t_27, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__17_2__32_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__17_2__32_76");
  int needed_g_t_28[] = {  74,   75}; //   2
  psi_needed_g_t[no_ps][28] = get_vector_from_array_int(needed_g_t_28, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__17_2__64_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__17_2__64_44");
  int needed_g_t_29[] = {  80,   81,   82,   83}; //   4
  psi_needed_g_t[no_ps][29] = get_vector_from_array_int(needed_g_t_29, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_17__12_96");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_17__12_96");
  int needed_g_t_30[] = {  80,   81}; //   2
  psi_needed_g_t[no_ps][30] = get_vector_from_array_int(needed_g_t_30, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__17_14__32_64");
  psi_container_IS_name.push_back("phi_of_tchannel_0__17_14__32_64");
  int needed_g_t_31[] = {  82,   83}; //   2
  psi_needed_g_t[no_ps][31] = get_vector_from_array_int(needed_g_t_31, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__17_14__64_32");
  psi_container_IS_name.push_back("phi_of_tchannel_0__17_14__64_32");
  int needed_g_t_32[] = {  84,   85,  110,  111}; //   4
  psi_needed_g_t[no_ps][32] = get_vector_from_array_int(needed_g_t_32, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_33__12_80");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_33__12_80");
  int needed_g_t_33[] = {  84,   85}; //   2
  psi_needed_g_t[no_ps][33] = get_vector_from_array_int(needed_g_t_33, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__33_14__64_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__33_14__64_16");
  int needed_g_t_34[] = {  86,   87,  108,  109}; //   4
  psi_needed_g_t[no_ps][34] = get_vector_from_array_int(needed_g_t_34, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__12_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__12_48");
  int needed_g_t_35[] = {  86,   87}; //   2
  psi_needed_g_t[no_ps][35] = get_vector_from_array_int(needed_g_t_35, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__65_14__32_16");
  psi_container_IS_name.push_back("phi_of_tchannel_0__65_14__32_16");
  int needed_g_t_36[] = {  92,   93,  100,  101}; //   4
  psi_needed_g_t[no_ps][36] = get_vector_from_array_int(needed_g_t_36, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__48_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__48_76");
  int needed_g_t_37[] = {  94,   95,  102,  103}; //   4
  psi_needed_g_t[no_ps][37] = get_vector_from_array_int(needed_g_t_37, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__80_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__80_44");
  int needed_g_t_38[] = {  96,   97,   98,   99}; //   4
  psi_needed_g_t[no_ps][38] = get_vector_from_array_int(needed_g_t_38, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__12_112");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__12_112");
  int needed_g_t_39[] = {  96,   97}; //   2
  psi_needed_g_t[no_ps][39] = get_vector_from_array_int(needed_g_t_39, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_13__48_64");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_13__48_64");
  int needed_g_t_40[] = {  98,   99}; //   2
  psi_needed_g_t[no_ps][40] = get_vector_from_array_int(needed_g_t_40, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_13__80_32");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_13__80_32");
  int needed_g_t_41[] = { 100,  101}; //   2
  psi_needed_g_t[no_ps][41] = get_vector_from_array_int(needed_g_t_41, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_49__12_64");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_49__12_64");
  int needed_g_t_42[] = { 102,  103}; //   2
  psi_needed_g_t[no_ps][42] = get_vector_from_array_int(needed_g_t_42, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_81__12_32");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_81__12_32");
  int needed_g_t_43[] = { 104,  105}; //   2
  psi_needed_g_t[no_ps][43] = get_vector_from_array_int(needed_g_t_43, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__48_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__48_76");
  int needed_g_t_44[] = { 106,  107}; //   2
  psi_needed_g_t[no_ps][44] = get_vector_from_array_int(needed_g_t_44, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__80_44");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__80_44");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(15);
  psi_needed_g_d[no_ps].resize(15);
  int needed_g_d_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   12,   13,   14,   15,   24,   25,   26,   27,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   52,   53,   54,   55,   60,   61,   62,   63,   64,   65,   66,   67,   72,   73,   74,   75,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,  108,  109,  110,  111}; //  80
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 80);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_1[] = {   8,    9,   10,   11,   20,   21,   22,   23,   48,   49,   50,   51,   68,   69,   70,   71}; //  16
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 16);
  psi_container_IS_name.push_back("costheta_of_decay_28__4_24");
  psi_container_IS_name.push_back("phi_of_decay_28__4_24");
  int needed_g_d_2[] = {   8,    9,   10,   11,   20,   21,   22,   23,   48,   49,   50,   51,   68,   69,   70,   71}; //  16
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 16);
  psi_container_IS_name.push_back("costheta_of_decay_24__8_16");
  psi_container_IS_name.push_back("phi_of_decay_24__8_16");
  int needed_g_d_3[] = {  12,   13,   24,   25,   40,   41,   44,   45,   54,   55,   72,   73,   92,   93,  104,  105}; //  16
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 16);
  psi_container_IS_name.push_back("costheta_of_decay_76__64_12");
  psi_container_IS_name.push_back("phi_of_decay_76__64_12");
  int needed_g_d_4[] = {  14,   15,   26,   27,   42,   43,   46,   47,   52,   53,   74,   75,   94,   95,  106,  107}; //  16
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 16);
  psi_container_IS_name.push_back("costheta_of_decay_44__32_12");
  psi_container_IS_name.push_back("phi_of_decay_44__32_12");
  int needed_g_d_5[] = {  16,   17,   18,   19,   28,   29,   30,   31,   56,   57,   58,   59,   76,   77,   78,   79}; //  16
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 16);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_6[] = {  16,   17,   18,   19,   28,   29,   30,   31,   56,   57,   58,   59,   76,   77,   78,   79}; //  16
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 16);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_7[] = {  20,   21,   28,   29,   48,   49,   56,   57}; //   8
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 8);
  psi_container_IS_name.push_back("costheta_of_decay_92__64_28");
  psi_container_IS_name.push_back("phi_of_decay_92__64_28");
  int needed_g_d_8[] = {  22,   23,   30,   31,   50,   51,   58,   59}; //   8
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 8);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_9[] = {  24,   25,   54,   55}; //   4
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 4);
  psi_container_IS_name.push_back("costheta_of_decay_92__16_76");
  psi_container_IS_name.push_back("phi_of_decay_92__16_76");
  int needed_g_d_10[] = {  26,   27,   52,   53}; //   4
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_11[] = {  32,   33,   60,   61}; //   4
  psi_needed_g_d[no_ps][11] = get_vector_from_array_int(needed_g_d_11, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__12_48");
  psi_container_IS_name.push_back("phi_of_decay_60__12_48");
  int needed_g_d_12[] = {  32,   33,   60,   61,   88,   89,   92,   93,   96,   97,  100,  101,  104,  105,  108,  109}; //  16
  psi_needed_g_d[no_ps][12] = get_vector_from_array_int(needed_g_d_12, 16);
  psi_container_IS_name.push_back("costheta_of_decay_48__16_32");
  psi_container_IS_name.push_back("phi_of_decay_48__16_32");
  int needed_g_d_13[] = {  34,   35,   62,   63}; //   4
  psi_needed_g_d[no_ps][13] = get_vector_from_array_int(needed_g_d_13, 4);
  psi_container_IS_name.push_back("costheta_of_decay_92__12_80");
  psi_container_IS_name.push_back("phi_of_decay_92__12_80");
  int needed_g_d_14[] = {  34,   35,   62,   63,   90,   91,   94,   95,   98,   99,  102,  103,  106,  107,  110,  111}; //  16
  psi_needed_g_d[no_ps][14] = get_vector_from_array_int(needed_g_d_14, 16);
  psi_container_IS_name.push_back("costheta_of_decay_80__16_64");
  psi_container_IS_name.push_back("phi_of_decay_80__16_64");

  psi_c_p[no_ps].resize(112);
  psi_c_f[no_ps].resize(112);
  psi_c_t[no_ps].resize(112);
  psi_c_d[no_ps].resize(112);

  int c_p_0[] = {  0}; //   1
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 1);
  int c_f_0[] = {  0,   1}; //   2
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 2);
  int c_t_0[] = {  0,   1,   2}; //   3
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 3);
  int c_d_0[] = {  0}; //   1
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 1);

  int c_p_1[] = {  1}; //   1
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 1);
  int c_f_1[] = {  0,   1}; //   2
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 2);
  int c_t_1[] = {  0,   1,   2}; //   3
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 3);
  int c_d_1[] = {  0}; //   1
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 1);

  int c_p_2[] = {  0}; //   1
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 1);
  int c_f_2[] = {  2,   3}; //   2
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 2);
  int c_t_2[] = {  3,   4,   5}; //   3
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 3);
  int c_d_2[] = {  0}; //   1
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 1);

  int c_p_3[] = {  1}; //   1
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 1);
  int c_f_3[] = {  2,   3}; //   2
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 2);
  int c_t_3[] = {  3,   4,   5}; //   3
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 3);
  int c_d_3[] = {  0}; //   1
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 1);

  int c_p_4[] = {  0}; //   1
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 1);
  int c_f_4[] = {  4,   5}; //   2
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 2);
  int c_t_4[] = {  6,   7,   8}; //   3
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 3);
  int c_d_4[] = {  0}; //   1
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 1);

  int c_p_5[] = {  1}; //   1
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 1);
  int c_f_5[] = {  4,   5}; //   2
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 2);
  int c_t_5[] = {  6,   7,   8}; //   3
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 3);
  int c_d_5[] = {  0}; //   1
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 1);

  int c_p_6[] = {  0}; //   1
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 1);
  int c_f_6[] = {  4,   5}; //   2
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 2);
  int c_t_6[] = {  6,   7,   9}; //   3
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 3);
  int c_d_6[] = {  0}; //   1
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 1);

  int c_p_7[] = {  1}; //   1
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 1);
  int c_f_7[] = {  4,   5}; //   2
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 2);
  int c_t_7[] = {  6,   7,   9}; //   3
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 3);
  int c_d_7[] = {  0}; //   1
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 1);

  int c_p_8[] = {  2,   3}; //   2
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 2);
  int c_f_8[] = {  6}; //   1
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 1);
  int c_t_8[] = {  0,  10}; //   2
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 2);
  int c_d_8[] = {  1,   2}; //   2
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 2);

  int c_p_9[] = {  2,   4}; //   2
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 2);
  int c_f_9[] = {  6}; //   1
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 1);
  int c_t_9[] = {  0,  10}; //   2
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 2);
  int c_d_9[] = {  1,   2}; //   2
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 2);

  int c_p_10[] = {  2,   3}; //   2
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 2);
  int c_f_10[] = {  7}; //   1
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 1);
  int c_t_10[] = {  3,  11}; //   2
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 2);
  int c_d_10[] = {  1,   2}; //   2
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 2);

  int c_p_11[] = {  2,   4}; //   2
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 2);
  int c_f_11[] = {  7}; //   1
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 1);
  int c_t_11[] = {  3,  11}; //   2
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 2);
  int c_d_11[] = {  1,   2}; //   2
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 2);

  int c_p_12[] = {  0,   5}; //   2
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 2);
  int c_f_12[] = {  8}; //   1
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 1);
  int c_t_12[] = {  6,  12}; //   2
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 2);
  int c_d_12[] = {  3,   0}; //   2
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 2);

  int c_p_13[] = {  1,   5}; //   2
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 2);
  int c_f_13[] = {  8}; //   1
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 1);
  int c_t_13[] = {  6,  12}; //   2
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 2);
  int c_d_13[] = {  3,   0}; //   2
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 2);

  int c_p_14[] = {  0,   6}; //   2
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 2);
  int c_f_14[] = {  9}; //   1
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 1);
  int c_t_14[] = {  6,  13}; //   2
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 2);
  int c_d_14[] = {  4,   0}; //   2
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 2);

  int c_p_15[] = {  1,   6}; //   2
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 2);
  int c_f_15[] = {  9}; //   1
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 1);
  int c_t_15[] = {  6,  13}; //   2
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 2);
  int c_d_15[] = {  4,   0}; //   2
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 2);

  int c_p_16[] = {  7,   8}; //   2
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 2);
  int c_f_16[] = {  6}; //   1
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 1);
  int c_t_16[] = {  0,  10}; //   2
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 2);
  int c_d_16[] = {  5,   6}; //   2
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 2);

  int c_p_17[] = {  7,   9}; //   2
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 2);
  int c_f_17[] = {  6}; //   1
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 1);
  int c_t_17[] = {  0,  10}; //   2
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 2);
  int c_d_17[] = {  5,   6}; //   2
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 2);

  int c_p_18[] = {  7,   8}; //   2
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 2);
  int c_f_18[] = {  7}; //   1
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 1);
  int c_t_18[] = {  3,  11}; //   2
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 2);
  int c_d_18[] = {  5,   6}; //   2
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 2);

  int c_p_19[] = {  7,   9}; //   2
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 2);
  int c_f_19[] = {  7}; //   1
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 1);
  int c_t_19[] = {  3,  11}; //   2
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 2);
  int c_d_19[] = {  5,   6}; //   2
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 2);

  int c_p_20[] = {  2,   3,  10}; //   3
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 3);
  int c_f_20[] = {}; //   0
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 0);
  int c_t_20[] = {  3}; //   1
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 1);
  int c_d_20[] = {  7,   1,   2}; //   3
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 3);

  int c_p_21[] = {  2,   4,  10}; //   3
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 3);
  int c_f_21[] = {}; //   0
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 0);
  int c_t_21[] = {  3}; //   1
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 1);
  int c_d_21[] = {  7,   1,   2}; //   3
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 3);

  int c_p_22[] = {  2,   3,  11}; //   3
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 3);
  int c_f_22[] = {}; //   0
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 0);
  int c_t_22[] = {  0}; //   1
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 1);
  int c_d_22[] = {  8,   1,   2}; //   3
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 3);

  int c_p_23[] = {  2,   4,  11}; //   3
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 3);
  int c_f_23[] = {}; //   0
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 0);
  int c_t_23[] = {  0}; //   1
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 1);
  int c_d_23[] = {  8,   1,   2}; //   3
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 3);

  int c_p_24[] = {  0,   5,  12}; //   3
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 3);
  int c_f_24[] = {}; //   0
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 0);
  int c_t_24[] = {  3}; //   1
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 1);
  int c_d_24[] = {  9,   3,   0}; //   3
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 3);

  int c_p_25[] = {  1,   5,  12}; //   3
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 3);
  int c_f_25[] = {}; //   0
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 0);
  int c_t_25[] = {  3}; //   1
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 1);
  int c_d_25[] = {  9,   3,   0}; //   3
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 3);

  int c_p_26[] = {  0,   6,  13}; //   3
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 3);
  int c_f_26[] = {}; //   0
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 0);
  int c_t_26[] = {  0}; //   1
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 1);
  int c_d_26[] = { 10,   4,   0}; //   3
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 3);

  int c_p_27[] = {  1,   6,  13}; //   3
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 3);
  int c_f_27[] = {}; //   0
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 0);
  int c_t_27[] = {  0}; //   1
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 1);
  int c_d_27[] = { 10,   4,   0}; //   3
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 3);

  int c_p_28[] = {  7,   8,  10}; //   3
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 3);
  int c_f_28[] = {}; //   0
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 0);
  int c_t_28[] = {  3}; //   1
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 1);
  int c_d_28[] = {  7,   5,   6}; //   3
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 3);

  int c_p_29[] = {  7,   9,  10}; //   3
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 3);
  int c_f_29[] = {}; //   0
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 0);
  int c_t_29[] = {  3}; //   1
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 1);
  int c_d_29[] = {  7,   5,   6}; //   3
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 3);

  int c_p_30[] = {  7,   8,  11}; //   3
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 3);
  int c_f_30[] = {}; //   0
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 0);
  int c_t_30[] = {  0}; //   1
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 1);
  int c_d_30[] = {  8,   5,   6}; //   3
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 3);

  int c_p_31[] = {  7,   9,  11}; //   3
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 3);
  int c_f_31[] = {}; //   0
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 0);
  int c_t_31[] = {  0}; //   1
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 1);
  int c_d_31[] = {  8,   5,   6}; //   3
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 3);

  int c_p_32[] = { 14,  15,  16}; //   3
  psi_c_p[no_ps][32] = get_vector_from_array_int(c_p_32, 3);
  int c_f_32[] = {}; //   0
  psi_c_f[no_ps][32] = get_vector_from_array_int(c_f_32, 0);
  int c_t_32[] = {  0}; //   1
  psi_c_t[no_ps][32] = get_vector_from_array_int(c_t_32, 1);
  int c_d_32[] = { 11,   0,  12}; //   3
  psi_c_d[no_ps][32] = get_vector_from_array_int(c_d_32, 3);

  int c_p_33[] = { 14,  17,  16}; //   3
  psi_c_p[no_ps][33] = get_vector_from_array_int(c_p_33, 3);
  int c_f_33[] = {}; //   0
  psi_c_f[no_ps][33] = get_vector_from_array_int(c_f_33, 0);
  int c_t_33[] = {  0}; //   1
  psi_c_t[no_ps][33] = get_vector_from_array_int(c_t_33, 1);
  int c_d_33[] = { 11,   0,  12}; //   3
  psi_c_d[no_ps][33] = get_vector_from_array_int(c_d_33, 3);

  int c_p_34[] = { 18,  19,  20}; //   3
  psi_c_p[no_ps][34] = get_vector_from_array_int(c_p_34, 3);
  int c_f_34[] = {}; //   0
  psi_c_f[no_ps][34] = get_vector_from_array_int(c_f_34, 0);
  int c_t_34[] = {  3}; //   1
  psi_c_t[no_ps][34] = get_vector_from_array_int(c_t_34, 1);
  int c_d_34[] = { 13,   0,  14}; //   3
  psi_c_d[no_ps][34] = get_vector_from_array_int(c_d_34, 3);

  int c_p_35[] = { 18,  21,  20}; //   3
  psi_c_p[no_ps][35] = get_vector_from_array_int(c_p_35, 3);
  int c_f_35[] = {}; //   0
  psi_c_f[no_ps][35] = get_vector_from_array_int(c_f_35, 0);
  int c_t_35[] = {  3}; //   1
  psi_c_t[no_ps][35] = get_vector_from_array_int(c_t_35, 1);
  int c_d_35[] = { 13,   0,  14}; //   3
  psi_c_d[no_ps][35] = get_vector_from_array_int(c_d_35, 3);

  int c_p_36[] = {  0}; //   1
  psi_c_p[no_ps][36] = get_vector_from_array_int(c_p_36, 1);
  int c_f_36[] = { 10,   9}; //   2
  psi_c_f[no_ps][36] = get_vector_from_array_int(c_f_36, 2);
  int c_t_36[] = { 14,  15,  16}; //   3
  psi_c_t[no_ps][36] = get_vector_from_array_int(c_t_36, 3);
  int c_d_36[] = {  0}; //   1
  psi_c_d[no_ps][36] = get_vector_from_array_int(c_d_36, 1);

  int c_p_37[] = {  1}; //   1
  psi_c_p[no_ps][37] = get_vector_from_array_int(c_p_37, 1);
  int c_f_37[] = { 10,   9}; //   2
  psi_c_f[no_ps][37] = get_vector_from_array_int(c_f_37, 2);
  int c_t_37[] = { 14,  15,  16}; //   3
  psi_c_t[no_ps][37] = get_vector_from_array_int(c_t_37, 3);
  int c_d_37[] = {  0}; //   1
  psi_c_d[no_ps][37] = get_vector_from_array_int(c_d_37, 1);

  int c_p_38[] = {  0}; //   1
  psi_c_p[no_ps][38] = get_vector_from_array_int(c_p_38, 1);
  int c_f_38[] = { 11,   8}; //   2
  psi_c_f[no_ps][38] = get_vector_from_array_int(c_f_38, 2);
  int c_t_38[] = { 14,  17,  18}; //   3
  psi_c_t[no_ps][38] = get_vector_from_array_int(c_t_38, 3);
  int c_d_38[] = {  0}; //   1
  psi_c_d[no_ps][38] = get_vector_from_array_int(c_d_38, 1);

  int c_p_39[] = {  1}; //   1
  psi_c_p[no_ps][39] = get_vector_from_array_int(c_p_39, 1);
  int c_f_39[] = { 11,   8}; //   2
  psi_c_f[no_ps][39] = get_vector_from_array_int(c_f_39, 2);
  int c_t_39[] = { 14,  17,  18}; //   3
  psi_c_t[no_ps][39] = get_vector_from_array_int(c_t_39, 3);
  int c_d_39[] = {  0}; //   1
  psi_c_d[no_ps][39] = get_vector_from_array_int(c_d_39, 1);

  int c_p_40[] = {  0,   5}; //   2
  psi_c_p[no_ps][40] = get_vector_from_array_int(c_p_40, 2);
  int c_f_40[] = { 12}; //   1
  psi_c_f[no_ps][40] = get_vector_from_array_int(c_f_40, 1);
  int c_t_40[] = { 19,  20}; //   2
  psi_c_t[no_ps][40] = get_vector_from_array_int(c_t_40, 2);
  int c_d_40[] = {  3,   0}; //   2
  psi_c_d[no_ps][40] = get_vector_from_array_int(c_d_40, 2);

  int c_p_41[] = {  1,   5}; //   2
  psi_c_p[no_ps][41] = get_vector_from_array_int(c_p_41, 2);
  int c_f_41[] = { 12}; //   1
  psi_c_f[no_ps][41] = get_vector_from_array_int(c_f_41, 1);
  int c_t_41[] = { 19,  20}; //   2
  psi_c_t[no_ps][41] = get_vector_from_array_int(c_t_41, 2);
  int c_d_41[] = {  3,   0}; //   2
  psi_c_d[no_ps][41] = get_vector_from_array_int(c_d_41, 2);

  int c_p_42[] = {  0,   6}; //   2
  psi_c_p[no_ps][42] = get_vector_from_array_int(c_p_42, 2);
  int c_f_42[] = { 13}; //   1
  psi_c_f[no_ps][42] = get_vector_from_array_int(c_f_42, 1);
  int c_t_42[] = { 21,  22}; //   2
  psi_c_t[no_ps][42] = get_vector_from_array_int(c_t_42, 2);
  int c_d_42[] = {  4,   0}; //   2
  psi_c_d[no_ps][42] = get_vector_from_array_int(c_d_42, 2);

  int c_p_43[] = {  1,   6}; //   2
  psi_c_p[no_ps][43] = get_vector_from_array_int(c_p_43, 2);
  int c_f_43[] = { 13}; //   1
  psi_c_f[no_ps][43] = get_vector_from_array_int(c_f_43, 1);
  int c_t_43[] = { 21,  22}; //   2
  psi_c_t[no_ps][43] = get_vector_from_array_int(c_t_43, 2);
  int c_d_43[] = {  4,   0}; //   2
  psi_c_d[no_ps][43] = get_vector_from_array_int(c_d_43, 2);

  int c_p_44[] = {  0,   5}; //   2
  psi_c_p[no_ps][44] = get_vector_from_array_int(c_p_44, 2);
  int c_f_44[] = {  8}; //   1
  psi_c_f[no_ps][44] = get_vector_from_array_int(c_f_44, 1);
  int c_t_44[] = { 14,  17}; //   2
  psi_c_t[no_ps][44] = get_vector_from_array_int(c_t_44, 2);
  int c_d_44[] = {  3,   0}; //   2
  psi_c_d[no_ps][44] = get_vector_from_array_int(c_d_44, 2);

  int c_p_45[] = {  1,   5}; //   2
  psi_c_p[no_ps][45] = get_vector_from_array_int(c_p_45, 2);
  int c_f_45[] = {  8}; //   1
  psi_c_f[no_ps][45] = get_vector_from_array_int(c_f_45, 1);
  int c_t_45[] = { 14,  17}; //   2
  psi_c_t[no_ps][45] = get_vector_from_array_int(c_t_45, 2);
  int c_d_45[] = {  3,   0}; //   2
  psi_c_d[no_ps][45] = get_vector_from_array_int(c_d_45, 2);

  int c_p_46[] = {  0,   6}; //   2
  psi_c_p[no_ps][46] = get_vector_from_array_int(c_p_46, 2);
  int c_f_46[] = {  9}; //   1
  psi_c_f[no_ps][46] = get_vector_from_array_int(c_f_46, 1);
  int c_t_46[] = { 14,  15}; //   2
  psi_c_t[no_ps][46] = get_vector_from_array_int(c_t_46, 2);
  int c_d_46[] = {  4,   0}; //   2
  psi_c_d[no_ps][46] = get_vector_from_array_int(c_d_46, 2);

  int c_p_47[] = {  1,   6}; //   2
  psi_c_p[no_ps][47] = get_vector_from_array_int(c_p_47, 2);
  int c_f_47[] = {  9}; //   1
  psi_c_f[no_ps][47] = get_vector_from_array_int(c_f_47, 1);
  int c_t_47[] = { 14,  15}; //   2
  psi_c_t[no_ps][47] = get_vector_from_array_int(c_t_47, 2);
  int c_d_47[] = {  4,   0}; //   2
  psi_c_d[no_ps][47] = get_vector_from_array_int(c_d_47, 2);

  int c_p_48[] = {  2,   3,  10}; //   3
  psi_c_p[no_ps][48] = get_vector_from_array_int(c_p_48, 3);
  int c_f_48[] = {}; //   0
  psi_c_f[no_ps][48] = get_vector_from_array_int(c_f_48, 0);
  int c_t_48[] = { 19}; //   1
  psi_c_t[no_ps][48] = get_vector_from_array_int(c_t_48, 1);
  int c_d_48[] = {  7,   1,   2}; //   3
  psi_c_d[no_ps][48] = get_vector_from_array_int(c_d_48, 3);

  int c_p_49[] = {  2,   4,  10}; //   3
  psi_c_p[no_ps][49] = get_vector_from_array_int(c_p_49, 3);
  int c_f_49[] = {}; //   0
  psi_c_f[no_ps][49] = get_vector_from_array_int(c_f_49, 0);
  int c_t_49[] = { 19}; //   1
  psi_c_t[no_ps][49] = get_vector_from_array_int(c_t_49, 1);
  int c_d_49[] = {  7,   1,   2}; //   3
  psi_c_d[no_ps][49] = get_vector_from_array_int(c_d_49, 3);

  int c_p_50[] = {  2,   3,  11}; //   3
  psi_c_p[no_ps][50] = get_vector_from_array_int(c_p_50, 3);
  int c_f_50[] = {}; //   0
  psi_c_f[no_ps][50] = get_vector_from_array_int(c_f_50, 0);
  int c_t_50[] = { 21}; //   1
  psi_c_t[no_ps][50] = get_vector_from_array_int(c_t_50, 1);
  int c_d_50[] = {  8,   1,   2}; //   3
  psi_c_d[no_ps][50] = get_vector_from_array_int(c_d_50, 3);

  int c_p_51[] = {  2,   4,  11}; //   3
  psi_c_p[no_ps][51] = get_vector_from_array_int(c_p_51, 3);
  int c_f_51[] = {}; //   0
  psi_c_f[no_ps][51] = get_vector_from_array_int(c_f_51, 0);
  int c_t_51[] = { 21}; //   1
  psi_c_t[no_ps][51] = get_vector_from_array_int(c_t_51, 1);
  int c_d_51[] = {  8,   1,   2}; //   3
  psi_c_d[no_ps][51] = get_vector_from_array_int(c_d_51, 3);

  int c_p_52[] = {  0,   6,  13}; //   3
  psi_c_p[no_ps][52] = get_vector_from_array_int(c_p_52, 3);
  int c_f_52[] = {}; //   0
  psi_c_f[no_ps][52] = get_vector_from_array_int(c_f_52, 0);
  int c_t_52[] = { 21}; //   1
  psi_c_t[no_ps][52] = get_vector_from_array_int(c_t_52, 1);
  int c_d_52[] = { 10,   4,   0}; //   3
  psi_c_d[no_ps][52] = get_vector_from_array_int(c_d_52, 3);

  int c_p_53[] = {  1,   6,  13}; //   3
  psi_c_p[no_ps][53] = get_vector_from_array_int(c_p_53, 3);
  int c_f_53[] = {}; //   0
  psi_c_f[no_ps][53] = get_vector_from_array_int(c_f_53, 0);
  int c_t_53[] = { 21}; //   1
  psi_c_t[no_ps][53] = get_vector_from_array_int(c_t_53, 1);
  int c_d_53[] = { 10,   4,   0}; //   3
  psi_c_d[no_ps][53] = get_vector_from_array_int(c_d_53, 3);

  int c_p_54[] = {  0,   5,  12}; //   3
  psi_c_p[no_ps][54] = get_vector_from_array_int(c_p_54, 3);
  int c_f_54[] = {}; //   0
  psi_c_f[no_ps][54] = get_vector_from_array_int(c_f_54, 0);
  int c_t_54[] = { 19}; //   1
  psi_c_t[no_ps][54] = get_vector_from_array_int(c_t_54, 1);
  int c_d_54[] = {  9,   3,   0}; //   3
  psi_c_d[no_ps][54] = get_vector_from_array_int(c_d_54, 3);

  int c_p_55[] = {  1,   5,  12}; //   3
  psi_c_p[no_ps][55] = get_vector_from_array_int(c_p_55, 3);
  int c_f_55[] = {}; //   0
  psi_c_f[no_ps][55] = get_vector_from_array_int(c_f_55, 0);
  int c_t_55[] = { 19}; //   1
  psi_c_t[no_ps][55] = get_vector_from_array_int(c_t_55, 1);
  int c_d_55[] = {  9,   3,   0}; //   3
  psi_c_d[no_ps][55] = get_vector_from_array_int(c_d_55, 3);

  int c_p_56[] = {  7,   8,  10}; //   3
  psi_c_p[no_ps][56] = get_vector_from_array_int(c_p_56, 3);
  int c_f_56[] = {}; //   0
  psi_c_f[no_ps][56] = get_vector_from_array_int(c_f_56, 0);
  int c_t_56[] = { 19}; //   1
  psi_c_t[no_ps][56] = get_vector_from_array_int(c_t_56, 1);
  int c_d_56[] = {  7,   5,   6}; //   3
  psi_c_d[no_ps][56] = get_vector_from_array_int(c_d_56, 3);

  int c_p_57[] = {  7,   9,  10}; //   3
  psi_c_p[no_ps][57] = get_vector_from_array_int(c_p_57, 3);
  int c_f_57[] = {}; //   0
  psi_c_f[no_ps][57] = get_vector_from_array_int(c_f_57, 0);
  int c_t_57[] = { 19}; //   1
  psi_c_t[no_ps][57] = get_vector_from_array_int(c_t_57, 1);
  int c_d_57[] = {  7,   5,   6}; //   3
  psi_c_d[no_ps][57] = get_vector_from_array_int(c_d_57, 3);

  int c_p_58[] = {  7,   8,  11}; //   3
  psi_c_p[no_ps][58] = get_vector_from_array_int(c_p_58, 3);
  int c_f_58[] = {}; //   0
  psi_c_f[no_ps][58] = get_vector_from_array_int(c_f_58, 0);
  int c_t_58[] = { 21}; //   1
  psi_c_t[no_ps][58] = get_vector_from_array_int(c_t_58, 1);
  int c_d_58[] = {  8,   5,   6}; //   3
  psi_c_d[no_ps][58] = get_vector_from_array_int(c_d_58, 3);

  int c_p_59[] = {  7,   9,  11}; //   3
  psi_c_p[no_ps][59] = get_vector_from_array_int(c_p_59, 3);
  int c_f_59[] = {}; //   0
  psi_c_f[no_ps][59] = get_vector_from_array_int(c_f_59, 0);
  int c_t_59[] = { 21}; //   1
  psi_c_t[no_ps][59] = get_vector_from_array_int(c_t_59, 1);
  int c_d_59[] = {  8,   5,   6}; //   3
  psi_c_d[no_ps][59] = get_vector_from_array_int(c_d_59, 3);

  int c_p_60[] = { 14,  15,  16}; //   3
  psi_c_p[no_ps][60] = get_vector_from_array_int(c_p_60, 3);
  int c_f_60[] = {}; //   0
  psi_c_f[no_ps][60] = get_vector_from_array_int(c_f_60, 0);
  int c_t_60[] = { 21}; //   1
  psi_c_t[no_ps][60] = get_vector_from_array_int(c_t_60, 1);
  int c_d_60[] = { 11,   0,  12}; //   3
  psi_c_d[no_ps][60] = get_vector_from_array_int(c_d_60, 3);

  int c_p_61[] = { 14,  17,  16}; //   3
  psi_c_p[no_ps][61] = get_vector_from_array_int(c_p_61, 3);
  int c_f_61[] = {}; //   0
  psi_c_f[no_ps][61] = get_vector_from_array_int(c_f_61, 0);
  int c_t_61[] = { 21}; //   1
  psi_c_t[no_ps][61] = get_vector_from_array_int(c_t_61, 1);
  int c_d_61[] = { 11,   0,  12}; //   3
  psi_c_d[no_ps][61] = get_vector_from_array_int(c_d_61, 3);

  int c_p_62[] = { 18,  19,  20}; //   3
  psi_c_p[no_ps][62] = get_vector_from_array_int(c_p_62, 3);
  int c_f_62[] = {}; //   0
  psi_c_f[no_ps][62] = get_vector_from_array_int(c_f_62, 0);
  int c_t_62[] = { 19}; //   1
  psi_c_t[no_ps][62] = get_vector_from_array_int(c_t_62, 1);
  int c_d_62[] = { 13,   0,  14}; //   3
  psi_c_d[no_ps][62] = get_vector_from_array_int(c_d_62, 3);

  int c_p_63[] = { 18,  21,  20}; //   3
  psi_c_p[no_ps][63] = get_vector_from_array_int(c_p_63, 3);
  int c_f_63[] = {}; //   0
  psi_c_f[no_ps][63] = get_vector_from_array_int(c_f_63, 0);
  int c_t_63[] = { 19}; //   1
  psi_c_t[no_ps][63] = get_vector_from_array_int(c_t_63, 1);
  int c_d_63[] = { 13,   0,  14}; //   3
  psi_c_d[no_ps][63] = get_vector_from_array_int(c_d_63, 3);

  int c_p_64[] = {  0}; //   1
  psi_c_p[no_ps][64] = get_vector_from_array_int(c_p_64, 1);
  int c_f_64[] = { 11,  12}; //   2
  psi_c_f[no_ps][64] = get_vector_from_array_int(c_f_64, 2);
  int c_t_64[] = { 19,  20,  23}; //   3
  psi_c_t[no_ps][64] = get_vector_from_array_int(c_t_64, 3);
  int c_d_64[] = {  0}; //   1
  psi_c_d[no_ps][64] = get_vector_from_array_int(c_d_64, 1);

  int c_p_65[] = {  1}; //   1
  psi_c_p[no_ps][65] = get_vector_from_array_int(c_p_65, 1);
  int c_f_65[] = { 11,  12}; //   2
  psi_c_f[no_ps][65] = get_vector_from_array_int(c_f_65, 2);
  int c_t_65[] = { 19,  20,  23}; //   3
  psi_c_t[no_ps][65] = get_vector_from_array_int(c_t_65, 3);
  int c_d_65[] = {  0}; //   1
  psi_c_d[no_ps][65] = get_vector_from_array_int(c_d_65, 1);

  int c_p_66[] = {  0}; //   1
  psi_c_p[no_ps][66] = get_vector_from_array_int(c_p_66, 1);
  int c_f_66[] = { 10,  13}; //   2
  psi_c_f[no_ps][66] = get_vector_from_array_int(c_f_66, 2);
  int c_t_66[] = { 21,  22,  24}; //   3
  psi_c_t[no_ps][66] = get_vector_from_array_int(c_t_66, 3);
  int c_d_66[] = {  0}; //   1
  psi_c_d[no_ps][66] = get_vector_from_array_int(c_d_66, 1);

  int c_p_67[] = {  1}; //   1
  psi_c_p[no_ps][67] = get_vector_from_array_int(c_p_67, 1);
  int c_f_67[] = { 10,  13}; //   2
  psi_c_f[no_ps][67] = get_vector_from_array_int(c_f_67, 2);
  int c_t_67[] = { 21,  22,  24}; //   3
  psi_c_t[no_ps][67] = get_vector_from_array_int(c_t_67, 3);
  int c_d_67[] = {  0}; //   1
  psi_c_d[no_ps][67] = get_vector_from_array_int(c_d_67, 1);

  int c_p_68[] = {  2,   3}; //   2
  psi_c_p[no_ps][68] = get_vector_from_array_int(c_p_68, 2);
  int c_f_68[] = {  7}; //   1
  psi_c_f[no_ps][68] = get_vector_from_array_int(c_f_68, 1);
  int c_t_68[] = { 19,  25}; //   2
  psi_c_t[no_ps][68] = get_vector_from_array_int(c_t_68, 2);
  int c_d_68[] = {  1,   2}; //   2
  psi_c_d[no_ps][68] = get_vector_from_array_int(c_d_68, 2);

  int c_p_69[] = {  2,   4}; //   2
  psi_c_p[no_ps][69] = get_vector_from_array_int(c_p_69, 2);
  int c_f_69[] = {  7}; //   1
  psi_c_f[no_ps][69] = get_vector_from_array_int(c_f_69, 1);
  int c_t_69[] = { 19,  25}; //   2
  psi_c_t[no_ps][69] = get_vector_from_array_int(c_t_69, 2);
  int c_d_69[] = {  1,   2}; //   2
  psi_c_d[no_ps][69] = get_vector_from_array_int(c_d_69, 2);

  int c_p_70[] = {  2,   3}; //   2
  psi_c_p[no_ps][70] = get_vector_from_array_int(c_p_70, 2);
  int c_f_70[] = {  6}; //   1
  psi_c_f[no_ps][70] = get_vector_from_array_int(c_f_70, 1);
  int c_t_70[] = { 21,  26}; //   2
  psi_c_t[no_ps][70] = get_vector_from_array_int(c_t_70, 2);
  int c_d_70[] = {  1,   2}; //   2
  psi_c_d[no_ps][70] = get_vector_from_array_int(c_d_70, 2);

  int c_p_71[] = {  2,   4}; //   2
  psi_c_p[no_ps][71] = get_vector_from_array_int(c_p_71, 2);
  int c_f_71[] = {  6}; //   1
  psi_c_f[no_ps][71] = get_vector_from_array_int(c_f_71, 1);
  int c_t_71[] = { 21,  26}; //   2
  psi_c_t[no_ps][71] = get_vector_from_array_int(c_t_71, 2);
  int c_d_71[] = {  1,   2}; //   2
  psi_c_d[no_ps][71] = get_vector_from_array_int(c_d_71, 2);

  int c_p_72[] = {  0,   5}; //   2
  psi_c_p[no_ps][72] = get_vector_from_array_int(c_p_72, 2);
  int c_f_72[] = {  8}; //   1
  psi_c_f[no_ps][72] = get_vector_from_array_int(c_f_72, 1);
  int c_t_72[] = { 14,  27}; //   2
  psi_c_t[no_ps][72] = get_vector_from_array_int(c_t_72, 2);
  int c_d_72[] = {  3,   0}; //   2
  psi_c_d[no_ps][72] = get_vector_from_array_int(c_d_72, 2);

  int c_p_73[] = {  1,   5}; //   2
  psi_c_p[no_ps][73] = get_vector_from_array_int(c_p_73, 2);
  int c_f_73[] = {  8}; //   1
  psi_c_f[no_ps][73] = get_vector_from_array_int(c_f_73, 1);
  int c_t_73[] = { 14,  27}; //   2
  psi_c_t[no_ps][73] = get_vector_from_array_int(c_t_73, 2);
  int c_d_73[] = {  3,   0}; //   2
  psi_c_d[no_ps][73] = get_vector_from_array_int(c_d_73, 2);

  int c_p_74[] = {  0,   6}; //   2
  psi_c_p[no_ps][74] = get_vector_from_array_int(c_p_74, 2);
  int c_f_74[] = {  9}; //   1
  psi_c_f[no_ps][74] = get_vector_from_array_int(c_f_74, 1);
  int c_t_74[] = { 14,  28}; //   2
  psi_c_t[no_ps][74] = get_vector_from_array_int(c_t_74, 2);
  int c_d_74[] = {  4,   0}; //   2
  psi_c_d[no_ps][74] = get_vector_from_array_int(c_d_74, 2);

  int c_p_75[] = {  1,   6}; //   2
  psi_c_p[no_ps][75] = get_vector_from_array_int(c_p_75, 2);
  int c_f_75[] = {  9}; //   1
  psi_c_f[no_ps][75] = get_vector_from_array_int(c_f_75, 1);
  int c_t_75[] = { 14,  28}; //   2
  psi_c_t[no_ps][75] = get_vector_from_array_int(c_t_75, 2);
  int c_d_75[] = {  4,   0}; //   2
  psi_c_d[no_ps][75] = get_vector_from_array_int(c_d_75, 2);

  int c_p_76[] = {  7,   8}; //   2
  psi_c_p[no_ps][76] = get_vector_from_array_int(c_p_76, 2);
  int c_f_76[] = {  7}; //   1
  psi_c_f[no_ps][76] = get_vector_from_array_int(c_f_76, 1);
  int c_t_76[] = { 19,  25}; //   2
  psi_c_t[no_ps][76] = get_vector_from_array_int(c_t_76, 2);
  int c_d_76[] = {  5,   6}; //   2
  psi_c_d[no_ps][76] = get_vector_from_array_int(c_d_76, 2);

  int c_p_77[] = {  7,   9}; //   2
  psi_c_p[no_ps][77] = get_vector_from_array_int(c_p_77, 2);
  int c_f_77[] = {  7}; //   1
  psi_c_f[no_ps][77] = get_vector_from_array_int(c_f_77, 1);
  int c_t_77[] = { 19,  25}; //   2
  psi_c_t[no_ps][77] = get_vector_from_array_int(c_t_77, 2);
  int c_d_77[] = {  5,   6}; //   2
  psi_c_d[no_ps][77] = get_vector_from_array_int(c_d_77, 2);

  int c_p_78[] = {  7,   8}; //   2
  psi_c_p[no_ps][78] = get_vector_from_array_int(c_p_78, 2);
  int c_f_78[] = {  6}; //   1
  psi_c_f[no_ps][78] = get_vector_from_array_int(c_f_78, 1);
  int c_t_78[] = { 21,  26}; //   2
  psi_c_t[no_ps][78] = get_vector_from_array_int(c_t_78, 2);
  int c_d_78[] = {  5,   6}; //   2
  psi_c_d[no_ps][78] = get_vector_from_array_int(c_d_78, 2);

  int c_p_79[] = {  7,   9}; //   2
  psi_c_p[no_ps][79] = get_vector_from_array_int(c_p_79, 2);
  int c_f_79[] = {  6}; //   1
  psi_c_f[no_ps][79] = get_vector_from_array_int(c_f_79, 1);
  int c_t_79[] = { 21,  26}; //   2
  psi_c_t[no_ps][79] = get_vector_from_array_int(c_t_79, 2);
  int c_d_79[] = {  5,   6}; //   2
  psi_c_d[no_ps][79] = get_vector_from_array_int(c_d_79, 2);

  int c_p_80[] = {  0}; //   1
  psi_c_p[no_ps][80] = get_vector_from_array_int(c_p_80, 1);
  int c_f_80[] = {  4,   5}; //   2
  psi_c_f[no_ps][80] = get_vector_from_array_int(c_f_80, 2);
  int c_t_80[] = { 14,  29,  30}; //   3
  psi_c_t[no_ps][80] = get_vector_from_array_int(c_t_80, 3);
  int c_d_80[] = {  0}; //   1
  psi_c_d[no_ps][80] = get_vector_from_array_int(c_d_80, 1);

  int c_p_81[] = {  1}; //   1
  psi_c_p[no_ps][81] = get_vector_from_array_int(c_p_81, 1);
  int c_f_81[] = {  4,   5}; //   2
  psi_c_f[no_ps][81] = get_vector_from_array_int(c_f_81, 2);
  int c_t_81[] = { 14,  29,  30}; //   3
  psi_c_t[no_ps][81] = get_vector_from_array_int(c_t_81, 3);
  int c_d_81[] = {  0}; //   1
  psi_c_d[no_ps][81] = get_vector_from_array_int(c_d_81, 1);

  int c_p_82[] = {  0}; //   1
  psi_c_p[no_ps][82] = get_vector_from_array_int(c_p_82, 1);
  int c_f_82[] = {  4,   5}; //   2
  psi_c_f[no_ps][82] = get_vector_from_array_int(c_f_82, 2);
  int c_t_82[] = { 14,  29,  31}; //   3
  psi_c_t[no_ps][82] = get_vector_from_array_int(c_t_82, 3);
  int c_d_82[] = {  0}; //   1
  psi_c_d[no_ps][82] = get_vector_from_array_int(c_d_82, 1);

  int c_p_83[] = {  1}; //   1
  psi_c_p[no_ps][83] = get_vector_from_array_int(c_p_83, 1);
  int c_f_83[] = {  4,   5}; //   2
  psi_c_f[no_ps][83] = get_vector_from_array_int(c_f_83, 2);
  int c_t_83[] = { 14,  29,  31}; //   3
  psi_c_t[no_ps][83] = get_vector_from_array_int(c_t_83, 3);
  int c_d_83[] = {  0}; //   1
  psi_c_d[no_ps][83] = get_vector_from_array_int(c_d_83, 1);

  int c_p_84[] = {  0}; //   1
  psi_c_p[no_ps][84] = get_vector_from_array_int(c_p_84, 1);
  int c_f_84[] = {  2,   3}; //   2
  psi_c_f[no_ps][84] = get_vector_from_array_int(c_f_84, 2);
  int c_t_84[] = { 19,  32,  33}; //   3
  psi_c_t[no_ps][84] = get_vector_from_array_int(c_t_84, 3);
  int c_d_84[] = {  0}; //   1
  psi_c_d[no_ps][84] = get_vector_from_array_int(c_d_84, 1);

  int c_p_85[] = {  1}; //   1
  psi_c_p[no_ps][85] = get_vector_from_array_int(c_p_85, 1);
  int c_f_85[] = {  2,   3}; //   2
  psi_c_f[no_ps][85] = get_vector_from_array_int(c_f_85, 2);
  int c_t_85[] = { 19,  32,  33}; //   3
  psi_c_t[no_ps][85] = get_vector_from_array_int(c_t_85, 3);
  int c_d_85[] = {  0}; //   1
  psi_c_d[no_ps][85] = get_vector_from_array_int(c_d_85, 1);

  int c_p_86[] = {  0}; //   1
  psi_c_p[no_ps][86] = get_vector_from_array_int(c_p_86, 1);
  int c_f_86[] = {  0,   1}; //   2
  psi_c_f[no_ps][86] = get_vector_from_array_int(c_f_86, 2);
  int c_t_86[] = { 21,  34,  35}; //   3
  psi_c_t[no_ps][86] = get_vector_from_array_int(c_t_86, 3);
  int c_d_86[] = {  0}; //   1
  psi_c_d[no_ps][86] = get_vector_from_array_int(c_d_86, 1);

  int c_p_87[] = {  1}; //   1
  psi_c_p[no_ps][87] = get_vector_from_array_int(c_p_87, 1);
  int c_f_87[] = {  0,   1}; //   2
  psi_c_f[no_ps][87] = get_vector_from_array_int(c_f_87, 2);
  int c_t_87[] = { 21,  34,  35}; //   3
  psi_c_t[no_ps][87] = get_vector_from_array_int(c_t_87, 3);
  int c_d_87[] = {  0}; //   1
  psi_c_d[no_ps][87] = get_vector_from_array_int(c_d_87, 1);

  int c_p_88[] = { 14,  15}; //   2
  psi_c_p[no_ps][88] = get_vector_from_array_int(c_p_88, 2);
  int c_f_88[] = {  1}; //   1
  psi_c_f[no_ps][88] = get_vector_from_array_int(c_f_88, 1);
  int c_t_88[] = {  0,   1}; //   2
  psi_c_t[no_ps][88] = get_vector_from_array_int(c_t_88, 2);
  int c_d_88[] = {  0,  12}; //   2
  psi_c_d[no_ps][88] = get_vector_from_array_int(c_d_88, 2);

  int c_p_89[] = { 14,  17}; //   2
  psi_c_p[no_ps][89] = get_vector_from_array_int(c_p_89, 2);
  int c_f_89[] = {  1}; //   1
  psi_c_f[no_ps][89] = get_vector_from_array_int(c_f_89, 1);
  int c_t_89[] = {  0,   1}; //   2
  psi_c_t[no_ps][89] = get_vector_from_array_int(c_t_89, 2);
  int c_d_89[] = {  0,  12}; //   2
  psi_c_d[no_ps][89] = get_vector_from_array_int(c_d_89, 2);

  int c_p_90[] = { 18,  19}; //   2
  psi_c_p[no_ps][90] = get_vector_from_array_int(c_p_90, 2);
  int c_f_90[] = {  3}; //   1
  psi_c_f[no_ps][90] = get_vector_from_array_int(c_f_90, 1);
  int c_t_90[] = {  3,   4}; //   2
  psi_c_t[no_ps][90] = get_vector_from_array_int(c_t_90, 2);
  int c_d_90[] = {  0,  14}; //   2
  psi_c_d[no_ps][90] = get_vector_from_array_int(c_d_90, 2);

  int c_p_91[] = { 18,  21}; //   2
  psi_c_p[no_ps][91] = get_vector_from_array_int(c_p_91, 2);
  int c_f_91[] = {  3}; //   1
  psi_c_f[no_ps][91] = get_vector_from_array_int(c_f_91, 1);
  int c_t_91[] = {  3,   4}; //   2
  psi_c_t[no_ps][91] = get_vector_from_array_int(c_t_91, 2);
  int c_d_91[] = {  0,  14}; //   2
  psi_c_d[no_ps][91] = get_vector_from_array_int(c_d_91, 2);

  int c_p_92[] = {  0,   5,  22}; //   3
  psi_c_p[no_ps][92] = get_vector_from_array_int(c_p_92, 3);
  int c_f_92[] = {}; //   0
  psi_c_f[no_ps][92] = get_vector_from_array_int(c_f_92, 0);
  int c_t_92[] = { 36}; //   1
  psi_c_t[no_ps][92] = get_vector_from_array_int(c_t_92, 1);
  int c_d_92[] = { 12,   3,   0}; //   3
  psi_c_d[no_ps][92] = get_vector_from_array_int(c_d_92, 3);

  int c_p_93[] = {  1,   5,  22}; //   3
  psi_c_p[no_ps][93] = get_vector_from_array_int(c_p_93, 3);
  int c_f_93[] = {}; //   0
  psi_c_f[no_ps][93] = get_vector_from_array_int(c_f_93, 0);
  int c_t_93[] = { 36}; //   1
  psi_c_t[no_ps][93] = get_vector_from_array_int(c_t_93, 1);
  int c_d_93[] = { 12,   3,   0}; //   3
  psi_c_d[no_ps][93] = get_vector_from_array_int(c_d_93, 3);

  int c_p_94[] = {  0,   6,  23}; //   3
  psi_c_p[no_ps][94] = get_vector_from_array_int(c_p_94, 3);
  int c_f_94[] = {}; //   0
  psi_c_f[no_ps][94] = get_vector_from_array_int(c_f_94, 0);
  int c_t_94[] = { 37}; //   1
  psi_c_t[no_ps][94] = get_vector_from_array_int(c_t_94, 1);
  int c_d_94[] = { 14,   4,   0}; //   3
  psi_c_d[no_ps][94] = get_vector_from_array_int(c_d_94, 3);

  int c_p_95[] = {  1,   6,  23}; //   3
  psi_c_p[no_ps][95] = get_vector_from_array_int(c_p_95, 3);
  int c_f_95[] = {}; //   0
  psi_c_f[no_ps][95] = get_vector_from_array_int(c_f_95, 0);
  int c_t_95[] = { 37}; //   1
  psi_c_t[no_ps][95] = get_vector_from_array_int(c_t_95, 1);
  int c_d_95[] = { 14,   4,   0}; //   3
  psi_c_d[no_ps][95] = get_vector_from_array_int(c_d_95, 3);

  int c_p_96[] = { 14,  15}; //   2
  psi_c_p[no_ps][96] = get_vector_from_array_int(c_p_96, 2);
  int c_f_96[] = { 14}; //   1
  psi_c_f[no_ps][96] = get_vector_from_array_int(c_f_96, 1);
  int c_t_96[] = { 38,  39}; //   2
  psi_c_t[no_ps][96] = get_vector_from_array_int(c_t_96, 2);
  int c_d_96[] = {  0,  12}; //   2
  psi_c_d[no_ps][96] = get_vector_from_array_int(c_d_96, 2);

  int c_p_97[] = { 14,  17}; //   2
  psi_c_p[no_ps][97] = get_vector_from_array_int(c_p_97, 2);
  int c_f_97[] = { 14}; //   1
  psi_c_f[no_ps][97] = get_vector_from_array_int(c_f_97, 1);
  int c_t_97[] = { 38,  39}; //   2
  psi_c_t[no_ps][97] = get_vector_from_array_int(c_t_97, 2);
  int c_d_97[] = {  0,  12}; //   2
  psi_c_d[no_ps][97] = get_vector_from_array_int(c_d_97, 2);

  int c_p_98[] = { 18,  19}; //   2
  psi_c_p[no_ps][98] = get_vector_from_array_int(c_p_98, 2);
  int c_f_98[] = { 15}; //   1
  psi_c_f[no_ps][98] = get_vector_from_array_int(c_f_98, 1);
  int c_t_98[] = { 38,  40}; //   2
  psi_c_t[no_ps][98] = get_vector_from_array_int(c_t_98, 2);
  int c_d_98[] = {  0,  14}; //   2
  psi_c_d[no_ps][98] = get_vector_from_array_int(c_d_98, 2);

  int c_p_99[] = { 18,  21}; //   2
  psi_c_p[no_ps][99] = get_vector_from_array_int(c_p_99, 2);
  int c_f_99[] = { 15}; //   1
  psi_c_f[no_ps][99] = get_vector_from_array_int(c_f_99, 1);
  int c_t_99[] = { 38,  40}; //   2
  psi_c_t[no_ps][99] = get_vector_from_array_int(c_t_99, 2);
  int c_d_99[] = {  0,  14}; //   2
  psi_c_d[no_ps][99] = get_vector_from_array_int(c_d_99, 2);

  int c_p_100[] = {  0,  24}; //   2
  psi_c_p[no_ps][100] = get_vector_from_array_int(c_p_100, 2);
  int c_f_100[] = { 16}; //   1
  psi_c_f[no_ps][100] = get_vector_from_array_int(c_f_100, 1);
  int c_t_100[] = { 36,  41}; //   2
  psi_c_t[no_ps][100] = get_vector_from_array_int(c_t_100, 2);
  int c_d_100[] = { 12,   0}; //   2
  psi_c_d[no_ps][100] = get_vector_from_array_int(c_d_100, 2);

  int c_p_101[] = {  1,  24}; //   2
  psi_c_p[no_ps][101] = get_vector_from_array_int(c_p_101, 2);
  int c_f_101[] = { 16}; //   1
  psi_c_f[no_ps][101] = get_vector_from_array_int(c_f_101, 1);
  int c_t_101[] = { 36,  41}; //   2
  psi_c_t[no_ps][101] = get_vector_from_array_int(c_t_101, 2);
  int c_d_101[] = { 12,   0}; //   2
  psi_c_d[no_ps][101] = get_vector_from_array_int(c_d_101, 2);

  int c_p_102[] = {  0,  25}; //   2
  psi_c_p[no_ps][102] = get_vector_from_array_int(c_p_102, 2);
  int c_f_102[] = { 17}; //   1
  psi_c_f[no_ps][102] = get_vector_from_array_int(c_f_102, 1);
  int c_t_102[] = { 37,  42}; //   2
  psi_c_t[no_ps][102] = get_vector_from_array_int(c_t_102, 2);
  int c_d_102[] = { 14,   0}; //   2
  psi_c_d[no_ps][102] = get_vector_from_array_int(c_d_102, 2);

  int c_p_103[] = {  1,  25}; //   2
  psi_c_p[no_ps][103] = get_vector_from_array_int(c_p_103, 2);
  int c_f_103[] = { 17}; //   1
  psi_c_f[no_ps][103] = get_vector_from_array_int(c_f_103, 1);
  int c_t_103[] = { 37,  42}; //   2
  psi_c_t[no_ps][103] = get_vector_from_array_int(c_t_103, 2);
  int c_d_103[] = { 14,   0}; //   2
  psi_c_d[no_ps][103] = get_vector_from_array_int(c_d_103, 2);

  int c_p_104[] = { 14,  15,  26}; //   3
  psi_c_p[no_ps][104] = get_vector_from_array_int(c_p_104, 3);
  int c_f_104[] = {}; //   0
  psi_c_f[no_ps][104] = get_vector_from_array_int(c_f_104, 0);
  int c_t_104[] = { 43}; //   1
  psi_c_t[no_ps][104] = get_vector_from_array_int(c_t_104, 1);
  int c_d_104[] = {  3,   0,  12}; //   3
  psi_c_d[no_ps][104] = get_vector_from_array_int(c_d_104, 3);

  int c_p_105[] = { 14,  17,  26}; //   3
  psi_c_p[no_ps][105] = get_vector_from_array_int(c_p_105, 3);
  int c_f_105[] = {}; //   0
  psi_c_f[no_ps][105] = get_vector_from_array_int(c_f_105, 0);
  int c_t_105[] = { 43}; //   1
  psi_c_t[no_ps][105] = get_vector_from_array_int(c_t_105, 1);
  int c_d_105[] = {  3,   0,  12}; //   3
  psi_c_d[no_ps][105] = get_vector_from_array_int(c_d_105, 3);

  int c_p_106[] = { 18,  19,  27}; //   3
  psi_c_p[no_ps][106] = get_vector_from_array_int(c_p_106, 3);
  int c_f_106[] = {}; //   0
  psi_c_f[no_ps][106] = get_vector_from_array_int(c_f_106, 0);
  int c_t_106[] = { 44}; //   1
  psi_c_t[no_ps][106] = get_vector_from_array_int(c_t_106, 1);
  int c_d_106[] = {  4,   0,  14}; //   3
  psi_c_d[no_ps][106] = get_vector_from_array_int(c_d_106, 3);

  int c_p_107[] = { 18,  21,  27}; //   3
  psi_c_p[no_ps][107] = get_vector_from_array_int(c_p_107, 3);
  int c_f_107[] = {}; //   0
  psi_c_f[no_ps][107] = get_vector_from_array_int(c_f_107, 0);
  int c_t_107[] = { 44}; //   1
  psi_c_t[no_ps][107] = get_vector_from_array_int(c_t_107, 1);
  int c_d_107[] = {  4,   0,  14}; //   3
  psi_c_d[no_ps][107] = get_vector_from_array_int(c_d_107, 3);

  int c_p_108[] = {  0,  24}; //   2
  psi_c_p[no_ps][108] = get_vector_from_array_int(c_p_108, 2);
  int c_f_108[] = {  1}; //   1
  psi_c_f[no_ps][108] = get_vector_from_array_int(c_f_108, 1);
  int c_t_108[] = { 21,  34}; //   2
  psi_c_t[no_ps][108] = get_vector_from_array_int(c_t_108, 2);
  int c_d_108[] = { 12,   0}; //   2
  psi_c_d[no_ps][108] = get_vector_from_array_int(c_d_108, 2);

  int c_p_109[] = {  1,  24}; //   2
  psi_c_p[no_ps][109] = get_vector_from_array_int(c_p_109, 2);
  int c_f_109[] = {  1}; //   1
  psi_c_f[no_ps][109] = get_vector_from_array_int(c_f_109, 1);
  int c_t_109[] = { 21,  34}; //   2
  psi_c_t[no_ps][109] = get_vector_from_array_int(c_t_109, 2);
  int c_d_109[] = { 12,   0}; //   2
  psi_c_d[no_ps][109] = get_vector_from_array_int(c_d_109, 2);

  int c_p_110[] = {  0,  25}; //   2
  psi_c_p[no_ps][110] = get_vector_from_array_int(c_p_110, 2);
  int c_f_110[] = {  3}; //   1
  psi_c_f[no_ps][110] = get_vector_from_array_int(c_f_110, 1);
  int c_t_110[] = { 19,  32}; //   2
  psi_c_t[no_ps][110] = get_vector_from_array_int(c_t_110, 2);
  int c_d_110[] = { 14,   0}; //   2
  psi_c_d[no_ps][110] = get_vector_from_array_int(c_d_110, 2);

  int c_p_111[] = {  1,  25}; //   2
  psi_c_p[no_ps][111] = get_vector_from_array_int(c_p_111, 2);
  int c_f_111[] = {  3}; //   1
  psi_c_f[no_ps][111] = get_vector_from_array_int(c_f_111, 1);
  int c_t_111[] = { 19,  32}; //   2
  psi_c_t[no_ps][111] = get_vector_from_array_int(c_t_111, 2);
  int c_d_111[] = { 14,   0}; //   2
  psi_c_d[no_ps][111] = get_vector_from_array_int(c_d_111, 2);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
