#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeexa03/header/ppeexa03.phasespace.h"
void ppeexa03_optimize_minv_real(phasespace_set & psi){
  static Logger logger("ppeexa03_optimize_minv_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.real.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppeexa03_determination_MCchannels_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexa03_determination_MCchannels_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] == 0){n_channel = 32;}
  else if (psi_no_map[no_ps] == 2){n_channel = 20;}
  else if (psi_no_map[no_ps] == 3){n_channel = 20;}
  else if (psi_no_map[no_ps] == 4){n_channel = 20;}
  else if (psi_no_map[no_ps] == 5){n_channel = 20;}
  else if (psi_no_map[no_ps] == 6){n_channel = 20;}
  else if (psi_no_map[no_ps] == 7){n_channel = 20;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeexa03_ac_tau_psp_real(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppeexa03_ac_tau_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] == 2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 7){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeexa03_ax_psp_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexa03_ax_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] == 2){ppeexa03_ax_psp_130_gd_emepad(no_ps, psi);}
  else if (psi_no_map[no_ps] == 3){ppeexa03_ax_psp_130_gu_emepau(no_ps, psi);}
  else if (psi_no_map[no_ps] == 4){ppeexa03_ax_psp_130_gdx_emepadx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 5){ppeexa03_ax_psp_130_gux_emepaux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 6){ppeexa03_ax_psp_130_ddx_emepag(no_ps, psi);}
  else if (psi_no_map[no_ps] == 7){ppeexa03_ax_psp_130_uux_emepag(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
