#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeexnenex04/header/ppeexnenex04.phasespace.h"
void ppeexnenex04_optimize_minv_born(phasespace_set & psi){
  static Logger logger("ppeexnenex04_optimize_minv_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.born.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppeexnenex04_determination_MCchannels_born(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexnenex04_determination_MCchannels_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if (psi_phasespace_order_alpha_s[no_ps] == 0 && psi_phasespace_order_alpha_e[no_ps] == 4 && psi_phasespace_order_interference[no_ps] == 0){
    if      (psi_no_map[no_ps] == 0){n_channel = 27;}
    else if (psi_no_map[no_ps] == 2){n_channel = 19;}
    else if (psi_no_map[no_ps] == 3){n_channel = 19;}
    else if (psi_no_map[no_ps] == 4){n_channel = 21;}
  }
  else if (psi_phasespace_order_alpha_s[no_ps] == 2 && psi_phasespace_order_alpha_e[no_ps] == 4 && psi_phasespace_order_interference[no_ps] == 0){
    if      (psi_no_map[no_ps] == 0){n_channel = 0;}
    else if (psi_no_map[no_ps] == 1){n_channel = 40;}
  }
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeexnenex04_ac_tau_psp_born(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppeexnenex04_ac_tau_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (psi.phasespace_order_alpha_s[no_ps] == 0 && psi.phasespace_order_alpha_e[no_ps] == 4 && psi.phasespace_order_interference[no_ps] == 0){
    if      (psi.no_map[no_ps] == 0){}
    else if (psi.no_map[no_ps] == 2){
      tau_MC_map.push_back(0);
      tau_MC_map.push_back(-23);
    }
    else if (psi.no_map[no_ps] == 3){
      tau_MC_map.push_back(0);
      tau_MC_map.push_back(-23);
    }
    else if (psi.no_map[no_ps] == 4){
      tau_MC_map.push_back(0);
      tau_MC_map.push_back(-23);
      tau_MC_map.push_back(-25);
    }
  }
  else if (psi.phasespace_order_alpha_s[no_ps] == 2 && psi.phasespace_order_alpha_e[no_ps] == 4 && psi.phasespace_order_interference[no_ps] == 0){
    if      (psi.no_map[no_ps] == 0){}
    else if (psi.no_map[no_ps] == 1){
      tau_MC_map.push_back(0);
      tau_MC_map.push_back(-23);
      //  tau_MC_map.push_back(5);
      //  tau_MC_map.push_back(6);
      tau_MC_map.push_back(-25);
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeexnenex04_ax_psp_born(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexnenex04_ax_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_phasespace_order_alpha_s[no_ps] == 0 && psi_phasespace_order_alpha_e[no_ps] == 4 && psi_phasespace_order_interference[no_ps] == 0){
    if (psi_no_map[no_ps] == 0){}
    else if (psi_no_map[no_ps] == 2){ppeexnenex04_ax_psp_040_ddx_emepvevex(no_ps, psi);}
    else if (psi_no_map[no_ps] == 3){ppeexnenex04_ax_psp_040_uux_emepvevex(no_ps, psi);}
    else if (psi_no_map[no_ps] == 4){ppeexnenex04_ax_psp_040_bbx_emepvevex(no_ps, psi);}
  }
  else if (psi_phasespace_order_alpha_s[no_ps] == 2 && psi_phasespace_order_alpha_e[no_ps] == 4 && psi_phasespace_order_interference[no_ps] == 0){
    if (psi_no_map[no_ps] == 0){}
    else if (psi_no_map[no_ps] == 1){ppeexnenex04_ax_psp_240_gg_emepvevex(no_ps, psi);}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
