#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeexnmnmx04/header/ppeexnmnmx04.phasespace.h"
void ppeexnmnmx04_optimize_minv_real(phasespace_set & psi){
  static Logger logger("ppeexnmnmx04_optimize_minv_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.real.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppeexnmnmx04_determination_MCchannels_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexnmnmx04_determination_MCchannels_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] == 0){n_channel = 38;}
  else if (psi_no_map[no_ps] == 2){n_channel = 24;}
  else if (psi_no_map[no_ps] == 3){n_channel = 24;}
  else if (psi_no_map[no_ps] == 4){n_channel = 24;}
  else if (psi_no_map[no_ps] == 5){n_channel = 24;}
  else if (psi_no_map[no_ps] == 6){n_channel = 24;}
  else if (psi_no_map[no_ps] == 7){n_channel = 24;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeexnmnmx04_ac_tau_psp_real(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppeexnmnmx04_ac_tau_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] == 2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 7){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeexnmnmx04_ax_psp_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexnmnmx04_ax_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] == 2){ppeexnmnmx04_ax_psp_140_gd_emepvmvmxd(no_ps, psi);}
  else if (psi_no_map[no_ps] == 3){ppeexnmnmx04_ax_psp_140_gu_emepvmvmxu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 4){ppeexnmnmx04_ax_psp_140_gdx_emepvmvmxdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 5){ppeexnmnmx04_ax_psp_140_gux_emepvmvmxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 6){ppeexnmnmx04_ax_psp_140_ddx_emepvmvmxg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 7){ppeexnmnmx04_ax_psp_140_uux_emepvmvmxg(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
