#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppemexmx04/header/ppemexmx04.phasespace.h"
void ppemexmx04_optimize_minv_doublereal(phasespace_set & psi){
  static Logger logger("ppemexmx04_optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppemexmx04_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppemexmx04_determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 584;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 248;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 248;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 248;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 248;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 248;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 248;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 288;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 144;}
  else if (psi_no_map[no_ps] == 10){n_channel = 144;}
  else if (psi_no_map[no_ps] == 11){n_channel = 144;}
  else if (psi_no_map[no_ps] == 13){n_channel = 248;}
  else if (psi_no_map[no_ps] == 14){n_channel = 288;}
  else if (psi_no_map[no_ps] == 15){n_channel = 144;}
  else if (psi_no_map[no_ps] == 16){n_channel = 144;}
  else if (psi_no_map[no_ps] == 17){n_channel = 144;}
  else if (psi_no_map[no_ps] == 18){n_channel = 144;}
  else if (psi_no_map[no_ps] == 20){n_channel = 144;}
  else if (psi_no_map[no_ps] == 22){n_channel = 144;}
  else if (psi_no_map[no_ps] == 23){n_channel = 288;}
  else if (psi_no_map[no_ps] == 24){n_channel = 144;}
  else if (psi_no_map[no_ps] == 25){n_channel = 144;}
  else if (psi_no_map[no_ps] == 27){n_channel = 248;}
  else if (psi_no_map[no_ps] == 28){n_channel = 144;}
  else if (psi_no_map[no_ps] == 29){n_channel = 288;}
  else if (psi_no_map[no_ps] == 30){n_channel = 144;}
  else if (psi_no_map[no_ps] == 31){n_channel = 144;}
  else if (psi_no_map[no_ps] == 32){n_channel = 144;}
  else if (psi_no_map[no_ps] == 34){n_channel = 144;}
  else if (psi_no_map[no_ps] == 35){n_channel = 288;}
  else if (psi_no_map[no_ps] == 36){n_channel = 144;}
  else if (psi_no_map[no_ps] == 37){n_channel = 144;}
  else if (psi_no_map[no_ps] == 38){n_channel = 144;}
  else if (psi_no_map[no_ps] == 40){n_channel = 288;}
  else if (psi_no_map[no_ps] == 41){n_channel = 144;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppemexmx04_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppemexmx04_ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 18){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 20){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 22){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 23){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 24){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 25){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 27){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 28){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 29){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 30){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 31){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 32){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 34){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 35){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 36){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 37){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 38){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 40){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 41){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppemexmx04_ax_psp_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppemexmx04_ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  2){ppemexmx04_ax_psp_240_gg_emmumepmupddx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppemexmx04_ax_psp_240_gg_emmumepmupuux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppemexmx04_ax_psp_240_gd_emmumepmupgd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppemexmx04_ax_psp_240_gu_emmumepmupgu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppemexmx04_ax_psp_240_gdx_emmumepmupgdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppemexmx04_ax_psp_240_gux_emmumepmupgux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppemexmx04_ax_psp_240_dd_emmumepmupdd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppemexmx04_ax_psp_240_du_emmumepmupdu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppemexmx04_ax_psp_240_ds_emmumepmupds(no_ps, psi);}
  else if (psi_no_map[no_ps] == 11){ppemexmx04_ax_psp_240_dc_emmumepmupdc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 13){ppemexmx04_ax_psp_240_ddx_emmumepmupgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 14){ppemexmx04_ax_psp_240_ddx_emmumepmupddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 15){ppemexmx04_ax_psp_240_ddx_emmumepmupuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 16){ppemexmx04_ax_psp_240_ddx_emmumepmupssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 17){ppemexmx04_ax_psp_240_ddx_emmumepmupccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 18){ppemexmx04_ax_psp_240_dux_emmumepmupdux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 20){ppemexmx04_ax_psp_240_dsx_emmumepmupdsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 22){ppemexmx04_ax_psp_240_dcx_emmumepmupdcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 23){ppemexmx04_ax_psp_240_uu_emmumepmupuu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 24){ppemexmx04_ax_psp_240_uc_emmumepmupuc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 25){ppemexmx04_ax_psp_240_udx_emmumepmupudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 27){ppemexmx04_ax_psp_240_uux_emmumepmupgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 28){ppemexmx04_ax_psp_240_uux_emmumepmupddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 29){ppemexmx04_ax_psp_240_uux_emmumepmupuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 30){ppemexmx04_ax_psp_240_uux_emmumepmupssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 31){ppemexmx04_ax_psp_240_uux_emmumepmupccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 32){ppemexmx04_ax_psp_240_usx_emmumepmupusx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 34){ppemexmx04_ax_psp_240_ucx_emmumepmupucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 35){ppemexmx04_ax_psp_240_dxdx_emmumepmupdxdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 36){ppemexmx04_ax_psp_240_dxux_emmumepmupdxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 37){ppemexmx04_ax_psp_240_dxsx_emmumepmupdxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 38){ppemexmx04_ax_psp_240_dxcx_emmumepmupdxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 40){ppemexmx04_ax_psp_240_uxux_emmumepmupuxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 41){ppemexmx04_ax_psp_240_uxcx_emmumepmupuxcx(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
