#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppemexmx04/header/ppemexmx04.phasespace.h"
void ppemexmx04_optimize_minv_real(phasespace_set & psi){
  static Logger logger("ppemexmx04_optimize_minv_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.real.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppemexmx04_determination_MCchannels_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppemexmx04_determination_MCchannels_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] == 0){n_channel = 88;}
  else if (psi_no_map[no_ps] == 2){n_channel = 56;}
  else if (psi_no_map[no_ps] == 3){n_channel = 56;}
  else if (psi_no_map[no_ps] == 4){n_channel = 56;}
  else if (psi_no_map[no_ps] == 5){n_channel = 56;}
  else if (psi_no_map[no_ps] == 6){n_channel = 56;}
  else if (psi_no_map[no_ps] == 7){n_channel = 56;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppemexmx04_ac_tau_psp_real(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppemexmx04_ac_tau_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] == 2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 7){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppemexmx04_ax_psp_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppemexmx04_ax_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] == 2){ppemexmx04_ax_psp_140_gd_emmumepmupd(no_ps, psi);}
  else if (psi_no_map[no_ps] == 3){ppemexmx04_ax_psp_140_gu_emmumepmupu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 4){ppemexmx04_ax_psp_140_gdx_emmumepmupdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 5){ppemexmx04_ax_psp_140_gux_emmumepmupux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 6){ppemexmx04_ax_psp_140_ddx_emmumepmupg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 7){ppemexmx04_ax_psp_140_uux_emmumepmupg(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
