#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppenexa03/header/ppenexa03.phasespace.h"
void ppenexa03_optimize_minv_real(phasespace_set & psi){
  static Logger logger("ppenexa03_optimize_minv_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.real.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppenexa03_determination_MCchannels_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppenexa03_determination_MCchannels_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] == 0){n_channel = 16;}
  else if (psi_no_map[no_ps] == 1){n_channel = 10;}
  else if (psi_no_map[no_ps] == 2){n_channel = 10;}
  else if (psi_no_map[no_ps] == 3){n_channel = 10;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppenexa03_ac_tau_psp_real(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppenexa03_ac_tau_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] == 1){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 3){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppenexa03_ax_psp_real(int no_ps, phasespace_set & psi){
  static Logger logger("ppenexa03_ax_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] == 1){ppenexa03_ax_psp_130_gd_emvexau(no_ps, psi);}
  else if (psi_no_map[no_ps] == 2){ppenexa03_ax_psp_130_gux_emvexadx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 3){ppenexa03_ax_psp_130_dux_emvexag(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
