#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../pph21/header/pph21.phasespace.h"
void pph21_optimize_minv_real(phasespace_set & psi){
  static Logger logger("pph21_optimize_minv_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.real.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int pph21_determination_MCchannels_real(int no_ps, phasespace_set & psi){
  static Logger logger("pph21_determination_MCchannels_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] == 0){n_channel = 3;}
  else if (psi_no_map[no_ps] == 1){n_channel = 3;}
  else if (psi_no_map[no_ps] == 2){n_channel = 1;}
  else if (psi_no_map[no_ps] == 3){n_channel = 1;}
  else if (psi_no_map[no_ps] == 4){n_channel = 1;}
  else if (psi_no_map[no_ps] == 5){n_channel = 1;}
  else if (psi_no_map[no_ps] == 6){n_channel = 1;}
  else if (psi_no_map[no_ps] == 7){n_channel = 1;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void pph21_ac_tau_psp_real(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("pph21_ac_tau_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] == 1){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 7){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void pph21_ax_psp_real(int no_ps, phasespace_set & psi){
  static Logger logger("pph21_ax_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] == 1){pph21_ax_psp_310_gg_hg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 2){pph21_ax_psp_310_gd_hd(no_ps, psi);}
  else if (psi_no_map[no_ps] == 3){pph21_ax_psp_310_gu_hu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 4){pph21_ax_psp_310_gdx_hdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 5){pph21_ax_psp_310_gux_hux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 6){pph21_ax_psp_310_ddx_hg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 7){pph21_ax_psp_310_uux_hg(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
