#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppz01/header/ppz01.phasespace.h"
void ppz01_optimize_minv_doublereal(phasespace_set & psi){
  static Logger logger("ppz01_optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppz01_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppz01_determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] ==  0){n_channel = 15;}
  else if (psi_no_map[no_ps] ==  2){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  3){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  4){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  5){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  6){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  7){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  8){n_channel = 8;}
  else if (psi_no_map[no_ps] ==  9){n_channel = 4;}
  else if (psi_no_map[no_ps] == 10){n_channel = 4;}
  else if (psi_no_map[no_ps] == 11){n_channel = 4;}
  else if (psi_no_map[no_ps] == 13){n_channel = 8;}
  else if (psi_no_map[no_ps] == 14){n_channel = 8;}
  else if (psi_no_map[no_ps] == 15){n_channel = 4;}
  else if (psi_no_map[no_ps] == 16){n_channel = 4;}
  else if (psi_no_map[no_ps] == 17){n_channel = 4;}
  else if (psi_no_map[no_ps] == 18){n_channel = 4;}
  else if (psi_no_map[no_ps] == 20){n_channel = 4;}
  else if (psi_no_map[no_ps] == 22){n_channel = 4;}
  else if (psi_no_map[no_ps] == 23){n_channel = 8;}
  else if (psi_no_map[no_ps] == 24){n_channel = 4;}
  else if (psi_no_map[no_ps] == 25){n_channel = 4;}
  else if (psi_no_map[no_ps] == 27){n_channel = 8;}
  else if (psi_no_map[no_ps] == 28){n_channel = 4;}
  else if (psi_no_map[no_ps] == 29){n_channel = 8;}
  else if (psi_no_map[no_ps] == 30){n_channel = 4;}
  else if (psi_no_map[no_ps] == 31){n_channel = 4;}
  else if (psi_no_map[no_ps] == 32){n_channel = 4;}
  else if (psi_no_map[no_ps] == 34){n_channel = 4;}
  else if (psi_no_map[no_ps] == 35){n_channel = 8;}
  else if (psi_no_map[no_ps] == 36){n_channel = 4;}
  else if (psi_no_map[no_ps] == 37){n_channel = 4;}
  else if (psi_no_map[no_ps] == 38){n_channel = 4;}
  else if (psi_no_map[no_ps] == 40){n_channel = 8;}
  else if (psi_no_map[no_ps] == 41){n_channel = 4;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppz01_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppz01_ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] ==  2){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  3){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  4){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  5){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  6){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  7){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  8){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] ==  9){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 10){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 11){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 13){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 14){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 15){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 16){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 17){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 18){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 20){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 22){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 23){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 24){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 25){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 27){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 28){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 29){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 30){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 31){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 32){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 34){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 35){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 36){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 37){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 38){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 40){
    tau_MC_map.push_back(0);
  }
  else if (psi.no_map[no_ps] == 41){
    tau_MC_map.push_back(0);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppz01_ax_psp_doublereal(int no_ps, phasespace_set & psi){
  static Logger logger("ppz01_ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  2){ppz01_ax_psp_210_gg_zddx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  3){ppz01_ax_psp_210_gg_zuux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  4){ppz01_ax_psp_210_gd_zgd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  5){ppz01_ax_psp_210_gu_zgu(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  6){ppz01_ax_psp_210_gdx_zgdx(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  7){ppz01_ax_psp_210_gux_zgux(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  8){ppz01_ax_psp_210_dd_zdd(no_ps, psi);}
  else if (psi_no_map[no_ps] ==  9){ppz01_ax_psp_210_du_zdu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 10){ppz01_ax_psp_210_ds_zds(no_ps, psi);}
  else if (psi_no_map[no_ps] == 11){ppz01_ax_psp_210_dc_zdc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 13){ppz01_ax_psp_210_ddx_zgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 14){ppz01_ax_psp_210_ddx_zddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 15){ppz01_ax_psp_210_ddx_zuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 16){ppz01_ax_psp_210_ddx_zssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 17){ppz01_ax_psp_210_ddx_zccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 18){ppz01_ax_psp_210_dux_zdux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 20){ppz01_ax_psp_210_dsx_zdsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 22){ppz01_ax_psp_210_dcx_zdcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 23){ppz01_ax_psp_210_uu_zuu(no_ps, psi);}
  else if (psi_no_map[no_ps] == 24){ppz01_ax_psp_210_uc_zuc(no_ps, psi);}
  else if (psi_no_map[no_ps] == 25){ppz01_ax_psp_210_udx_zudx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 27){ppz01_ax_psp_210_uux_zgg(no_ps, psi);}
  else if (psi_no_map[no_ps] == 28){ppz01_ax_psp_210_uux_zddx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 29){ppz01_ax_psp_210_uux_zuux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 30){ppz01_ax_psp_210_uux_zssx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 31){ppz01_ax_psp_210_uux_zccx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 32){ppz01_ax_psp_210_usx_zusx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 34){ppz01_ax_psp_210_ucx_zucx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 35){ppz01_ax_psp_210_dxdx_zdxdx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 36){ppz01_ax_psp_210_dxux_zdxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 37){ppz01_ax_psp_210_dxsx_zdxsx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 38){ppz01_ax_psp_210_dxcx_zdxcx(no_ps, psi);}
  else if (psi_no_map[no_ps] == 40){ppz01_ax_psp_210_uxux_zuxux(no_ps, psi);}
  else if (psi_no_map[no_ps] == 41){ppz01_ax_psp_210_uxcx_zuxcx(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
