#include "../include/classes.cxx"
//#include "../include/definitions.cxx"
#include "../include/definitions.observable.set.cxx"

// !!! cumulative distributions and dddistributions are probably not working properly with qT subtraction !!!

xdistribution get_fake_distribution_from_dddistribution(dddistribution & dddist){
  Logger logger("get_fake_distribution_from_dddistribution");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  xdistribution temp;

  temp.xdistribution_name = dddist.name;
  temp.n_bins = dddist.n_bins;

  temp.bin_edge.resize(temp.n_bins + 1);
  temp.bin_width.resize(temp.n_bins);
  for (int i_b1 = 0; i_b1 < dddist.distribution_1.n_bins; i_b1++){
    for (int i_b2 = 0; i_b2 < dddist.distribution_2.n_bins; i_b2++){
      int i_b = i_b1 * dddist.distribution_2.n_bins + i_b2;
      temp.bin_edge[i_b] = i_b1 * 1000 + i_b2;//dddist.distribution_1.bin_edge[i_b1] * dddist.distribution_2.bin_edge[i_b1];
      temp.bin_width[i_b] = dddist.distribution_1.bin_width[i_b1] * dddist.distribution_2.bin_width[i_b2];
    }
  }
  temp.bin_edge[temp.n_bins] = dddist.distribution_1.n_bins * 1000 + dddist.distribution_2.n_bins;
  
  return temp;
}

void determine_distribution_complete(observable_set & oset){
  Logger logger("determine_distribution_complete");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (osi_switch_distribution == 0){return;}

  determine_distribution_bin(osi_dat, osi_bin, osi_bin_max, oset);
  logger << LOG_DEBUG_VERBOSE << "determine_distribution_bin done !" << endl;
  
  for (int i_d = 0; i_d < osi_dat.size(); i_d++){
    for (int i_a = 0; i_a < osi_n_ps; i_a++){
      // use only new implementation: osi_bin[i_d][i_a] etc. could be generically replaced by osi_dat[i_d].bin[i_a] !!!
      osi_bin[i_d][i_a] = osi_dat[i_d].bin[i_a];
      if (osi_dat[i_d].typeCumulative != CUMULATIVE_NONE){osi_bin_max[i_d][i_a] = osi_dat[i_d].bin_max[i_a];}
    }
  }
  
  determine_distribution(osi_dat, osi_bin_weight, osi_bin_weight2, 1, osi_bin_counts, osi_integrand_D, osi_bin, osi_bin_max, oset);
  logger << LOG_DEBUG_VERBOSE << "determine_distribution done !" << endl;
  determine_dddistribution(osi_dddat, osi_dat, osi_bin_weight, osi_bin_weight2, 1, osi_bin_counts, osi_integrand_D, osi_bin, osi_bin_max, oset);
  logger << LOG_DEBUG_VERBOSE << "determine_dddistribution done !" << endl;
  if (osi_switch_CV != 0){
    for (int s = 0; s < osi_n_scales_CV; s++){
      logger << LOG_DEBUG_VERBOSE << "osi_integrand_D_CV[" << s << "] = " << setw(23) << osi_integrand_D_CV[s][0][0] << setw(23) << osi_integrand_D_CV[s][1][0] << setw(23) << osi_integrand_D_CV[s][2][0] << endl;
      determine_distribution(osi_dat, osi_bin_weight_CV[s], osi_bin_weight2_CV[s], 0, osi_bin_counts, osi_integrand_D_CV[s], osi_bin, osi_bin_max, oset);
      logger << LOG_DEBUG_VERBOSE << "determine_distribution done !" << endl;
      determine_dddistribution(osi_dddat, osi_dat, osi_bin_weight_CV[s], osi_bin_weight2_CV[s], 0, osi_bin_counts, osi_integrand_D_CV[s], osi_bin, osi_bin_max, oset);
      logger << LOG_DEBUG_VERBOSE << "determine_dddistribution done !" << endl;
    }
  }
  
  logger << LOG_DEBUG_VERBOSE << "../include/determine.distribution.cxx   TSV   started" << endl;
  
  if (osi_n_set_TSV > 0){
    determine_distribution_TSV(osi_bin, osi_bin_max, osi_dat, oset);
    //    determine_dddistribution_TSV(osi_bin, osi_bin_max, osi_dat, oset);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}



double perform_binning(double value, xdistribution & this_distribution){
  static Logger logger("perform_binning");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (this_distribution.type_binning == "linear"){return (value - this_distribution.start) / this_distribution.step;}
  else if (this_distribution.type_binning == "logarithmic"){
    /*
    cout << "logarithmic binning:"<< endl;
    cout << "value          = " << log10(value) << endl;
    cout << "log_start      = " << this_distribution.start << endl;
    cout << "log_end        = " << this_distribution.end << endl;
    cout << "log_step       = " << this_distribution.step << endl;
    //    double log_value = log10(value);
    cout << "dbin           = " << (log10(value) - this_distribution.start) / this_distribution.step << endl;
    */
    return (log10(value) - this_distribution.start) / this_distribution.step;}
  /*
    if (log_value < this_distribution.bin_edge[0] || log_value > this_distribution.bin_edge[0]){return -1.}
    else {

    }
  }
  */
  else if (this_distribution.type_binning == "irregular"){
    /*
    cout << "irregular: value = " << value << endl;
    cout << "irregular: this_distribution.start = " << this_distribution.start << endl;
    cout << "irregular: this_distribution.end = " << this_distribution.end << endl;
    cout << "irregular: this_distribution.n_bins = " << this_distribution.n_bins << endl;
    */
    //    cout << "value = " << value << endl;
    if (value < this_distribution.start){return -1.;}
    else if (value > this_distribution.end){return double(this_distribution.n_bins) + .5;}
    else {
      int i_b;
      for (i_b = 1; i_b < this_distribution.n_bins; i_b++){
	if (value <= this_distribution.bin_edge[i_b]){break;}
      }
      //      cout << "this_distribution.bin_width[i_b] = " << double(i_b - 1) << "   " << double(i_b - 1) + (value - this_distribution.bin_edge[i_b]) / this_distribution.bin_width[i_b] << endl;
      //      cout << "double(i_b - 1) + (value - this_distribution.bin_edge[i_b]) / this_distribution.bin_width[i_b] = " << double(i_b - 1) << "   " << double(i_b - 1) + (value - this_distribution.bin_edge[i_b - 1]) / this_distribution.bin_width[i_b - 1] << endl;
      //      cout << "dbin = " << double(i_b - 1) + (value - this_distribution.bin_edge[i_b - 1]) / this_distribution.bin_width[i_b - 1] << endl;
      return double(i_b - 1) + (value - this_distribution.bin_edge[i_b - 1]) / this_distribution.bin_width[i_b - 1];
    }
  }
  else {
    logger << LOG_DEBUG_VERBOSE << "No binning type chosen!" << endl;
    return -1;
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void determine_distribution_bin(vector<xdistribution> & dat, vector<vector<int> > & bin, vector<vector<int> > & bin_max, observable_set & oset){
  Logger logger("determine_distribution_bin");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  for (int d = 0; d < dat.size(); d++){
    dat[d].determineBin();
  }
}
  
//#include "old.routines.distribution.cpp"

void determine_distribution(vector<xdistribution> & dat, vector<vector<double> > & bin_value, vector<vector<double> > & bin_dev, int switch_bin_count, vector<vector<long long> > & bin_counts, vector<vector<double> > & var_x_integrand, vector<vector<int> > & bin, vector<vector<int> > & bin_max, observable_set & oset){
  static Logger logger("determine_distribution");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  for (int d = 0; d < dat.size(); d++){
    if (dat[d].typeCumulative != CUMULATIVE_NONE){
      // cumulative distributions
      // only non-symmetric distributions possible here !!!
      if (osi_n_ps == 1){
	if (bin[d][0] != -1 && bin_max[d][0] != -1){
	  for (int presentbin = bin[d][0]; presentbin < bin_max[d][0]; presentbin++){
	    //	  for (int presentbin = bin[d][0]; presentbin < dat[d].n_bins; presentbin++){
	    bin_value[d][presentbin] += var_x_integrand[1][0]*dat[d].rescale_weight[0];
	    if (switch_bin_count == 1){bin_counts[d][presentbin]++;}
	    if (osi_type_parton[0][1] != osi_type_parton[0][2]){
	      // asymmetric distribution
	      bin_value[d][presentbin] += var_x_integrand[2][0]*dat[d].rescale_weight[0];
	      if (switch_bin_count == 1){bin_counts[d][presentbin]++;}
	    }
	  
	    // changed on 20140805 !!!

	    if (var_x_integrand[2][0] == 0.){bin_dev[d][presentbin] += pow(var_x_integrand[1][0]*dat[d].rescale_weight[0], 2);}
	    else {bin_dev[d][presentbin] += pow(var_x_integrand[0][0]*dat[d].rescale_weight[0], 2);}

	    /*
	    bin_dev[d][presentbin] += pow(var_x_integrand[1][0], 2);
	    if (var_x_integrand[2][0] != 0.){bin_dev[d][presentbin] += pow(var_x_integrand[2][0], 2);}
	    */

	  }
	}
      }
      else {

	// changed on 20140805 !!!

	vector<vector<double> > xbin_dev(dat[d].n_bins);//, xbin_dev_2(dat[d].n_bins);
	for (int i_a = 0; i_a < osi_n_ps; i_a++){
	  //	  cout << "bin[" << setw(3) << d << "][" << setw(2) << i_a << "] = " << bin[d][i_a] << "   bin_max[" << setw(3) << d << "][" << setw(2) << i_a << "] = " <<  bin_max[d][i_a] << endl;
	  if (bin[d][i_a] != -1 && bin_max[d][i_a] != -1){
	    for (int presentbin = bin[d][i_a]; presentbin < bin_max[d][i_a]; presentbin++){
	      //	    for (int presentbin = bin[d][i_a]; presentbin < dat[d].n_bins; presentbin++){
	      //	      cout << "var_x_integrand[1][" << i_a << "] = " << var_x_integrand[1][i_a] << endl;
	      bin_value[d][presentbin] += var_x_integrand[1][i_a]*dat[d].rescale_weight[i_a];
	      if (switch_bin_count == 1){bin_counts[d][presentbin]++;}
	      if (osi_type_parton[0][1] != osi_type_parton[0][2]){
		// asymmetric distribution
		//	      cout << "var_x_integrand[2][" << i_a << "] = " << var_x_integrand[2][i_a] << endl;
		bin_value[d][presentbin] += var_x_integrand[2][i_a]*dat[d].rescale_weight[i_a];
		if (switch_bin_count == 1){bin_counts[d][presentbin]++;}
	      }

	      if (var_x_integrand[2][i_a] == 0.){xbin_dev[presentbin].push_back(var_x_integrand[1][i_a]*dat[d].rescale_weight[i_a]);}
	      else {xbin_dev[presentbin].push_back(var_x_integrand[0][i_a]*dat[d].rescale_weight[i_a]);}

	      /*
	      xbin_dev[presentbin].push_back(var_x_integrand[1][i_a]);
	      if (var_x_integrand[2][i_a] != 0.){xbin_dev_2[presentbin].push_back(var_x_integrand[2][i_a]);}
	      */
	      //	      cout << "bin_value[" << d << "][" << presentbin << "] = " << bin_value[d][presentbin] << endl;
	    }
	  }
	}
	for (int x = 0; x < bin_dev[d].size(); x++){
	  if (xbin_dev[x].size() != 0){bin_dev[d][x] += pow(accumulate(xbin_dev[x].begin(), xbin_dev[x].end(), 0.), 2);}
	  //	  if (xbin_dev_2[x].size() != 0){bin_dev[d][x] += pow(accumulate(xbin_dev_2[x].begin(), xbin_dev_2[x].end(), 0.), 2);}
	}

	/*
	vector<vector<double> > xbin_dev(dat[d].n_bins), xbin_dev_2(dat[d].n_bins);
	for (int i_a = 0; i_a < osi_n_ps; i_a++){
	  //	  cout << "bin[" << setw(3) << d << "][" << setw(2) << i_a << "] = " << bin[d][i_a] << "   bin_max[" << setw(3) << d << "][" << setw(2) << i_a << "] = " <<  bin_max[d][i_a] << endl;
	  if (bin[d][i_a] != -1 && bin_max[d][i_a] != -1){
	    for (int presentbin = bin[d][i_a]; presentbin < bin_max[d][i_a]; presentbin++){
	      //	    for (int presentbin = bin[d][i_a]; presentbin < dat[d].n_bins; presentbin++){
	      //	      cout << "var_x_integrand[1][" << i_a << "] = " << var_x_integrand[1][i_a] << endl;
	      bin_value[d][presentbin] += var_x_integrand[1][i_a];
	      if (switch_bin_count == 1){bin_counts[d][presentbin]++;}
	      if (osi_type_parton[0][1] != osi_type_parton[0][2]){
		// asymmetric distribution
		//	      cout << "var_x_integrand[2][" << i_a << "] = " << var_x_integrand[2][i_a] << endl;
		bin_value[d][presentbin] += var_x_integrand[2][i_a];
		if (switch_bin_count == 1){bin_counts[d][presentbin]++;}
	      }
	      xbin_dev[presentbin].push_back(var_x_integrand[1][i_a]);
	      if (var_x_integrand[2][i_a] != 0.){xbin_dev_2[presentbin].push_back(var_x_integrand[2][i_a]);}
	      //	      cout << "bin_value[" << d << "][" << presentbin << "] = " << bin_value[d][presentbin] << endl;
	    }
	  }
	}
	for (int x = 0; x < bin_dev[d].size(); x++){
	  if (xbin_dev[x].size() != 0){bin_dev[d][x] += pow(accumulate(xbin_dev[x].begin(), xbin_dev[x].end(), 0.), 2);}
	  if (xbin_dev_2[x].size() != 0){bin_dev[d][x] += pow(accumulate(xbin_dev_2[x].begin(), xbin_dev_2[x].end(), 0.), 2);}
	}
*/
      }
    }
    /*
    else if (dat[d].xdistribution_number > 200){
      if (osi_n_ps == 1){
	if (bin[d][0] != -1){
	  for (int presentbin = 0; presentbin <= bin[d][0]; presentbin++){
	    bin_value[d][presentbin] += var_x_integrand[1][0];
	    if (switch_bin_count == 1){bin_counts[d][presentbin]++;}
	    if (osi_type_parton[0][1] != osi_type_parton[0][2]){
	      // asymmetric distribution
	      bin_value[d][presentbin] += var_x_integrand[2][0];
	      if (switch_bin_count == 1){bin_counts[d][presentbin]++;}
	    }
	    bin_dev[d][presentbin] += pow(var_x_integrand[1][0], 2);
	    if (var_x_integrand[2][0] != 0.){bin_dev[d][presentbin] += pow(var_x_integrand[2][0], 2);}
	  }
	}
      }
      else {
	//      vector<int> xbin_count(0), xbin_count_2(0);
	vector<vector<double> > xbin_dev(dat[d].n_bins), xbin_dev_2(dat[d].n_bins);
	for (int i_a = 0; i_a < osi_n_ps; i_a++){
	  if (bin[d][i_a] != -1){
	    for (int presentbin = 0; presentbin <= bin[d][i_a]; presentbin++){
	      bin_value[d][presentbin] += var_x_integrand[1][i_a];
	      if (switch_bin_count == 1){bin_counts[d][presentbin]++;}
	      if (osi_type_parton[0][1] != osi_type_parton[0][2]){
		// asymmetric distribution
		bin_value[d][presentbin] += var_x_integrand[2][i_a];
		if (switch_bin_count == 1){bin_counts[d][presentbin]++;}
	      }
	      xbin_dev[presentbin].push_back(var_x_integrand[1][i_a]);
	      if (var_x_integrand[2][i_a] != 0.){xbin_dev_2[presentbin].push_back(var_x_integrand[2][i_a]);}
	    }
	  }
	}
	for (int x = 0; x < bin_dev[d].size(); x++){
	  if (xbin_dev[x].size() != 0){bin_dev[d][x] += pow(accumulate(xbin_dev[x].begin(), xbin_dev[x].end(), 0.), 2);}
	  if (xbin_dev_2[x].size() != 0){bin_dev[d][x] += pow(accumulate(xbin_dev_2[x].begin(), xbin_dev_2[x].end(), 0.), 2);}
	}
      }
    }
    */
    /*
    else if (dat[d].xdistribution_number > 100){
      if (osi_n_ps == 1){
	if (bin[d][0] != -1){
	  for (int presentbin = bin[d][0]; presentbin < dat[d].n_bins; presentbin++){
	    bin_value[d][presentbin] += var_x_integrand[1][0];
	    if (switch_bin_count == 1){bin_counts[d][presentbin]++;}
	    if (osi_type_parton[0][1] != osi_type_parton[0][2]){
	      // asymmetric distribution
	      bin_value[d][presentbin] += var_x_integrand[2][0];
	      if (switch_bin_count == 1){bin_counts[d][presentbin]++;}
	    }
	    bin_dev[d][presentbin] += pow(var_x_integrand[1][0], 2);
	    if (var_x_integrand[2][0] != 0.){bin_dev[d][presentbin] += pow(var_x_integrand[2][0], 2);}
	  }
	}
      }
      else {
	vector<vector<double> > xbin_dev(dat[d].n_bins), xbin_dev_2(dat[d].n_bins);
	for (int i_a = 0; i_a < osi_n_ps; i_a++){
	  if (bin[d][i_a] != -1){
	    for (int presentbin = bin[d][i_a]; presentbin < dat[d].n_bins; presentbin++){
	      bin_value[d][presentbin] += var_x_integrand[1][i_a];
	      if (switch_bin_count == 1){bin_counts[d][presentbin]++;}
	      if (osi_type_parton[0][1] != osi_type_parton[0][2]){
		// asymmetric distribution
		bin_value[d][presentbin] += var_x_integrand[2][i_a];
		if (switch_bin_count == 1){bin_counts[d][presentbin]++;}
	      }
	      xbin_dev[presentbin].push_back(var_x_integrand[1][i_a]);
	      if (var_x_integrand[2][i_a] != 0.){xbin_dev_2[presentbin].push_back(var_x_integrand[2][i_a]);}
	    }
	  }
	}
	for (int x = 0; x < bin_dev[d].size(); x++){
	  if (xbin_dev[x].size() != 0){bin_dev[d][x] += pow(accumulate(xbin_dev[x].begin(), xbin_dev[x].end(), 0.), 2);}
	  if (xbin_dev_2[x].size() != 0){bin_dev[d][x] += pow(accumulate(xbin_dev_2[x].begin(), xbin_dev_2[x].end(), 0.), 2);}
	}
      }
    }
    */
    else {
      // non-cumulative distributions
      if (osi_n_ps == 1){
	if (bin[d][0] != -1){
	  bin_value[d][bin[d][0]] += var_x_integrand[1][0]*dat[d].rescale_weight[0];
	  //	  bin_value[d][bin[d][0]] += var_x_integrand[1][0] / dat[d].step;
	  if (switch_bin_count == 1){bin_counts[d][bin[d][0]]++;}
	  if (osi_type_parton[0][1] != osi_type_parton[0][2]){
	    if (dat[d].symm == 0){ // asymmetric distribution
	      bin_value[d][bin[d][0]] += var_x_integrand[2][0]*dat[d].rescale_weight[0];
	      //	      bin_value[d][bin[d][0]] += (var_x_integrand[2][0]) / dat[d].step;
	      if (switch_bin_count == 1){bin_counts[d][bin[d][0]]++;}
	    }
	    else if (dat[d].symm == 1) { // symmetric distribution
	      bin_value[d][dat[d].n_bins - 1 - bin[d][0]] += var_x_integrand[2][0]*dat[d].rescale_weight[0];
	      //	      bin_value[d][dat[d].n_bins - 1 - bin[d][0]] += (var_x_integrand[2][0]) / dat[d].step;
	      if (switch_bin_count == 1){bin_counts[d][dat[d].n_bins - 1 - bin[d][0]]++;}
	    }
	  }
	  
	  //	  logger << LOG_DEBUG << "bin_value[" << setw(2) << d << "][" << setw(3) << bin[d][0] << "] = " << bin_value[d][bin[d][0]]  << endl;
	  // changed on 20140805 !!!
	  // changed on 20150227 !!! was probably wrong for logarithmic distributions !!!

	  if (var_x_integrand[2][0] == 0.){bin_dev[d][bin[d][0]] += pow(var_x_integrand[1][0]*dat[d].rescale_weight[0], 2);}
	  //	  if (var_x_integrand[2][0] == 0.){bin_dev[d][bin[d][0]] += pow(var_x_integrand[1][0] / dat[d].step, 2);}
	  else {
	    //	  if (var_x_integrand[2][0] != 0.){
	    if (dat[d].symm == 0){ // asymmetric distribution
	      bin_dev[d][bin[d][0]] += pow(var_x_integrand[0][0]*dat[d].rescale_weight[0], 2);
	      //	      bin_dev[d][bin[d][0]] += pow(var_x_integrand[0][0] / dat[d].step, 2);
	    }
	    else if (dat[d].symm == 1){ // symmetric distribution
	      bin_dev[d][bin[d][0]] += pow(var_x_integrand[1][0]*dat[d].rescale_weight[0], 2);
	      //	      bin_dev[d][bin[d][0]] += pow(var_x_integrand[1][0] / dat[d].step, 2);
	      bin_dev[d][dat[d].n_bins - 1 - bin[d][0]] += pow(var_x_integrand[2][0]*dat[d].rescale_weight[0], 2);
	      //	      bin_dev[d][dat[d].n_bins - 1 - bin[d][0]] += pow(var_x_integrand[2][0] / dat[d].step, 2);
	    }
	  }


	  /*
	  bin_dev[d][bin[d][0]] += pow(var_x_integrand[1][0] / dat[d].step, 2);
	  if (var_x_integrand[2][0] != 0.){
	    if (dat[d].symm == 0){ // asymmetric distribution
	      bin_dev[d][bin[d][0]] += pow(var_x_integrand[2][0] / dat[d].step, 2);
	    }
	    else if (dat[d].symm == 1){ // symmetric distribution
	      bin_dev[d][dat[d].n_bins - 1 - bin[d][0]] += pow(var_x_integrand[2][0] / dat[d].step, 2);
	    }
	  }
	  */
	}
      }
      else {

	// changed on 20140805 !!!

	// changed on 20141013: replace dat[d].step by dat[d].bin_width[bin[d][i_a]]
	vector<int> xbin_count(0);//, xbin_count_2(0);
	vector<double> xbin_dev(0);//, xbin_dev_2(0);
	for (int i_a = 0; i_a < osi_n_ps; i_a++){
	  if (bin[d][i_a] != -1){
	    bin_value[d][bin[d][i_a]] += var_x_integrand[1][i_a]*dat[d].rescale_weight[i_a];
	    //	    bin_value[d][bin[d][i_a]] += (var_x_integrand[1][i_a]) / dat[d].bin_width[bin[d][i_a]];
	    if (switch_bin_count == 1){bin_counts[d][bin[d][i_a]]++;}
	    if (osi_type_parton[0][1] != osi_type_parton[0][2]){
	      if (dat[d].symm == 0){ // asymmetric distribution
		bin_value[d][bin[d][i_a]] += var_x_integrand[2][i_a]*dat[d].rescale_weight[i_a];
		//		bin_value[d][bin[d][i_a]] += (var_x_integrand[2][i_a]) / dat[d].bin_width[bin[d][i_a]];
		if (switch_bin_count == 1){bin_counts[d][bin[d][i_a]]++;}
	      }
	      else if (dat[d].symm == 1){ // symmetric distribution
		bin_value[d][dat[d].n_bins - 1 - bin[d][i_a]] += var_x_integrand[2][i_a]*dat[d].rescale_weight[i_a];
		//		bin_value[d][dat[d].n_bins - 1 - bin[d][i_a]] += (var_x_integrand[2][i_a]) / dat[d].bin_width[bin[d][i_a]];
		if (switch_bin_count == 1){bin_counts[d][dat[d].n_bins - 1 - bin[d][i_a]]++;}
	      }
	    }
	    //
	    // deviation
	    //
	    int exist = -1;
	    for (int x = 0; x < xbin_count.size(); x++){
	      if (bin[d][i_a] == xbin_count[x]){exist = x; break;}
	    }
	    if (exist == -1){
	      xbin_count.push_back(bin[d][i_a]);
	      xbin_dev.push_back(var_x_integrand[1][i_a]*dat[d].rescale_weight[i_a]);
	      //	      xbin_dev.push_back(var_x_integrand[1][i_a] / dat[d].bin_width[bin[d][i_a]]);
	    }
	    else {
	      xbin_dev[exist] += var_x_integrand[1][i_a]*dat[d].rescale_weight[i_a];
	      //	      xbin_dev[exist] += var_x_integrand[1][i_a] / dat[d].bin_width[bin[d][i_a]];
	    }
	    if (var_x_integrand[2][i_a] != 0.){
	      exist = -1;
	      if (dat[d].symm == 0){ // asymmetric distribution
		for (int x = 0; x < xbin_count.size(); x++){
		  if (bin[d][i_a] == xbin_count[x]){exist = x; break;}
		}
		if (exist == -1){
		  xbin_count.push_back(bin[d][i_a]);
		  xbin_dev.push_back(var_x_integrand[2][i_a]*dat[d].rescale_weight[i_a]);
		  //		  xbin_dev.push_back(var_x_integrand[2][i_a] / dat[d].bin_width[bin[d][i_a]]);
		}
		else {
		  xbin_dev[exist] += var_x_integrand[2][i_a]*dat[d].rescale_weight[i_a];
		  //		  xbin_dev[exist] += var_x_integrand[2][i_a] / dat[d].bin_width[bin[d][i_a]];
		}
	      }
	      else if (dat[d].symm == 1){ // symmetric distribution
		for (int x = 0; x < xbin_count.size(); x++){
		  if (dat[d].n_bins - 1 - bin[d][i_a] == xbin_count[x]){exist = x; break;}
		}
		if (exist == -1){
		  xbin_count.push_back(dat[d].n_bins - 1 - bin[d][i_a]);
		  xbin_dev.push_back(var_x_integrand[2][i_a]*dat[d].rescale_weight[i_a]);
		  //		  xbin_dev.push_back(var_x_integrand[2][i_a] / dat[d].bin_width[bin[d][i_a]]);
		}
		else{
		  xbin_dev[exist] += var_x_integrand[2][i_a]*dat[d].rescale_weight[i_a];
		  //		  xbin_dev[exist] += var_x_integrand[2][i_a] / dat[d].bin_width[bin[d][i_a]];
		}
	      }
	    }
	  }
	}


	for (int x = 0; x < xbin_count.size(); x++){
	  bin_dev[d][xbin_count[x]] += pow(xbin_dev[x], 2);
	}
	/*
	for (int x = 0; x < xbin_count_2.size(); x++){
	  bin_dev[d][xbin_count_2[x]] += pow(xbin_dev_2[x], 2);
	}
	*/



	/*
	vector<int> xbin_count(0), xbin_count_2(0);
	vector<double> xbin_dev(0), xbin_dev_2(0);
	for (int i_a = 0; i_a < osi_n_ps; i_a++){
	  if (bin[d][i_a] != -1){
	    bin_value[d][bin[d][i_a]] += (var_x_integrand[1][i_a]) / dat[d].step;
	    if (switch_bin_count == 1){bin_counts[d][bin[d][i_a]]++;}
	    if (osi_type_parton[0][1] != osi_type_parton[0][2]){
	      if (dat[d].symm == 0){ // asymmetric distribution
		bin_value[d][bin[d][i_a]] += (var_x_integrand[2][i_a]) / dat[d].step;
		if (switch_bin_count == 1){bin_counts[d][bin[d][i_a]]++;}
	      }
	      else if (dat[d].symm == 1){ // symmetric distribution
		bin_value[d][dat[d].n_bins - 1 - bin[d][i_a]] += (var_x_integrand[2][i_a]) / dat[d].step;
		if (switch_bin_count == 1){bin_counts[d][dat[d].n_bins - 1 - bin[d][i_a]]++;}
	      }
	    }
	    //
	    // deviation
	    //
	    int exist = -1;
	    for (int x = 0; x < xbin_count.size(); x++){
	      if (bin[d][i_a] == xbin_count[x]){exist = x; break;}
	    }
	    if (exist == -1){
	      xbin_count.push_back(bin[d][i_a]);
	      xbin_dev.push_back(var_x_integrand[1][i_a] / dat[d].step);
	    }
	    else{
	      xbin_dev[exist] += var_x_integrand[1][i_a] / dat[d].step;
	    }
	    if (var_x_integrand[2][i_a] != 0.){
	      exist = -1;
	      if (dat[d].symm == 0){ // asymmetric distribution
		for (int x = 0; x < xbin_count_2.size(); x++){
		  if (bin[d][i_a] == xbin_count_2[x]){exist = x; break;}
		}
		if (exist == -1){
		  xbin_count_2.push_back(bin[d][i_a]);
		  xbin_dev_2.push_back(var_x_integrand[2][i_a] / dat[d].step);
		}
		else{
		  xbin_dev_2[exist] += var_x_integrand[2][i_a] / dat[d].step;
		}
	      }
	      else if (dat[d].symm == 1){ // symmetric distribution
		for (int x = 0; x < xbin_count_2.size(); x++){
		  if (dat[d].n_bins - 1 - bin[d][i_a] == xbin_count_2[x]){exist = x; break;}
		}
		if (exist == -1){
		  xbin_count_2.push_back(dat[d].n_bins - 1 - bin[d][i_a]);
		  xbin_dev_2.push_back(var_x_integrand[2][i_a] / dat[d].step);
		}
		else{
		  xbin_dev_2[exist] += var_x_integrand[2][i_a] / dat[d].step;
		}
	      }
	    }
	  }
	}


	for (int x = 0; x < xbin_count.size(); x++){
	  bin_dev[d][xbin_count[x]] += pow(xbin_dev[x], 2);
	}
	for (int x = 0; x < xbin_count_2.size(); x++){
	  bin_dev[d][xbin_count_2[x]] += pow(xbin_dev_2[x], 2);
	}
*/



      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}


// mirror-bin modifications not jet tested for dddistributions !!!

void determine_dddistribution(vector<dddistribution> & dddat, vector<xdistribution> & dat, vector<vector<double> > & bin_value, vector<vector<double> > & bin_dev, int switch_bin_count, vector<vector<long long> > & bin_counts, vector<vector<double> > & integrand_D, vector<vector<int> > & bin, vector<vector<int> > & bin_max, observable_set & oset){
  static Logger logger("determine_dddistribution");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  for (int d = 0; d < dddat.size(); d++){
    //    cout << "dddistribution: " << d << endl;
    //    if (dat[d].xdistribution_number > 0){
    if (osi_n_ps == 1){
      // d_1, d_2 are indices of distributions in dat that match the name given for distribution_1 and distribution_2 in the dddistribution.dat input
      // use these indices to get the respective rescale weights.
      double ddd_rescale_weight = dat[dddat[d].d_1].rescale_weight[0]*dat[dddat[d].d_2].rescale_weight[0]; 
      // rescale weight for dddistribtions defined as product of individual rescale weights

      //      cout << "bin[dddat[d].d_1][0] = " << bin[dddat[d].d_1][0] << endl;
      //      cout << "bin[dddat[d].d_2][0] = " << bin[dddat[d].d_2][0] << endl;
      if ((bin[dddat[d].d_1][0] == -1) || (bin[dddat[d].d_2][0] == -1)){bin[dat.size() + d][0] = -1;}
      else {bin[dat.size() + d][0] = bin[dddat[d].d_1][0] * (dddat[d].distribution_2).n_bins + bin[dddat[d].d_2][0];}
      //      cout << "bin[dat.size() + d][0] = " << bin[dat.size() + d][0] << endl;
      if (bin[dat.size() + d][0] != -1){
	int mirror_bin = -1;
	bin_value[dat.size() + d][bin[dat.size() + d][0]] += integrand_D[1][0] / dddat[d].step * ddd_rescale_weight;
	if (switch_bin_count == 1){bin_counts[dat.size() + d][bin[dat.size() + d][0]]++;}
	if (osi_type_parton[0][1] != osi_type_parton[0][2]){
	  if (((dddat[d].distribution_1).symm == 0) && ((dddat[d].distribution_2).symm == 0)){ // asymmetric distribution 1, asymmetric distribution 2
	    mirror_bin = bin[dat.size() + d][0];
	    bin_value[dat.size() + d][mirror_bin] += (integrand_D[2][0]) / dddat[d].step * ddd_rescale_weight;
	    if (switch_bin_count == 1){bin_counts[dat.size() + d][mirror_bin]++;}
	  }
	  else if (((dddat[d].distribution_1).symm == 0) && ((dddat[d].distribution_2).symm == 1)){ // asymmetric distribution 1, symmetric distribution 2
	    mirror_bin = bin[dddat[d].d_1][0] * (dddat[d].distribution_2).n_bins + ((dddat[d].distribution_2).n_bins - 1 - bin[dddat[d].d_2][0]);
	    bin_value[dat.size() + d][mirror_bin] += (integrand_D[2][0]) / dddat[d].step * ddd_rescale_weight;
	    if (switch_bin_count == 1){bin_counts[dat.size() + d][mirror_bin]++;}
	  }
	  else if (((dddat[d].distribution_1).symm == 1) && ((dddat[d].distribution_2).symm == 0)){ // symmetric distribution 1, asymmetric distribution 2
	    mirror_bin = ((dddat[d].distribution_1).n_bins - 1 - bin[dddat[d].d_1][0]) * (dddat[d].distribution_2).n_bins + bin[dddat[d].d_2][0];
	    bin_value[dat.size() + d][mirror_bin] += (integrand_D[2][0]) / dddat[d].step * ddd_rescale_weight;
	    if (switch_bin_count == 1){bin_counts[dat.size() + d][mirror_bin]++;}
	  }
	  else if (((dddat[d].distribution_1).symm == 1) && ((dddat[d].distribution_2).symm == 1)){ // symmetric distribution 1, symmetric distribution 2
	    mirror_bin = dat[d].n_bins - 1 - bin[dat.size() + d][0];
	    bin_value[dat.size() + d][mirror_bin] += (integrand_D[2][0]) / dddat[d].step * ddd_rescale_weight;
	    if (switch_bin_count == 1){bin_counts[dat.size() + d][mirror_bin]++;}
	  }
	}
	bin_dev[dat.size() + d][bin[dat.size() + d][0]] += pow(integrand_D[1][0] / dddat[d].step * ddd_rescale_weight, 2);
	if (integrand_D[2][0] != 0.){bin_dev[dat.size() + d][mirror_bin] += pow(integrand_D[2][0] / dddat[d].step * ddd_rescale_weight, 2);}
      }
    }
    else {
      vector<int> xbin_count(0), xbin_count_2(0);
      vector<double> xbin_dev(0), xbin_dev_2(0);
      for (int i_a = 0; i_a < osi_n_ps; i_a++){
	// d_1, d_2 are indices of distributions in dat that match the name given for distribution_1 and distribution_2 in the dddistribution.dat input
	// use these indices to get the respective rescale weights.
	double ddd_rescale_weight = dat[dddat[d].d_1].rescale_weight[i_a]*dat[dddat[d].d_2].rescale_weight[i_a]; 
	// rescale weight for dddistribtions defined as product of individual rescale weights
	if ((bin[dddat[d].d_1][i_a] == -1) || (bin[dddat[d].d_2][i_a] == -1)){bin[dat.size() + d][i_a] = -1;}
	else {bin[dat.size() + d][i_a] = bin[dddat[d].d_1][i_a] * (dddat[d].distribution_2).n_bins + bin[dddat[d].d_2][i_a];}
	
	if (bin[dat.size() + d][i_a] != -1){
	  vector<int> mirror_bin(osi_n_ps);
	  bin_value[dat.size() + d][bin[dat.size() + d][i_a]] += (integrand_D[1][i_a]) / dddat[d].step * ddd_rescale_weight;
	  if (switch_bin_count == 1){bin_counts[dat.size() + d][bin[dat.size() + d][i_a]]++;}
	  if (osi_type_parton[0][1] != osi_type_parton[0][2]){
	    if (((dddat[d].distribution_1).symm == 0) && ((dddat[d].distribution_2).symm == 0)){ // asymmetric distribution 1, asymmetric distribution 2
	      mirror_bin[i_a] = bin[dat.size() + d][i_a];
	      bin_value[dat.size() + d][mirror_bin[i_a]] += (integrand_D[2][i_a]) / dddat[d].step * ddd_rescale_weight;
	      if (switch_bin_count == 1){bin_counts[dat.size() + d][mirror_bin[i_a]]++;}
	    }
	    else if (((dddat[d].distribution_1).symm == 0) && ((dddat[d].distribution_2).symm == 1)){ // asymmetric distribution 1, symmetric distribution 2
	      mirror_bin[i_a] = bin[dddat[d].d_1][i_a] * (dddat[d].distribution_2).n_bins + ((dddat[d].distribution_2).n_bins - 1 - bin[dddat[d].d_2][i_a]);
	      bin_value[dat.size() + d][mirror_bin[i_a]] += (integrand_D[2][i_a]) / dddat[d].step * ddd_rescale_weight;
	      if (switch_bin_count == 1){bin_counts[dat.size() + d][mirror_bin[i_a]]++;}
	    }
	    else if (((dddat[d].distribution_1).symm == 1) && ((dddat[d].distribution_2).symm == 0)){ // symmetric distribution 1, asymmetric distribution 2
	      mirror_bin[i_a] = ((dddat[d].distribution_1).n_bins - 1 - bin[dddat[d].d_1][i_a]) * (dddat[d].distribution_2).n_bins + bin[dddat[d].d_2][i_a];
	      bin_value[dat.size() + d][mirror_bin[i_a]] += (integrand_D[2][i_a]) / dddat[d].step * ddd_rescale_weight;
	      if (switch_bin_count == 1){bin_counts[dat.size() + d][mirror_bin[i_a]]++;}
	    }
	    else if (((dddat[d].distribution_1).symm == 1) && ((dddat[d].distribution_2).symm == 1)){ // symmetric distribution 1, symmetric distribution 2
	      mirror_bin[i_a] = dat[d].n_bins - 1 - bin[dat.size() + d][i_a];
	      bin_value[dat.size() + d][mirror_bin[i_a]] += (integrand_D[2][i_a]) / dddat[d].step * ddd_rescale_weight;
	      if (switch_bin_count == 1){bin_counts[dat.size() + d][mirror_bin[i_a]]++;}
	    }
	  }
	  //
	  // deviation
	  //
	  int exist = -1;
	  for (int x = 0; x < xbin_count.size(); x++){
	    if (bin[dat.size() + d][i_a] == xbin_count[x]){exist = x; break;}
	  }
	  if (exist == -1){
	    xbin_count.push_back(bin[dat.size() + d][i_a]);
	    xbin_dev.push_back(integrand_D[1][i_a] / dddat[d].step * ddd_rescale_weight);
	  }
	  else{
	    xbin_dev[exist] += integrand_D[1][i_a] / dddat[d].step * ddd_rescale_weight;
	  }
	  if (integrand_D[2][i_a] != 0.){
	    exist = -1;
	    //	    if (dat[d].symm == 0){ // asymmetric distribution
	      for (int x = 0; x < xbin_count_2.size(); x++){
		if (mirror_bin[i_a] == xbin_count_2[x]){exist = x; break;}
	      }
	      if (exist == -1){
		xbin_count_2.push_back(mirror_bin[i_a]);
		xbin_dev_2.push_back(integrand_D[2][i_a] / dddat[d].step * ddd_rescale_weight);
	      }
	      else{
		xbin_dev_2[exist] += integrand_D[2][i_a] / dddat[d].step * ddd_rescale_weight;
	      }
	      //	    }
	      /*	    else if (dat[d].symm == 1){ // symmetric distribution
	      for (int x = 0; x < xbin_count_2.size(); x++){
		if (dat[d].n_bins - 1 - bin[dat.size() + d][i_a] == xbin_count_2[x]){exist = x; break;}
	      }
	      if (exist == -1){
		xbin_count_2.push_back(dat[d].n_bins - 1 - bin[dat.size() + d][i_a]);
		xbin_dev_2.push_back(integrand_D[2][i_a] / dat[d].step);
	      }
	      else{
		xbin_dev_2[exist] += integrand_D[2][i_a] / dat[d].step;
	      }
	    }
	      */
	  }
	}
      }
      for (int x = 0; x < xbin_count.size(); x++){
	bin_dev[dat.size() + d][xbin_count[x]] += pow(xbin_dev[x], 2);
      }
      for (int x = 0; x < xbin_count_2.size(); x++){
	bin_dev[dat.size() + d][xbin_count_2[x]] += pow(xbin_dev_2[x], 2);
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}














void determine_distribution_TSV(vector<vector<int> > & bin, vector<vector<int> > & bin_max, vector<xdistribution> & dat, observable_set & oset){
  static Logger logger("determine_distribution_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  //  cout << "determine_distribution_TSV started" << endl;
  vector<vector<int> > distribution_no_bin(dat.size() + osi_dddat.size());
  vector<vector<int> > distribution_no_bin_max(dat.size() + osi_dddat.size());
  vector<vector<vector<int> > > distribution_no_bin_phasespace(dat.size() + osi_dddat.size());
  vector<vector<vector<int> > > distribution_no_bin_max_phasespace(dat.size() + osi_dddat.size());

  vector<int> distribution_no_qTcut = osi_cut_ps;
  vector<vector<int> > distribution_no_qTcut_phasespace;
  ///  vector<vector<int> > distribution_no_qTcut_phasespace(dat.size());

  vector<vector<vector<vector<int> > > > distribution_no_bin_no_qTcut_phasespace(dat.size() + osi_dddat.size());

  vector<vector<int> > distribution_no_bin_all(dat.size() + osi_dddat.size());

  logger << LOG_DEBUG_VERBOSE << "after local initializations" << endl;

  // bin contains the relevant bin number of the respective distribution (the smallest bin number in case of cumulated distributions):
  //    1st [] -> no_distribution   2nd [] -> no_phasespace   
  //    entry -> value_bin

  // bin_max contains the highest relevant bin number (i_b < bin_max[i_d][i_a]) of the respective cumulated distribution (irrelevant for normal distributions):
  //    1st [] -> no_distribution   2nd [] -> no_phasespace   
  //    entry -> value_bin_max (+1)

  // distribution_no_bin contains all bin numbers which are relevant for the present set of phase-space points:   
  //    1st [] -> no_distribution   2nd [] -> no_relevant_bin   
  //    entry -> value_bin

  // distribution_no_bin_phasespace contains the numbers of all phasespaces which are relevant for the respective bins (last 2nd entry empty for cumulative distributions):
  //    1st [] -> no_distribution   2nd [] -> no_relevant_bin   3rd [] -> no_relevant_phasespace   
  //    entry -> no_phasespace

  // distribution_no_qTcut contains all relevant qTcut numbers:
  //    1st [] -> no_relevant_qTcut   
  //    entry -> no_qTcut

  // distribution_no_bin_no_qTcut_phasespace:   
  //    1st [] -> no_distribution   2nd [] -> no_relevant_qTcut   3nd [] -> no_relevant_bin   4th [] -> no_relevant_phasespace   
  //    entry -> no_phasespace

  // relevant for n_ps > 1 !!!
  //    for (int ia = 0; ia < osi_cut_ps.size(); ia++){cout << "osi_cut_ps[" << ia << "] = " << osi_cut_ps[ia] << endl;}


  /// to be shifted elsewhere - does not need to be determined at every phase-space point !!!
  /*
  int switch_distribution_TSV_at_all = 0;
  for (int i_s = 0; i_s < osi_n_set_TSV; i_s++){
    if (osi_switch_distribution_TSV[i_s] > 0){switch_distribution_TSV_at_all = 1; break;}
  }
  */  
  ///

  if (osi_switch_distribution_at_all_TSV == 1){
    logger << LOG_DEBUG_VERBOSE << "osi_switch_distribution_at_all_TSV == 1" << endl;
    if (osi_n_ps == 1){
      logger << LOG_DEBUG_VERBOSE << "osi_n_ps == 1" << endl;
      for (int i_d = 0; i_d < dat.size(); i_d++){
	logger << LOG_DEBUG_VERBOSE << "osi_n_ps == 1: i_d = " << i_d << endl;
	logger << LOG_DEBUG_VERBOSE << "   dat[" << i_d << "].xdistribution_name = " << dat[i_d].xdistribution_name << endl;
	if (dat[i_d].typeCumulative != CUMULATIVE_NONE){
	logger << LOG_DEBUG_VERBOSE << "bin[i_d][0] = " << bin[i_d][0] << endl;
	logger << LOG_DEBUG_VERBOSE << "bin_max[i_d][0] = " << bin_max[i_d][0] << endl;
	  distribution_no_bin[i_d] = bin[i_d]; // could still be -1
	  distribution_no_bin_max[i_d] = bin_max[i_d]; // could still be -1
	  if (bin[i_d][0] != -1 && bin_max[i_d][0] != -1){
	    logger << LOG_DEBUG_VERBOSE << "distribution_no_bin_phasespace[i_d].size() = " << distribution_no_bin_phasespace[i_d].size() << endl;
	    distribution_no_bin_phasespace[i_d].resize(1, vector<int> (1, 0)); // -> (1, 0) only 1 phasespace, namely 0; resize(1, ...) -> only 1 bin
	    distribution_no_qTcut_phasespace.resize(1, vector<int> (1, 0)); // -> (1, 0) only 1 phasespace value, namely 0; resize(1, ...) -> only 1 qTcut value
	    distribution_no_bin_no_qTcut_phasespace[i_d].resize(1, vector<vector<int> > (1, vector<int> (1, 0)));
	    for (int i_q = 0; i_q <= osi_cut_ps[0]; i_q++){for (int j_b = distribution_no_bin[i_d][0]; j_b < distribution_no_bin_max[i_d][0]; j_b++){osi_bin_count_TSV[i_q][i_d][j_b]++;}} // mirrored contributions ???
	  }
	}
	else {
	  logger << LOG_DEBUG_VERBOSE << "bin[" << i_d << "][0] = " << bin[i_d][0] << endl;
	  if (bin[i_d][0] != -1){
	    distribution_no_bin[i_d].resize(1, bin[i_d][0]);
	    //	  distribution_no_bin[i_d] = bin[i_d]; // could still be -1 --- does the same ???
	    distribution_no_bin_phasespace[i_d].resize(1, vector<int> (1, 0)); // -> (1, 0) only 1 phasespace, namely 0; resize(1, ...) -> only 1 bin
	    distribution_no_qTcut_phasespace.resize(1, vector<int> (1, 0)); // -> (1, 0) only 1 phasespace value, namely 0; resize(1, ...) -> only 1 qTcut value
	    distribution_no_bin_no_qTcut_phasespace[i_d].resize(1, vector<vector<int> > (1, vector<int> (1, 0)));
	    logger << LOG_DEBUG_VERBOSE << "osi_cut_ps[0] = " << osi_cut_ps[0] << endl;
	    logger << LOG_DEBUG_VERBOSE << "osi_bin_count_TSV.size() = " << osi_bin_count_TSV.size() << endl;

	    for (int i_q = 0; i_q <= osi_cut_ps[0]; i_q++){osi_bin_count_TSV[i_q][i_d][bin[i_d][0]]++;}// ??? < or <= ???  // mirrored contributions ???
	    //	    for (int i_q = 0; i_q <= osi_cut_ps[0]; i_q++){logger << LOG_DEBUG_VERBOSE << "i_q = " << i_q << endl; osi_bin_count_TSV[i_q][i_d][bin[i_d][0]]++;}// ??? < or <= ???  // mirrored contributions ???
	    logger << LOG_DEBUG_VERBOSE << "osi_bin_count_TSV.size() = " << osi_bin_count_TSV.size() << endl;

	  }
	}
      }
    }
    else {
      //VERBOSE
      logger << LOG_DEBUG_VERBOSE << "osi_n_ps != 1" << endl;
      logger << LOG_DEBUG_VERBOSE << "distribution_no_qTcut.size() = " << distribution_no_qTcut.size() << endl;
      for (int i_q = 0; i_q < distribution_no_qTcut.size(); i_q++){logger << LOG_DEBUG_VERBOSE << "distribution_no_qTcut[" << i_q << "] = " << distribution_no_qTcut[i_q] << endl;}
      // i_q > 0, because the 0 entry always remains unchanged!
      logger << LOG_DEBUG_VERBOSE << "sort   distribution_no_qTcut" << endl;
      sort(distribution_no_qTcut.begin(), distribution_no_qTcut.end());
      for (int i_q = 0; i_q < distribution_no_qTcut.size(); i_q++){logger << LOG_DEBUG_VERBOSE << "distribution_no_qTcut[" << i_q << "] = " << distribution_no_qTcut[i_q] << endl;}
      for (int i_q = osi_n_ps - 1; i_q > 0; i_q--){  // i_q > 0, because the 0 entry always remains unchanged!
	if (distribution_no_qTcut[i_q] == distribution_no_qTcut[i_q - 1]){distribution_no_qTcut.erase(distribution_no_qTcut.begin() + i_q);}
      }
      logger << LOG_DEBUG_VERBOSE << "remove identical entries from   distribution_no_qTcut" << endl;
      logger << LOG_DEBUG_VERBOSE << "distribution_no_qTcut.size() = " << distribution_no_qTcut.size() << endl;
      for (int i_q = 0; i_q < distribution_no_qTcut.size(); i_q++){logger << LOG_DEBUG_VERBOSE << "distribution_no_qTcut[" << i_q << "] = " << distribution_no_qTcut[i_q] << endl;}
      logger << LOG_DEBUG_VERBOSE << "remove -1 entries from   distribution_no_qTcut" << endl;
      if (distribution_no_qTcut[0] == -1){distribution_no_qTcut.erase(distribution_no_qTcut.begin());}

      // !!!
      logger << LOG_DEBUG_VERBOSE << "distribution_no_qTcut.size() = " << distribution_no_qTcut.size() << endl;
      for (int j_q = 0; j_q < distribution_no_qTcut.size(); j_q++){
	logger << LOG_DEBUG_VERBOSE << "distribution_no_qTcut[" << j_q << "] = " << distribution_no_qTcut[j_q] << endl;
      }

      distribution_no_qTcut_phasespace.resize(distribution_no_qTcut.size());
      for (int i_a = 0; i_a < osi_n_ps; i_a++){
	for (int i_q = 0; i_q < distribution_no_qTcut.size(); i_q++){
	  if (distribution_no_qTcut[i_q] == osi_cut_ps[i_a]){distribution_no_qTcut_phasespace[i_q].push_back(i_a);}
	}
      }

      // !!!
      for (int j_q = 0; j_q < distribution_no_qTcut_phasespace.size(); j_q++){
	for (int j_a = 0; j_a < distribution_no_qTcut_phasespace[j_q].size(); j_a++){
	  logger << LOG_DEBUG_VERBOSE << "distribution_no_qTcut_phasespace[" << j_q << "][" << j_a << "] = " << distribution_no_qTcut_phasespace[j_q][j_a] << endl;
	}
      }

      // distribution_no_qTcut
      // 1st entry: all relevant values of osi_cut_ps, in ascending (?) order, appearing only once each (-1 entries removed)

      // distribution_no_qTcut_phasespace:
      // 1st entry: cut value from "distribution_no_qTcut"
      // 2nd entry: phasespace (i_a) with that cut value



      /////    distribution_no_bin = bin;
      /////    distribution_no_bin_max = bin_max;
      for (int i_d = 0; i_d < dat.size(); i_d++){
	logger << LOG_DEBUG_VERBOSE << "osi_n_ps != 1:   dat[" << i_d << "] = " << dat[i_d].xdistribution_name << endl;
	if (dat[i_d].typeCumulative != CUMULATIVE_NONE){
	  distribution_no_bin[i_d] = bin[i_d];
	  distribution_no_bin_max[i_d] = bin_max[i_d];

	  sort(distribution_no_bin[i_d].begin(), distribution_no_bin[i_d].end());
	  for (int i_b = osi_n_ps - 1; i_b > 0; i_b--){
	    if (distribution_no_bin[i_d][i_b] == distribution_no_bin[i_d][i_b - 1]){distribution_no_bin[i_d].erase(distribution_no_bin[i_d].begin() + i_b);}
	  }
	  if (distribution_no_bin[i_d][0] == -1){distribution_no_bin[i_d].erase(distribution_no_bin[i_d].begin());}
	  // distribution_no_bin
	  // 1st entry: no of distribution
	  // 2nd entry: all relevant bin values, in ascending (?) order, appearing only once each
	  
	  sort(distribution_no_bin_max[i_d].begin(), distribution_no_bin_max[i_d].end());
	  for (int i_b = osi_n_ps - 1; i_b > 0; i_b--){
	    if (distribution_no_bin_max[i_d][i_b] == distribution_no_bin_max[i_d][i_b - 1]){distribution_no_bin_max[i_d].erase(distribution_no_bin_max[i_d].begin() + i_b);}
	  }
	  if (distribution_no_bin_max[i_d][0] == -1){distribution_no_bin_max[i_d].erase(distribution_no_bin_max[i_d].begin());}
	  // distribution_no_bin_max
	  // 1st entry: no of distribution
	  // 2nd entry: all relevant bin_max values, in ascending (?) order, appearing only once each

	  distribution_no_bin_all[i_d] = distribution_no_bin[i_d];
	  for (int i_b = 0; i_b < distribution_no_bin_max[i_d].size(); i_b++){distribution_no_bin_all[i_d].push_back(distribution_no_bin_max[i_d][i_b]);}
	  sort(distribution_no_bin_all[i_d].begin(), distribution_no_bin_all[i_d].end());
	  for (int i_b = distribution_no_bin_all[i_d].size() - 1; i_b > 0; i_b--){
	    if (distribution_no_bin_all[i_d][i_b] == distribution_no_bin_all[i_d][i_b - 1]){distribution_no_bin_all[i_d].erase(distribution_no_bin_all[i_d].begin() + i_b);}
	  }
	  // distribution_no_bin_all
	  // 1st entry: no of distribution
	  // 2nd entry: all relevant bin and bin_max values, in ascending (?) order, appearing only once each

	  distribution_no_bin_phasespace[i_d].resize(distribution_no_bin_all[i_d].size());
	  for (int i_a = 0; i_a < osi_n_ps; i_a++){
	    for (int i_b = 0; i_b < distribution_no_bin_all[i_d].size(); i_b++){
	      if (distribution_no_bin_all[i_d][i_b] >= bin[i_d][i_a] && distribution_no_bin_all[i_d][i_b] < bin_max[i_d][i_a]){distribution_no_bin_phasespace[i_d][i_b].push_back(i_a);}
	      if (distribution_no_bin_all[i_d][i_b] == bin_max[i_d][i_a]){break;}
	    }
	  }
	  // distribution_no_bin_phasespace
	  // 1st entry: no of distribution
	  // 2nd entry: bin value from "distribution_no_bin_all[i_d]"
	  // 3rd entry: phasespace (i_a) with that bin value

	  if (distribution_no_bin_all[i_d].size() != 0){
	    distribution_no_bin_no_qTcut_phasespace[i_d].resize(distribution_no_bin_all[i_d].size() - 1, vector<vector<int> > (distribution_no_qTcut.size()));
	    for (int i_b = 0; i_b < distribution_no_bin_all[i_d].size() - 1; i_b++){ // -1, because last entry contains no dipoles numbers any more
	      for (int i_q = 0; i_q < distribution_no_qTcut.size(); i_q++){
		for (int i_ba = 0; i_ba < distribution_no_bin_phasespace[i_d][i_b].size(); i_ba++){
		  for (int i_qa = 0; i_qa < distribution_no_qTcut_phasespace[i_q].size(); i_qa++){
		    if (distribution_no_bin_phasespace[i_d][i_b][i_ba] == distribution_no_qTcut_phasespace[i_q][i_qa]){
		      distribution_no_bin_no_qTcut_phasespace[i_d][i_b][i_q].push_back(distribution_no_bin_phasespace[i_d][i_b][i_ba]);
		    }
		  }
		}
	      }
	    }
	    // distribution_no_bin_phasespace
	    // 1st entry: no of distribution
	    // 2nd entry: bin value from "distribution_no_bin_all[i_d]"
	    // 3rd entry: cut value from "distribution_no_qTcut"
	    // 4th entry: phasespace (i_a) with that bin and qTcut value

	    for (int i_b = 0; i_b < distribution_no_bin_all[i_d].size() - 1; i_b++){
	      int i_b_min = distribution_no_bin_all[i_d][i_b];
	      int i_b_max = distribution_no_bin_all[i_d][i_b + 1];
	      for (int j_b = i_b_min; j_b < i_b_max; j_b++){
		int j_q = 0;
		int start_i_q = distribution_no_qTcut[0];
		for (int i_q = start_i_q; i_q < osi_output_n_qTcut; i_q++){
		  if (i_q > start_i_q && i_q == distribution_no_qTcut[j_q]){j_q++;}
		  osi_bin_count_TSV[i_q][i_d][j_b] += distribution_no_bin_no_qTcut_phasespace[i_d][i_b][j_q].size();
		}
	      }
	    }
	  }
	}

	else {
	  ////////////////////////////////////////////////////////////////
	  //  n_ps > 1  //  dat[i_d].typeCumulative == CUMULATIVE_NONE  //
	  ////////////////////////////////////////////////////////////////

	  distribution_no_bin[i_d] = bin[i_d];
	  // Is bin[i_d][i_a] == -1 id that phase-space is cut ??? Doesn't seem to be the case !!!
	  sort(distribution_no_bin[i_d].begin(), distribution_no_bin[i_d].end());
	  for (int i_b = osi_n_ps - 1; i_b > 0; i_b--){
	    if (distribution_no_bin[i_d][i_b] == distribution_no_bin[i_d][i_b - 1]){distribution_no_bin[i_d].erase(distribution_no_bin[i_d].begin() + i_b);}
	  }
	  if (distribution_no_bin[i_d][0] == -1){distribution_no_bin[i_d].erase(distribution_no_bin[i_d].begin());}

	  distribution_no_bin_phasespace[i_d].resize(distribution_no_bin[i_d].size());
	  for (int i_a = 0; i_a < osi_n_ps; i_a++){
	    for (int i_b = 0; i_b < distribution_no_bin[i_d].size(); i_b++){
	      if (distribution_no_bin[i_d][i_b] == bin[i_d][i_a]){distribution_no_bin_phasespace[i_d][i_b].push_back(i_a); break;}
	    }
	  }

	  // !!!
	  if (i_d == 0){
	    for (int j_b = 0; j_b < distribution_no_bin_phasespace[i_d].size(); j_b++){
	      logger << LOG_DEBUG_VERBOSE << "distribution_no_bin[" << i_d << "][" << j_b << "] = " << distribution_no_bin[i_d][j_b] << endl;
	      for (int j_a = 0; j_a < distribution_no_bin_phasespace[i_d][j_b].size(); j_a++){
		logger << LOG_DEBUG_VERBOSE << "distribution_no_bin_phasespace[" << i_d << "][" << j_b << "][" << j_a << "] = " << distribution_no_bin_phasespace[i_d][j_b][j_a] << endl;
	      }
	    }
	  }
	
	  distribution_no_bin_no_qTcut_phasespace[i_d].resize(distribution_no_bin[i_d].size(), vector<vector<int> > (distribution_no_qTcut.size()));
	  for (int i_b = 0; i_b < distribution_no_bin[i_d].size(); i_b++){
	    for (int i_q = 0; i_q < distribution_no_qTcut.size(); i_q++){
	      for (int i_ba = 0; i_ba < distribution_no_bin_phasespace[i_d][i_b].size(); i_ba++){
		for (int i_qa = 0; i_qa < distribution_no_qTcut_phasespace[i_q].size(); i_qa++){
		  if (distribution_no_bin_phasespace[i_d][i_b][i_ba] == distribution_no_qTcut_phasespace[i_q][i_qa]){
		    distribution_no_bin_no_qTcut_phasespace[i_d][i_b][i_q].push_back(distribution_no_bin_phasespace[i_d][i_b][i_ba]);
		    for (int j_q = 0; j_q <= distribution_no_qTcut[i_q]; j_q++){
		      osi_bin_count_TSV[j_q][i_d][bin[i_d][distribution_no_bin_phasespace[i_d][i_b][i_ba]]]++;
		    }
		    // check if correct !!!
		  }
		}
	      }
	    }
	  }
	  // !!!
	  if (i_d == 0){
	    for (int j_b = 0; j_b < distribution_no_bin_no_qTcut_phasespace[i_d].size(); j_b++){ // -1, because last entry contains no dipoles numbers any more
	      for (int i_q = 0; i_q < distribution_no_bin_no_qTcut_phasespace[i_d][j_b].size(); i_q++){
		for (int i_x = 0; i_x < distribution_no_bin_no_qTcut_phasespace[i_d][j_b][i_q].size(); i_x++){
		  logger << LOG_DEBUG_VERBOSE << "distribution_no_bin_no_qTcut_phasespace[i_d = " << i_d << "][no_b = " << j_b << "][no_q = " << i_q << "][no_x = " << i_x << "] = " << distribution_no_bin_no_qTcut_phasespace[i_d][j_b][i_q][i_x] << endl;
		}
	      }
	    }
	  }
	  logger << LOG_DEBUG_VERBOSE << "i_d = " << i_d << "   here" << endl;


	}
	logger << LOG_DEBUG_VERBOSE << "osi_n_ps != 1:   dat[" << i_d << "] = " << dat[i_d].xdistribution_name << " done" << endl;
      }
    }
  






    for (int i_s = 0; i_s < osi_n_set_TSV; i_s++){
      logger << LOG_DEBUG_VERBOSE << "i_s = " << i_s << endl;
      if (osi_switch_distribution_TSV[i_s] > 0){
	for (int i_d = 0; i_d < dat.size(); i_d++){
	  logger << LOG_DEBUG_VERBOSE << "i_d = " << i_d << endl;
	  if (osi_n_ps == 1){
	    /*
	    if (dat[i_d].xdistribution_number > 100){
	      if (distribution_no_bin_all[i_d].size() != 0){
	      }
	    }
	    else {
	    */
	    if (bin[i_d][0] != -1){
	      if (osi_type_contribution == "CT" || 
		  osi_type_contribution == "CT2" || 
		  osi_type_contribution == "L2CT"){
		for (int i_q = 0; i_q <= osi_cut_ps[0]; i_q++){
		  int min = 0, max = 0;
		  if (dat[i_d].typeCumulative != CUMULATIVE_NONE){min = distribution_no_bin[i_d][0]; max = distribution_no_bin_max[i_d][0];}
		  else {min = distribution_no_bin[i_d][0]; max = distribution_no_bin[i_d][0] + 1;}
		  
		  for (int i_r = 0; i_r < osi_n_scale_ren_TSV[i_s]; i_r++){
		    for (int i_f = 0; i_f < osi_n_scale_fact_TSV[i_s]; i_f++){
		      for (int i_b = min; i_b < max; i_b++){ // was '<=' before !!!
			// maybe improve for cumulative distributions ???
			// i_b -> only one bin: bin[i_d][0]
			// i_q -> n_qTcut different values: osi_cut_ps[0] is always -1  or  osi_n_qTcut (-1?)
			if (dat[i_d].symm == 0 || osi_type_parton[0][1] == osi_type_parton[0][2]){
			  osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_d][i_b] += osi_ps_integrand_qTcut_TSV[i_q][i_s][i_r][i_f][0][0];
			  osi_bin_weight2_TSV[i_s][i_q][i_r][i_f][i_d][i_b] += pow(osi_ps_integrand_qTcut_TSV[i_q][i_s][i_r][i_f][0][0], 2);
			}
			else {
			  osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_d][i_b] += osi_ps_integrand_qTcut_TSV[i_q][i_s][i_r][i_f][1][0];
			  osi_bin_weight2_TSV[i_s][i_q][i_r][i_f][i_d][i_b] += pow(osi_ps_integrand_qTcut_TSV[i_q][i_s][i_r][i_f][1][0], 2);
			  osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_d][dat[i_d].n_bins - 1 - i_b] += osi_ps_integrand_qTcut_TSV[i_q][i_s][i_r][i_f][2][0];
			  osi_bin_weight2_TSV[i_s][i_q][i_r][i_f][i_d][dat[i_d].n_bins - 1 - i_b] += pow(osi_ps_integrand_qTcut_TSV[i_q][i_s][i_r][i_f][2][0], 2);
			}
		      }
		    }
		  }
		}
	      }
	      else {
		vector<vector<double> > change_bin_weight(osi_n_scale_ren_TSV[i_s], vector<double> (osi_n_scale_fact_TSV[i_s], 0.));
		vector<vector<double> > change_bin_weight2(osi_n_scale_ren_TSV[i_s], vector<double> (osi_n_scale_fact_TSV[i_s], 0.));
		vector<vector<double> > change_bin_weight_2nd(osi_n_scale_ren_TSV[i_s], vector<double> (osi_n_scale_fact_TSV[i_s], 0.));
		vector<vector<double> > change_bin_weight2_2nd(osi_n_scale_ren_TSV[i_s], vector<double> (osi_n_scale_fact_TSV[i_s], 0.));
		for (int i_r = 0; i_r < osi_n_scale_ren_TSV[i_s]; i_r++){
		  for (int i_f = 0; i_f < osi_n_scale_fact_TSV[i_s]; i_f++){
		    // i_b -> only one bin: bin[i_d][0]
		    // i_q -> only one qTcut: osi_cut_ps[0]
		    if (dat[i_d].symm == 0 || osi_type_parton[0][1] == osi_type_parton[0][2]){
		      change_bin_weight[i_r][i_f] = osi_ps_integrand_TSV[i_s][i_r][i_f][0][0];
		      change_bin_weight2[i_r][i_f] = pow(change_bin_weight[i_r][i_f], 2);
		    }
		    else {
		      change_bin_weight[i_r][i_f] = osi_ps_integrand_TSV[i_s][i_r][i_f][1][0];
		      change_bin_weight2[i_r][i_f] = pow(change_bin_weight[i_r][i_f], 2);
		      change_bin_weight_2nd[i_r][i_f] = osi_ps_integrand_TSV[i_s][i_r][i_f][2][0];
		      change_bin_weight2_2nd[i_r][i_f] = pow(change_bin_weight_2nd[i_r][i_f], 2);
		    }

		    // calculate change_bin_weight !!!
		    //		for (int i_q = 0; i_q <= osi_cut_ps[0]; i_q++){ // !!! check '<' or '<=' !!! 2nd ?
		    for (int i_q = 0; i_q <= osi_cut_ps[0]; i_q++){
		      int min = 0, max = 0;
		      if (dat[i_d].typeCumulative != CUMULATIVE_NONE){min = distribution_no_bin[i_d][0]; max = distribution_no_bin_max[i_d][0];}
			/*
		      if (dat[i_d].xdistribution_number > 300){min = distribution_no_bin[i_d][0]; max = dat[i_d].n_bins - 1;}///xxxxx !!!!!
		      //		  if (dat[i_d].xdistribution_number > 300){min = distribution_no_bin[i_d][0]; max = distribution_no_bin_max[i_d][0] - 1;}///xxxxx
		      else if (dat[i_d].xdistribution_number > 200){min = distribution_no_bin[i_d][0]; max = dat[i_d].n_bins - 1;}
		      else if (dat[i_d].xdistribution_number > 100){min = 0; max = distribution_no_bin[i_d][0];}
			*/
		      else {min = distribution_no_bin[i_d][0]; max = distribution_no_bin[i_d][0] + 1;}
		      for (int i_b = min; i_b < max; i_b++){ // was '<=' before !!!
			osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_d][i_b] += change_bin_weight[i_r][i_f];
			osi_bin_weight2_TSV[i_s][i_q][i_r][i_f][i_d][i_b] += change_bin_weight2[i_r][i_f];
			if (!(dat[i_d].symm == 0 || osi_type_parton[0][1] == osi_type_parton[0][2])){
			  osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_d][dat[i_d].n_bins - 1 - i_b] += change_bin_weight_2nd[i_r][i_f];
			  osi_bin_weight2_TSV[i_s][i_q][i_r][i_f][i_d][dat[i_d].n_bins - 1 - i_b] += change_bin_weight2_2nd[i_r][i_f];
			}
		      }
		      // !!! adpat to ... < max !!!
		    }
		  }
		}
	      }
	    }
	  }
	  else {
	    logger << LOG_DEBUG_VERBOSE << "osi_n_ps != 1:   2nd step   dat[" << i_d << "] = " << dat[i_d].xdistribution_name << endl;
	    if (dat[i_d].typeCumulative != CUMULATIVE_NONE){
	      if (distribution_no_bin_all[i_d].size() != 0){
		vector<vector<vector<vector<double> > > > change_bin_weight(osi_n_scale_ren_TSV[i_s], vector<vector<vector<double> > > (osi_n_scale_fact_TSV[i_s], vector<vector<double> > (distribution_no_qTcut.size(), vector<double> (distribution_no_bin_all[i_d].size() - 1, 0.)))); // could be done statically via oset (with maximum length osi_n_ps)
		vector<vector<vector<vector<double> > > > change_bin_weight2(osi_n_scale_ren_TSV[i_s], vector<vector<vector<double> > > (osi_n_scale_fact_TSV[i_s], vector<vector<double> > (distribution_no_qTcut.size(), vector<double> (distribution_no_bin_all[i_d].size() - 1, 0.)))); // could be done statically via oset (with maximum length osi_n_ps)
		vector<vector<vector<vector<double> > > > change_bin_weight_2nd(osi_n_scale_ren_TSV[i_s], vector<vector<vector<double> > > (osi_n_scale_fact_TSV[i_s], vector<vector<double> > (distribution_no_qTcut.size(), vector<double> (distribution_no_bin_all[i_d].size() - 1, 0.)))); // could be done statically via oset (with maximum length osi_n_ps)
		vector<vector<vector<vector<double> > > > change_bin_weight2_2nd(osi_n_scale_ren_TSV[i_s], vector<vector<vector<double> > > (osi_n_scale_fact_TSV[i_s], vector<vector<double> > (distribution_no_qTcut.size(), vector<double> (distribution_no_bin_all[i_d].size() - 1, 0.)))); // could be done statically via oset (with maximum length osi_n_ps)

		for (int i_r = 0; i_r < osi_n_scale_ren_TSV[i_s]; i_r++){
		  for (int i_f = 0; i_f < osi_n_scale_fact_TSV[i_s]; i_f++){
		    for (int i_b = 0; i_b < distribution_no_bin_all[i_d].size() - 1; i_b++){
		      for (int i_q = distribution_no_qTcut.size() - 1; i_q >= 0; i_q--){
			if (distribution_no_bin_no_qTcut_phasespace[i_d][i_b][i_q].size() > 0){
			  for (int i_a = 0; i_a < distribution_no_bin_no_qTcut_phasespace[i_d][i_b][i_q].size(); i_a++){
			    if (dat[i_d].symm == 0 || osi_type_parton[0][1] == osi_type_parton[0][2]){
			      change_bin_weight[i_r][i_f][i_q][i_b] += osi_ps_integrand_TSV[i_s][i_r][i_f][0][distribution_no_bin_no_qTcut_phasespace[i_d][i_b][i_q][i_a]];
			    }
			    else {
			      change_bin_weight[i_r][i_f][i_q][i_b] += osi_ps_integrand_TSV[i_s][i_r][i_f][1][distribution_no_bin_no_qTcut_phasespace[i_d][i_b][i_q][i_a]];
			      change_bin_weight_2nd[i_r][i_f][i_q][i_b] += osi_ps_integrand_TSV[i_s][i_r][i_f][2][distribution_no_bin_no_qTcut_phasespace[i_d][i_b][i_q][i_a]];
			    }
			  }
			  change_bin_weight2[i_r][i_f][i_q][i_b] = pow(change_bin_weight[i_r][i_f][i_q][i_b], 2);
			  if (!(dat[i_d].symm == 0 || osi_type_parton[0][1] == osi_type_parton[0][2])){
			    change_bin_weight2_2nd[i_r][i_f][i_q][i_b] = pow(change_bin_weight_2nd[i_r][i_f][i_q][i_b], 2);
			  }
			}	
			else if (change_bin_weight[i_r][i_f][i_q][i_b] == 0.){
			  // can happen in case of non-overlapping intervals, e.g. [0:3] v [7:21]
			}
			else {
			  logger << LOG_WARN << "osi_n_ps != 1   ---   dat[" << i_d << "].typeCumulative != CUMULATIVE_NONE   ---   Should not happen now!" << endl;
			  change_bin_weight[i_r][i_f][i_q][i_b] = change_bin_weight[i_r][i_f][i_q + 1][i_b];
			  change_bin_weight2[i_r][i_f][i_q][i_b] = change_bin_weight2[i_r][i_f][i_q + 1][i_b];
			  if (!(dat[i_d].symm == 0 || osi_type_parton[0][1] == osi_type_parton[0][2])){
			    change_bin_weight_2nd[i_r][i_f][i_q][i_b] = change_bin_weight_2nd[i_r][i_f][i_q + 1][i_b];
			    change_bin_weight2_2nd[i_r][i_f][i_q][i_b] = change_bin_weight2_2nd[i_r][i_f][i_q + 1][i_b];
			  }
			}
		      }
		    }
		    
		    for (int i_b = 0; i_b < distribution_no_bin_all[i_d].size() - 1; i_b++){
		      int i_b_min = distribution_no_bin_all[i_d][i_b];
		      int i_b_max = distribution_no_bin_all[i_d][i_b + 1];
		      for (int j_b = i_b_min; j_b < i_b_max; j_b++){
			int j_q = 0;
			int start_i_q = distribution_no_qTcut[0];
			for (int i_q = start_i_q; i_q < osi_output_n_qTcut; i_q++){
			  if (i_q > start_i_q && i_q == distribution_no_qTcut[j_q]){j_q++;}
			  osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_d][j_b] += change_bin_weight[i_r][i_f][distribution_no_qTcut[j_q]][i_b];
			  osi_bin_weight2_TSV[i_s][i_q][i_r][i_f][i_d][j_b] += change_bin_weight2[i_r][i_f][distribution_no_qTcut[j_q]][i_b];
			  if (!(dat[i_d].symm == 0 || osi_type_parton[0][1] == osi_type_parton[0][2])){
			    osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_d][dat[i_d].n_bins - 1 - j_b] += change_bin_weight_2nd[i_r][i_f][distribution_no_qTcut[j_q]][i_b];
			    osi_bin_weight2_TSV[i_s][i_q][i_r][i_f][i_d][dat[i_d].n_bins - 1 - j_b] += change_bin_weight2_2nd[i_r][i_f][distribution_no_qTcut[j_q]][i_b];
			  }
			  if (j_q == distribution_no_qTcut.size() - 1){break;}// ???
			}
		      }
		    }
		  }
		}
	      }
	    }
	    else {	      // if (dat[i_d].typeCumulative == CUMULATIVE_NONE)
	      // !!!
	      logger << LOG_DEBUG_VERBOSE << "before change_bin_weight:   i_d = " << i_d << "   here" << endl;
	      logger << LOG_DEBUG_VERBOSE << "before change_bin_weight:   distribution_no_qTcut.size() = " << distribution_no_qTcut.size() << endl;
	      logger << LOG_DEBUG_VERBOSE << "before change_bin_weight:   distribution_no_bin[" << i_d << "].size() = " << distribution_no_bin[i_d].size() << endl;
	      vector<vector<vector<vector<double> > > > change_bin_weight(osi_n_scale_ren_TSV[i_s], vector<vector<vector<double> > > (osi_n_scale_fact_TSV[i_s], vector<vector<double> > (distribution_no_qTcut.size(), vector<double> (distribution_no_bin[i_d].size(), 0.)))); // could be done statically via oset (with maximum length osi_n_ps)
	      vector<vector<vector<vector<double> > > > change_bin_weight2(osi_n_scale_ren_TSV[i_s], vector<vector<vector<double> > > (osi_n_scale_fact_TSV[i_s], vector<vector<double> > (distribution_no_qTcut.size(), vector<double> (distribution_no_bin[i_d].size(), 0.)))); // could be done statically via oset (with maximum length osi_n_ps)
	      vector<vector<vector<vector<double> > > > change_bin_weight_2nd(osi_n_scale_ren_TSV[i_s], vector<vector<vector<double> > > (osi_n_scale_fact_TSV[i_s], vector<vector<double> > (distribution_no_qTcut.size(), vector<double> (distribution_no_bin[i_d].size(), 0.)))); // could be done statically via oset (with maximum length osi_n_ps)
	      vector<vector<vector<vector<double> > > > change_bin_weight2_2nd(osi_n_scale_ren_TSV[i_s], vector<vector<vector<double> > > (osi_n_scale_fact_TSV[i_s], vector<vector<double> > (distribution_no_qTcut.size(), vector<double> (distribution_no_bin[i_d].size(), 0.)))); // could be done statically via oset (with maximum length osi_n_ps)

	      for (int i_r = 0; i_r < osi_n_scale_ren_TSV[i_s]; i_r++){
		for (int i_f = 0; i_f < osi_n_scale_fact_TSV[i_s]; i_f++){
		  // 1st: asymmetric (no symmetry wrt. rotating the positive beam axis to the negative one and vice versa) distribution
		  // 2nd: identical initial-state partons -> no contribution from rotated point (double-counting)
		  for (int i_b = 0; i_b < distribution_no_bin[i_d].size(); i_b++){
		    for (int i_q = distribution_no_qTcut.size() - 1; i_q >= 0; i_q--){
		      //		    {int i_q = 0;
		      // !!! change to fix bug !!!
		      if (i_q < distribution_no_qTcut.size() - 1){
			// start with weight from higher qTcut values:
			change_bin_weight[i_r][i_f][i_q][i_b] = change_bin_weight[i_r][i_f][i_q + 1][i_b];
			change_bin_weight_2nd[i_r][i_f][i_q][i_b] = change_bin_weight_2nd[i_r][i_f][i_q + 1][i_b];
		      }
		      // !!! change to fix bug end !!!
		      if (i_d == 0 && i_r == 0 && i_f == 0){
			logger << LOG_DEBUG_VERBOSE << "change_bin_weight:   distribution_no_qTcut[" << i_q << "] = " << distribution_no_qTcut[i_q] << endl;
		      }
		      if (i_d == 0 && i_r == 0 && i_f == 0){
			logger << LOG_DEBUG_VERBOSE << "distribution_no_bin_no_qTcut_phasespace[" << i_d << "][" << i_b << "][" << i_q << "].size() = " << distribution_no_bin_no_qTcut_phasespace[i_d][i_b][i_q].size() << endl;
		      }
		      if (distribution_no_bin_no_qTcut_phasespace[i_d][i_b][i_q].size() > 0){
			for (int i_a = 0; i_a < distribution_no_bin_no_qTcut_phasespace[i_d][i_b][i_q].size(); i_a++){
			  if (dat[i_d].symm == 0 || osi_type_parton[0][1] == osi_type_parton[0][2]){
			    //			    logger << LOG_DEBUG_VERBOSE << "distribution_no_bin_no_qTcut_phasespace[" << i_d << "][" << i_b << "][" << i_q << "][" << i_q << "] = " << distribution_no_bin_no_qTcut_phasespace[i_d][i_b][i_q][i_a] << endl;
			    change_bin_weight[i_r][i_f][i_q][i_b] += osi_ps_integrand_TSV[i_s][i_r][i_f][0][distribution_no_bin_no_qTcut_phasespace[i_d][i_b][i_q][i_a]];
			    if (i_d == 0 && i_r == 0 && i_f == 0){
			      logger << LOG_DEBUG_VERBOSE << "osi_ps_integrand_TSV[" << i_s << "][" << i_r << "][" << i_f << "][0][distribution_no_bin_no_qTcut_phasespace[" << i_d << "][" << i_b << "][" << i_q << "][" << i_a << "] = " << distribution_no_bin_no_qTcut_phasespace[i_d][i_b][i_q][i_a] << "] = " << osi_ps_integrand_TSV[i_s][i_r][i_f][0][distribution_no_bin_no_qTcut_phasespace[i_d][i_b][i_q][i_a]] << endl;
			    }
			  }
			  else {
			    
			    // !!!
			    if (i_d == 0 && i_r == 0 && i_f == 0){
			      logger << LOG_DEBUG_VERBOSE << "distribution_no_bin_no_qTcut_phasespace[i_d = " << i_d << "][no_b = " << i_b << "][no_q = " << i_q << "][no_a = " << i_a << "] = " << distribution_no_bin_no_qTcut_phasespace[i_d][i_b][i_q][i_a] << endl;
			      logger << LOG_DEBUG_VERBOSE << "change_bin_weight[0][0][no_q = " << i_q << "][no_a = " << i_a << "]   changed" << endl;
			    }
			    
			    change_bin_weight[i_r][i_f][i_q][i_b] += osi_ps_integrand_TSV[i_s][i_r][i_f][1][distribution_no_bin_no_qTcut_phasespace[i_d][i_b][i_q][i_a]];
			    change_bin_weight_2nd[i_r][i_f][i_q][i_b] += osi_ps_integrand_TSV[i_s][i_r][i_f][2][distribution_no_bin_no_qTcut_phasespace[i_d][i_b][i_q][i_a]];
			  }
			  logger << LOG_DEBUG_VERBOSE << "i_a = " << i_a << endl;

			}
			change_bin_weight2[i_r][i_f][i_q][i_b] = pow(change_bin_weight[i_r][i_f][i_q][i_b], 2);
			if (!(dat[i_d].symm == 0 || osi_type_parton[0][1] == osi_type_parton[0][2])){
			  change_bin_weight2_2nd[i_r][i_f][i_q][i_b] = pow(change_bin_weight_2nd[i_r][i_f][i_q][i_b], 2);
			}
		      }
		      else if (change_bin_weight[i_r][i_f][i_q][i_b] == 0.){logger << LOG_DEBUG_VERBOSE << "Why would this happen ???" << endl;}
		      else {
			//logger << LOG_WARN << "osi_n_ps != 1   ---   dat[" << i_d << "].typeCumulative == CUMULATIVE_NONE   ---   Should not happen now!" << endl;
			// I guess this should be removed (would never happen) !!!
			if (i_d == 0 && i_r == 0 && i_f == 0){
			  logger << LOG_DEBUG_VERBOSE << "distribution_no_bin_no_qTcut_phasespace[" << i_d << "][" << i_b << "][" << i_q << "].size() = " << distribution_no_bin_no_qTcut_phasespace[i_d][i_b][i_q].size() << endl;
			}
			double temp = change_bin_weight[i_r][i_f][i_q][i_b];
			change_bin_weight[i_r][i_f][i_q][i_b] = change_bin_weight[i_r][i_f][i_q + 1][i_b];
			change_bin_weight2[i_r][i_f][i_q][i_b] = change_bin_weight2[i_r][i_f][i_q + 1][i_b];
			if (!(dat[i_d].symm == 0 || osi_type_parton[0][1] == osi_type_parton[0][2])){
			  change_bin_weight_2nd[i_r][i_f][i_q][i_b] = change_bin_weight_2nd[i_r][i_f][i_q + 1][i_b];
			  change_bin_weight2_2nd[i_r][i_f][i_q][i_b] = change_bin_weight2_2nd[i_r][i_f][i_q + 1][i_b];
			}
			if (temp != change_bin_weight[i_r][i_f][i_q][i_b]){
			  logger << LOG_DEBUG_VERBOSE << "change_bin_weight[" << i_r << "][" << i_f << "][" << i_q << "][" << i_b << "] = " << temp << " --> " << change_bin_weight[i_r][i_f][i_q][i_b] << endl;
			}
		      }
		      logger << LOG_DEBUG_VERBOSE << "i_q = " << i_q << endl;
		    }
		    logger << LOG_DEBUG_VERBOSE << "i_b = " << i_b << endl;
		  }
		  for (int i_b = 0; i_b < distribution_no_bin[i_d].size(); i_b++){
		    logger << LOG_DEBUG_VERBOSE << "i_b = " << i_b << endl;

		    /*
		      e.g.:
		      distribution_no_qTcut[0] = 7
		      distribution_no_qTcut[1] = 15
		      -->
		      i_q = 0 - 7: osi_bin_weight_TSV[i_q] = distribution_no_qTcut[0]
		      i_q = 8 - 15: osi_bin_weight_TSV[i_q] = distribution_no_qTcut[1]
		      i_q = 16 - osi_output_n_qTcut: osi_bin_weight_TSV[i_q] = 0
		     */

		    int j_q = 0;
		    //			int start_i_q = distribution_no_qTcut[0];
		    for (int i_q = 0; i_q < osi_output_n_qTcut; i_q++){
		      //		      if (j_q < distribution_no_qTcut.size()){
//		      }
		      if (i_d == 0 && i_r == 0 && i_f == 0){
			//			logger << LOG_DEBUG << " distribution_no_qTcut[" << j_q << "] = " <<  distribution_no_qTcut[j_q] << endl;
			logger << LOG_DEBUG_VERBOSE << "i_q = " << setw(3) << i_q << "   change_bin_weight[" << i_r << "][" << i_f << "][j_q = " << j_q << "][" << i_b << "] = " << change_bin_weight[i_r][i_f][j_q][i_b] << endl;
		      }
		      osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_d][distribution_no_bin[i_d][i_b]] += change_bin_weight[i_r][i_f][j_q][i_b];
		      osi_bin_weight2_TSV[i_s][i_q][i_r][i_f][i_d][distribution_no_bin[i_d][i_b]] += change_bin_weight2[i_r][i_f][j_q][i_b];

		      //		      if (i_d == 0 && i_r == 1 && i_f == 1 && (i_q == 7 || i_q == 8 || i_q == 9)){logger << LOG_INFO << "i_q = " << i_q << "   " << change_bin_weight[i_r][i_f][j_q][i_b] << "   " << osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_d][distribution_no_bin[i_d][i_b]] << endl;}

		      if (!(dat[i_d].symm == 0 || osi_type_parton[0][1] == osi_type_parton[0][2])){
			osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_d][dat[i_d].n_bins - 1 - distribution_no_bin[i_d][i_b]] += change_bin_weight_2nd[i_r][i_f][j_q][i_b];
			osi_bin_weight2_TSV[i_s][i_q][i_r][i_f][i_d][dat[i_d].n_bins - 1 - distribution_no_bin[i_d][i_b]] += change_bin_weight2_2nd[i_r][i_f][j_q][i_b];
		      }
		      //		      logger << LOG_DEBUG << " distribution_no_qTcut[" << j_q << "] = " <<  distribution_no_qTcut[j_q] << endl;
		      if (i_q == distribution_no_qTcut[j_q]){j_q++;}
		      //		      logger << LOG_DEBUG_VERBOSE << " distribution_no_qTcut[" << j_q << "] = "
		      if (j_q == distribution_no_qTcut.size()){break;}
		    }
		    logger << LOG_DEBUG_VERBOSE << "break   j_q = " << j_q << endl;




		    /*
		    int i_q = 0;
		    int j_q = 0;
		    // cannot work for different qTcut values, I guess...
		    osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_d][distribution_no_bin[i_d][i_b]] += change_bin_weight[i_r][i_f][j_q][i_b];
		    osi_bin_weight2_TSV[i_s][i_q][i_r][i_f][i_d][distribution_no_bin[i_d][i_b]] += change_bin_weight2[i_r][i_f][j_q][i_b];
		    logger << LOG_DEBUG_VERBOSE << "dat[" << i_d << "].symm = " << dat[i_d].symm << endl;
		    if (!(dat[i_d].symm == 0 || osi_type_parton[0][1] == osi_type_parton[0][2])){
		      osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_d][dat[i_d].n_bins - 1 - distribution_no_bin[i_d][i_b]] += change_bin_weight_2nd[i_r][i_f][j_q][i_b];
		      osi_bin_weight2_TSV[i_s][i_q][i_r][i_f][i_d][dat[i_d].n_bins - 1 - distribution_no_bin[i_d][i_b]] += change_bin_weight2_2nd[i_r][i_f][j_q][i_b];
		    }
		    */
		    
		    /*
		    int j_q = 0;
		    int start_i_q = 0;
		    //		    int start_i_q = distribution_no_qTcut[0];
		    for (int i_q = start_i_q; i_q < distribution_no_qTcut[distribution_no_qTcut.size() - 1]; i_q++){
		      //		    for (int i_q = start_i_q; i_q < osi_output_n_qTcut; i_q++){
		      logger << LOG_DEBUG_VERBOSE << "i_q = " << i_q << endl;
		      if (i_q > start_i_q && i_q == distribution_no_qTcut[j_q]){j_q++;}
		      logger << LOG_DEBUG_VERBOSE << "j_q = " << j_q << endl;
		      logger << LOG_DEBUG_VERBOSE << "osi_bin_weight_TSV[" << i_s << "].size() = " << osi_bin_weight_TSV[i_s].size() << endl;
		      logger << LOG_DEBUG_VERBOSE << "osi_bin_weight_TSV[" << i_s << "][" << i_q << "].size() = " << osi_bin_weight_TSV[i_s][i_q].size() << endl;
		      logger << LOG_DEBUG_VERBOSE << "osi_bin_weight_TSV[" << i_s << "][" << i_q << "][" << i_r << "].size() = " << osi_bin_weight_TSV[i_s][i_q][i_r].size() << endl;
		      logger << LOG_DEBUG_VERBOSE << "osi_bin_weight_TSV[" << i_s << "][" << i_q << "][" << i_r << "][" << i_f << "].size() = " << osi_bin_weight_TSV[i_s][i_q][i_r][i_f].size() << endl;
		      logger << LOG_DEBUG_VERBOSE << "osi_bin_weight_TSV[" << i_s << "][" << i_q << "][" << i_r << "][" << i_f << "][" << i_b << "].size() = " << osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_d].size() << endl;
		      logger << LOG_DEBUG_VERBOSE << "osi_bin_weight2_TSV[" << i_s << "].size() = " << osi_bin_weight2_TSV[i_s].size() << endl;
		      logger << LOG_DEBUG_VERBOSE << "osi_bin_weight2_TSV[" << i_s << "][" << i_q << "].size() = " << osi_bin_weight2_TSV[i_s][i_q].size() << endl;
		      logger << LOG_DEBUG_VERBOSE << "osi_bin_weight2_TSV[" << i_s << "][" << i_q << "][" << i_r << "].size() = " << osi_bin_weight2_TSV[i_s][i_q][i_r].size() << endl;
		      logger << LOG_DEBUG_VERBOSE << "osi_bin_weight2_TSV[" << i_s << "][" << i_q << "][" << i_r << "][" << i_f << "].size() = " << osi_bin_weight2_TSV[i_s][i_q][i_r][i_f].size() << endl;
		      logger << LOG_DEBUG_VERBOSE << "osi_bin_weight2_TSV[" << i_s << "][" << i_q << "][" << i_r << "][" << i_f << "][" << i_b << "].size() = " << osi_bin_weight2_TSV[i_s][i_q][i_r][i_f][i_d].size() << endl;
		      logger << LOG_DEBUG_VERBOSE << "distribution_no_bin[" << i_d << "][" << i_b << "] = " << distribution_no_bin[i_d][i_b] << endl;

		      logger << LOG_DEBUG_VERBOSE << "j_q = " << j_q << endl;
		      logger << LOG_DEBUG_VERBOSE << "distribution_no_qTcut.size() = " << distribution_no_qTcut.size() << endl;
		      //		      logger << LOG_DEBUG_VERBOSE << "distribution_no_qTcut[" << j_q << "] = " << distribution_no_qTcut[j_q] << endl;
			  logger << LOG_DEBUG_VERBOSE << "change_bin_weight.size() = " << change_bin_weight.size() << endl;
			  logger << LOG_DEBUG_VERBOSE << "change_bin_weight[" << i_r << "].size() = " << change_bin_weight[i_r].size() << endl;
			  logger << LOG_DEBUG_VERBOSE << "change_bin_weight[" << i_r << "][" << i_f << "].size() = " << change_bin_weight[i_r][i_f].size() << endl;
			  logger << LOG_DEBUG_VERBOSE << "change_bin_weight[" << i_r << "][" << i_f << "][" << i_q << "].size() = " << change_bin_weight[i_r][i_f][i_q].size() << endl;
			  logger << LOG_DEBUG_VERBOSE << "change_bin_weight_2nd.size() = " << change_bin_weight_2nd.size() << endl;
			  logger << LOG_DEBUG_VERBOSE << "change_bin_weight_2nd[" << i_r << "].size() = " << change_bin_weight_2nd[i_r].size() << endl;
			  logger << LOG_DEBUG_VERBOSE << "change_bin_weight_2nd[" << i_r << "][" << i_f << "].size() = " << change_bin_weight_2nd[i_r][i_f].size() << endl;
			  logger << LOG_DEBUG_VERBOSE << "change_bin_weight_2nd[" << i_r << "][" << i_f << "][" << j_q << "].size() = " << change_bin_weight_2nd[i_r][i_f][j_q].size() << endl;
		      osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_d][distribution_no_bin[i_d][i_b]] += change_bin_weight[i_r][i_f][j_q][i_b];
		      osi_bin_weight2_TSV[i_s][i_q][i_r][i_f][i_d][distribution_no_bin[i_d][i_b]] += change_bin_weight2[i_r][i_f][j_q][i_b];
		      logger << LOG_DEBUG_VERBOSE << "dat[" << i_d << "].symm = " << dat[i_d].symm << endl;
		      if (!(dat[i_d].symm == 0 || osi_type_parton[0][1] == osi_type_parton[0][2])){
			osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_d][dat[i_d].n_bins - 1 - distribution_no_bin[i_d][i_b]] += change_bin_weight_2nd[i_r][i_f][j_q][i_b];
			osi_bin_weight2_TSV[i_s][i_q][i_r][i_f][i_d][dat[i_d].n_bins - 1 - distribution_no_bin[i_d][i_b]] += change_bin_weight2_2nd[i_r][i_f][j_q][i_b];
		      }
		      
		      //		      osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_d][distribution_no_bin[i_d][i_b]] += change_bin_weight[i_r][i_f][distribution_no_qTcut[j_q]][i_b];
		      //		      osi_bin_weight2_TSV[i_s][i_q][i_r][i_f][i_d][distribution_no_bin[i_d][i_b]] += change_bin_weight2[i_r][i_f][distribution_no_qTcut[j_q]][i_b];
		      //		      logger << LOG_DEBUG_VERBOSE << "dat[" << i_d << "].symm = " << dat[i_d].symm << endl;
		      //		      if (!(dat[i_d].symm == 0 || osi_type_parton[0][1] == osi_type_parton[0][2])){
		      //			osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_d][dat[i_d].n_bins - 1 - distribution_no_bin[i_d][i_b]] += change_bin_weight_2nd[i_r][i_f][distribution_no_qTcut[j_q]][i_b];
		      //			osi_bin_weight2_TSV[i_s][i_q][i_r][i_f][i_d][dat[i_d].n_bins - 1 - distribution_no_bin[i_d][i_b]] += change_bin_weight2_2nd[i_r][i_f][distribution_no_qTcut[j_q]][i_b];
		      //		      }
		      
		      logger << LOG_DEBUG_VERBOSE << "dat[" << i_d << "].symm = " << dat[i_d].symm << endl;
		      if (j_q == distribution_no_qTcut.size() - 1){break;}// ???
		      logger << LOG_DEBUG_VERBOSE << "i_q = " << i_q << endl;
		      }
		    */
		  
		  }
		}
	      }
	    }
	  }
	  logger << LOG_DEBUG_VERBOSE << "osi_n_ps != 1:   2nd step   dat[" << i_d << "] = " << dat[i_d].xdistribution_name << " done" << endl;
	}
      }
    }
    /*
    // Should be introduced !!!
  }
}
void determine_dddistribution_TSV(vector<vector<int> > & bin, vector<vector<int> > & bin_max, vector<distribution> & dat, observable_set & oset){
  static Logger logger("determine_dddistribution_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (osi_switch_distribution_at_all_TSV == 1){
    */
    logger << LOG_DEBUG_VERBOSE << "determine_dddistribution_TSV" << endl;
  
    if (osi_n_ps == 1){
      for (int i_d = 0; i_d < osi_dddat.size(); i_d++){
	int i_ddd = dat.size() + i_d;
	if ((osi_dddat[i_d].distribution_1).typeCumulative != CUMULATIVE_NONE || (osi_dddat[i_d].distribution_2).typeCumulative != CUMULATIVE_NONE){
	}
	else {
	  if (bin[i_ddd][0] != -1){
	    distribution_no_bin[i_ddd].resize(1, bin[i_ddd][0]);
	    //	  distribution_no_bin[i_ddd] = bin[i_ddd]; // could still be -1 --- does the same ???
	    distribution_no_bin_phasespace[i_ddd].resize(1, vector<int> (1, 0)); // -> (1, 0) only 1 phasespace, namely 0; resize(1, ...) -> only 1 bin
	    distribution_no_qTcut_phasespace.resize(1, vector<int> (1, 0)); // -> (1, 0) only 1 phasespace value, namely 0; resize(1, ...) -> only 1 qTcut value
	    distribution_no_bin_no_qTcut_phasespace[i_ddd].resize(1, vector<vector<int> > (1, vector<int> (1, 0)));
	    logger << LOG_DEBUG_VERBOSE << "osi_cut_ps[0] = " << osi_cut_ps[0] << endl;
	    logger << LOG_DEBUG_VERBOSE << "osi_bin_count_TSV.size() = " << osi_bin_count_TSV.size() << endl;

	    for (int i_q = 0; i_q <= osi_cut_ps[0]; i_q++){osi_bin_count_TSV[i_q][i_ddd][bin[i_ddd][0]]++;}// ??? < or <= ???  // mirrored contributions ???
	    //	    for (int i_q = 0; i_q <= osi_cut_ps[0]; i_q++){logger << LOG_DEBUG_VERBOSE << "i_q = " << i_q << endl; osi_bin_count_TSV[i_q][i_ddd][bin[i_ddd][0]]++;}// ??? < or <= ???  // mirrored contributions ???
	    logger << LOG_DEBUG_VERBOSE << "osi_bin_count_TSV.size() = " << osi_bin_count_TSV.size() << endl;
	  }
	}
      }
    }
    else {
      /*  
      logger << LOG_DEBUG_VERBOSE << "osi_n_ps != 1" << endl;
      logger << LOG_DEBUG_VERBOSE << "distribution_no_qTcut.size() = " << distribution_no_qTcut.size() << endl;
      for (int i_q = 0; i_q < distribution_no_qTcut.size(); i_q++){logger << LOG_DEBUG_VERBOSE << "distribution_no_qTcut[" << i_q << "] = " << distribution_no_qTcut[i_q] << endl;}
      // i_q > 0, because the 0 entry always remains unchanged!

      sort(distribution_no_qTcut.begin(), distribution_no_qTcut.end());
      for (int i_q = 0; i_q < distribution_no_qTcut.size(); i_q++){logger << LOG_DEBUG_VERBOSE << "distribution_no_qTcut[" << i_q << "] = " << distribution_no_qTcut[i_q] << endl;}
      for (int i_q = osi_n_ps - 1; i_q > 0; i_q--){  // i_q > 0, because the 0 entry always remains unchanged!
	if (distribution_no_qTcut[i_q] == distribution_no_qTcut[i_q - 1]){distribution_no_qTcut.erase(distribution_no_qTcut.begin() + i_q);}
      }
      logger << LOG_DEBUG_VERBOSE << "distribution_no_qTcut.size() = " << distribution_no_qTcut.size() << endl;
      if (distribution_no_qTcut[0] == -1){distribution_no_qTcut.erase(distribution_no_qTcut.begin());}
      logger << LOG_DEBUG_VERBOSE << "distribution_no_qTcut.size() = " << distribution_no_qTcut.size() << endl;
      for (int i_q = 0; i_q < distribution_no_qTcut.size(); i_q++){logger << LOG_DEBUG_VERBOSE << "distribution_no_qTcut[" << i_q << "] = " << distribution_no_qTcut[i_q] << endl;}

      distribution_no_qTcut_phasespace.resize(distribution_no_qTcut.size());
      for (int i_a = 0; i_a < osi_n_ps; i_a++){
	for (int i_q = 0; i_q < distribution_no_qTcut.size(); i_q++){
	  if (distribution_no_qTcut[i_q] == osi_cut_ps[i_a]){distribution_no_qTcut_phasespace[i_q].push_back(i_a);}
	}
      }
      */
      //  distribution_no_qTcut
      //  distribution_no_qTcut_phasespace
      //  should already be available !

      for (int i_d = 0; i_d < osi_dddat.size(); i_d++){
	int i_ddd = dat.size() + i_d;
	if ((osi_dddat[i_d].distribution_1).typeCumulative != CUMULATIVE_NONE || (osi_dddat[i_d].distribution_2).typeCumulative != CUMULATIVE_NONE){
	}
	else {
	  distribution_no_bin[i_ddd] = bin[i_ddd];
	  sort(distribution_no_bin[i_ddd].begin(), distribution_no_bin[i_ddd].end());
	  for (int i_b = osi_n_ps - 1; i_b > 0; i_b--){
	    if (distribution_no_bin[i_ddd][i_b] == distribution_no_bin[i_ddd][i_b - 1]){distribution_no_bin[i_ddd].erase(distribution_no_bin[i_ddd].begin() + i_b);}
	  }
	  if (distribution_no_bin[i_ddd][0] == -1){distribution_no_bin[i_ddd].erase(distribution_no_bin[i_ddd].begin());}
	  
	  distribution_no_bin_phasespace[i_ddd].resize(distribution_no_bin[i_ddd].size());
	  for (int i_a = 0; i_a < osi_n_ps; i_a++){
	    for (int i_b = 0; i_b < distribution_no_bin[i_ddd].size(); i_b++){
	      if (distribution_no_bin[i_ddd][i_b] == bin[i_ddd][i_a]){distribution_no_bin_phasespace[i_ddd][i_b].push_back(i_a); break;}
	    }
	  }
	  
	  distribution_no_bin_no_qTcut_phasespace[i_ddd].resize(distribution_no_bin[i_ddd].size(), vector<vector<int> > (distribution_no_qTcut.size()));
	  for (int i_b = 0; i_b < distribution_no_bin[i_ddd].size(); i_b++){
	    for (int i_q = 0; i_q < distribution_no_qTcut.size(); i_q++){
	      for (int i_ba = 0; i_ba < distribution_no_bin_phasespace[i_ddd][i_b].size(); i_ba++){
		for (int i_qa = 0; i_qa < distribution_no_qTcut_phasespace[i_q].size(); i_qa++){
		  if (distribution_no_bin_phasespace[i_ddd][i_b][i_ba] == distribution_no_qTcut_phasespace[i_q][i_qa]){
		    distribution_no_bin_no_qTcut_phasespace[i_ddd][i_b][i_q].push_back(distribution_no_bin_phasespace[i_ddd][i_b][i_ba]);
		    osi_bin_count_TSV[i_q][i_ddd][bin[i_ddd][distribution_no_bin_phasespace[i_ddd][i_b][i_ba]]]++;
		  }
		}
	      }
	    }
	  }
	}
      }
    }


    for (int i_s = 0; i_s < osi_n_set_TSV; i_s++){
      logger << LOG_DEBUG_VERBOSE << "i_s = " << i_s << endl;
      if (osi_switch_distribution_TSV[i_s] > 0){
	for (int i_d = 0; i_d < osi_dddat.size(); i_d++){
	  int i_ddd = dat.size() + i_d;

	  logger << LOG_DEBUG_VERBOSE << "i_d = " << i_d << endl;
	  if (osi_n_ps == 1){
	    {
	      if (bin[i_ddd][0] != -1){
		vector<vector<double> > change_bin_weight(osi_n_scale_ren_TSV[i_s], vector<double> (osi_n_scale_fact_TSV[i_s], 0.));
		vector<vector<double> > change_bin_weight2(osi_n_scale_ren_TSV[i_s], vector<double> (osi_n_scale_fact_TSV[i_s], 0.));
		vector<vector<double> > change_bin_weight_2nd(osi_n_scale_ren_TSV[i_s], vector<double> (osi_n_scale_fact_TSV[i_s], 0.));
		vector<vector<double> > change_bin_weight2_2nd(osi_n_scale_ren_TSV[i_s], vector<double> (osi_n_scale_fact_TSV[i_s], 0.));
		for (int i_r = 0; i_r < osi_n_scale_ren_TSV[i_s]; i_r++){
		  for (int i_f = 0; i_f < osi_n_scale_fact_TSV[i_s]; i_f++){
		    // i_b -> only one bin: bin[i_ddd][0]
		    // i_q -> only one qTcut: osi_cut_ps[0]

		    //	if ((osi_dddat[i_d].distribution_1).xdistribution_number > 100 || (osi_dddat[i_d].distribution_2).xdistribution_number > 100){
		    int mirror_bin = -1;
		    if (osi_type_parton[0][1] == osi_type_parton[0][2] || ((osi_dddat[i_d].distribution_1).symm == 0 && (osi_dddat[i_d].distribution_2).symm == 0)){
		      change_bin_weight[i_r][i_f] = osi_ps_integrand_TSV[i_s][i_r][i_f][0][0];
		      change_bin_weight2[i_r][i_f] = pow(change_bin_weight[i_r][i_f], 2);
		    }
		    else {
		      if (((osi_dddat[i_d].distribution_1).symm == 0) && ((osi_dddat[i_d].distribution_2).symm == 0)){ // asymmetric distribution 1, asymmetric distribution 2
			mirror_bin = bin[i_ddd][0];
		      }
		      else if (((osi_dddat[i_d].distribution_1).symm == 0) && ((osi_dddat[i_d].distribution_2).symm == 1)){ // asymmetric distribution 1, symmetric distribution 2
			mirror_bin = bin[osi_dddat[i_d].d_1][0] * (osi_dddat[i_d].distribution_2).n_bins + ((osi_dddat[i_d].distribution_2).n_bins - 1 - bin[osi_dddat[i_d].d_2][0]);
		      }
		      else if (((osi_dddat[i_d].distribution_1).symm == 1) && ((osi_dddat[i_d].distribution_2).symm == 0)){ // symmetric distribution 1, asymmetric distribution 2
			mirror_bin = ((osi_dddat[i_d].distribution_1).n_bins - 1 - bin[osi_dddat[i_d].d_1][0]) * (osi_dddat[i_d].distribution_2).n_bins + bin[osi_dddat[i_d].d_2][0];
		      }
		      else if (((osi_dddat[i_d].distribution_1).symm == 1) && ((osi_dddat[i_d].distribution_2).symm == 1)){ // symmetric distribution 1, symmetric distribution 2
			mirror_bin = osi_dddat[i_d].n_bins - 1 - bin[i_ddd][0];
			// mirror_bin ?????
		      }
		      //		      bin_value[i_ddd][mirror_bin] += integrand_D[2][0];
		      //		      if (switch_bin_count == 1){bin_counts[i_ddd][mirror_bin]++;}


		      change_bin_weight[i_r][i_f] = osi_ps_integrand_TSV[i_s][i_r][i_f][1][0];
		      change_bin_weight2[i_r][i_f] = pow(change_bin_weight[i_r][i_f], 2);
		      change_bin_weight_2nd[i_r][i_f] = osi_ps_integrand_TSV[i_s][i_r][i_f][2][0];
		      change_bin_weight2_2nd[i_r][i_f] = pow(change_bin_weight_2nd[i_r][i_f], 2);
		    }

		    //		    osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_d][dat[i_d].n_bins - 1 - distribution_no_bin[i_d][i_b]] += change_bin_weight_2nd[i_r][i_f][j_q][i_b];
		    //		    osi_bin_weight2_TSV[i_s][i_q][i_r][i_f][i_d][dat[i_d].n_bins - 1 - distribution_no_bin[i_d][i_b]] += change_bin_weight2_2nd[i_r][i_f][j_q][i_b];


		    for (int i_q = 0; i_q <= osi_cut_ps[0]; i_q++){
		      int min = 0, max = 0;
		      ///		      if (osi_dddat[i_d].xdistribution_number > 100){min = distribution_no_bin[i_ddd][0]; max = distribution_no_bin_max[i_ddd][0];}
		      ///		      else if (osi_dddat[i_d].xdistribution_number > 0){min = distribution_no_bin[i_ddd][0]; max = distribution_no_bin[i_ddd][0] + 1;}
		      if ((osi_dddat[i_d].distribution_1).typeCumulative != CUMULATIVE_NONE || (osi_dddat[i_d].distribution_2).typeCumulative != CUMULATIVE_NONE){
		      }
		      else {
			min = distribution_no_bin[i_ddd][0]; max = distribution_no_bin[i_ddd][0] + 1;
		      }
		      for (int i_b = min; i_b < max; i_b++){ // was '<=' before !!!
			osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_ddd][i_b] += change_bin_weight[i_r][i_f];
			osi_bin_weight2_TSV[i_s][i_q][i_r][i_f][i_ddd][i_b] += change_bin_weight2[i_r][i_f];
			if (!(osi_type_parton[0][1] == osi_type_parton[0][2] || ((osi_dddat[i_d].distribution_1).symm == 0 && (osi_dddat[i_d].distribution_2).symm == 0))){
			  osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_ddd][mirror_bin] += change_bin_weight_2nd[i_r][i_f];
			  osi_bin_weight2_TSV[i_s][i_q][i_r][i_f][i_ddd][mirror_bin] += change_bin_weight2_2nd[i_r][i_f];
			}
		      }
		      // !!! adpat to ... < max !!!
		    }






		    /*
		    // calculate change_bin_weight !!!
		    //		for (int i_q = 0; i_q <= osi_cut_ps[0]; i_q++){ // !!! check '<' or '<=' !!! 2nd ?
		    for (int i_q = 0; i_q <= osi_cut_ps[0]; i_q++){
		      int min, max;
		      if (dat[i_d].xdistribution_number > 100){min = distribution_no_bin[i_d][0]; max = distribution_no_bin_max[i_d][0];}
		      else if (dat[i_d].xdistribution_number > 0){min = distribution_no_bin[i_d][0]; max = distribution_no_bin[i_d][0] + 1;}
		      for (int i_b = min; i_b < max; i_b++){ // was '<=' before !!!
			osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_d][i_b] += change_bin_weight[i_r][i_f];
			osi_bin_weight2_TSV[i_s][i_q][i_r][i_f][i_d][i_b] += change_bin_weight2[i_r][i_f];
			if (!(dat[i_d].symm == 0 || osi_type_parton[0][1] == osi_type_parton[0][2])){
			  osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_d][dat[i_d].n_bins - 1 - i_b] += change_bin_weight_2nd[i_r][i_f];
			  osi_bin_weight2_TSV[i_s][i_q][i_r][i_f][i_d][dat[i_d].n_bins - 1 - i_b] += change_bin_weight2_2nd[i_r][i_f];
			}
		      }
		      // !!! adpat to ... < max !!!
		    }
		    */
		  }
		}
	      }
	    }
	  }
	
 	  
	  else {
	    logger << LOG_DEBUG_VERBOSE << "osi_n_ps != 1:   2nd step   dddat[" << i_d << " - " << i_ddd << "] = " << osi_dddat[i_d].name << endl;
	    if ((osi_dddat[i_d].distribution_1).typeCumulative != CUMULATIVE_NONE || (osi_dddat[i_d].distribution_2).typeCumulative != CUMULATIVE_NONE){
        // FIXME ???
	    }
	    else {
	      vector<vector<vector<vector<double> > > > change_bin_weight(osi_n_scale_ren_TSV[i_s], vector<vector<vector<double> > > (osi_n_scale_fact_TSV[i_s], vector<vector<double> > (distribution_no_qTcut.size(), vector<double> (distribution_no_bin[i_ddd].size(), 0.)))); // could be done statically via oset (with maximum length osi_n_ps)
	      vector<vector<vector<vector<double> > > > change_bin_weight2(osi_n_scale_ren_TSV[i_s], vector<vector<vector<double> > > (osi_n_scale_fact_TSV[i_s], vector<vector<double> > (distribution_no_qTcut.size(), vector<double> (distribution_no_bin[i_ddd].size(), 0.)))); // could be done statically via oset (with maximum length osi_n_ps)
	      vector<vector<vector<vector<double> > > > change_bin_weight_2nd(osi_n_scale_ren_TSV[i_s], vector<vector<vector<double> > > (osi_n_scale_fact_TSV[i_s], vector<vector<double> > (distribution_no_qTcut.size(), vector<double> (distribution_no_bin[i_ddd].size(), 0.)))); // could be done statically via oset (with maximum length osi_n_ps)
	      vector<vector<vector<vector<double> > > > change_bin_weight2_2nd(osi_n_scale_ren_TSV[i_s], vector<vector<vector<double> > > (osi_n_scale_fact_TSV[i_s], vector<vector<double> > (distribution_no_qTcut.size(), vector<double> (distribution_no_bin[i_ddd].size(), 0.)))); // could be done statically via oset (with maximum length osi_n_ps)

	      for (int i_r = 0; i_r < osi_n_scale_ren_TSV[i_s]; i_r++){
		for (int i_f = 0; i_f < osi_n_scale_fact_TSV[i_s]; i_f++){
		  // 1st: asymmetric (no symmetry wrt. rotating the positive beam axis to the negative one and vice versa) distribution
		  // 2nd: identical initial-state partons -> no contribution from rotated point (double-counting)
		  for (int i_b = 0; i_b < distribution_no_bin[i_ddd].size(); i_b++){
		    for (int i_q = distribution_no_qTcut.size() - 1; i_q >= 0; i_q--){
		      //		    {int i_q = 0;
		      if (distribution_no_bin_no_qTcut_phasespace[i_ddd][i_b][i_q].size() > 0){
			for (int i_a = 0; i_a < distribution_no_bin_no_qTcut_phasespace[i_ddd][i_b][i_q].size(); i_a++){
			  if (osi_type_parton[0][1] == osi_type_parton[0][2] || ((osi_dddat[i_d].distribution_1).symm == 0 && (osi_dddat[i_d].distribution_2).symm == 0)){
			    //			  if (dat[i_d].symm == 0 || osi_type_parton[0][1] == osi_type_parton[0][2]){
			    logger << LOG_DEBUG_VERBOSE << "distribution_no_bin_no_qTcut_phasespace[" << i_d << "][" << i_b << "][" << i_q << "][" << i_q << "] = " << distribution_no_bin_no_qTcut_phasespace[i_ddd][i_b][i_q][i_a] << endl;
			    change_bin_weight[i_r][i_f][i_q][i_b] += osi_ps_integrand_TSV[i_s][i_r][i_f][0][distribution_no_bin_no_qTcut_phasespace[i_ddd][i_b][i_q][i_a]];
			  }
			  else {
			    change_bin_weight[i_r][i_f][i_q][i_b] += osi_ps_integrand_TSV[i_s][i_r][i_f][1][distribution_no_bin_no_qTcut_phasespace[i_ddd][i_b][i_q][i_a]];
			    change_bin_weight_2nd[i_r][i_f][i_q][i_b] += osi_ps_integrand_TSV[i_s][i_r][i_f][2][distribution_no_bin_no_qTcut_phasespace[i_ddd][i_b][i_q][i_a]];
			  }
			  logger << LOG_DEBUG_VERBOSE << "i_a = " << i_a << endl;

			}
			change_bin_weight2[i_r][i_f][i_q][i_b] = pow(change_bin_weight[i_r][i_f][i_q][i_b], 2);
			if (!(osi_type_parton[0][1] == osi_type_parton[0][2] || ((osi_dddat[i_d].distribution_1).symm == 0 && (osi_dddat[i_d].distribution_2).symm == 0))){
			  //			if (!(dat[i_d].symm == 0 || osi_type_parton[0][1] == osi_type_parton[0][2])){
			  change_bin_weight2_2nd[i_r][i_f][i_q][i_b] = pow(change_bin_weight_2nd[i_r][i_f][i_q][i_b], 2);
			}
		      }
		      else if (change_bin_weight[i_r][i_f][i_q][i_b] == 0.){}
		      else {
			logger << LOG_WARN << "dddistribution   ---   osi_n_ps != 1   ---   dat[" << i_d << "].typeCumulative == CUMULATIVE_NONE   ---   Should not happen now!" << endl;
			change_bin_weight[i_r][i_f][i_q][i_b] = change_bin_weight[i_r][i_f][i_q + 1][i_b];
			change_bin_weight2[i_r][i_f][i_q][i_b] = change_bin_weight2[i_r][i_f][i_q + 1][i_b];
			if (!(osi_type_parton[0][1] == osi_type_parton[0][2] || ((osi_dddat[i_d].distribution_1).symm == 0 && (osi_dddat[i_d].distribution_2).symm == 0))){
			  //			if (!(dat[i_d].symm == 0 || osi_type_parton[0][1] == osi_type_parton[0][2])){
			  change_bin_weight_2nd[i_r][i_f][i_q][i_b] = change_bin_weight_2nd[i_r][i_f][i_q + 1][i_b];
			  change_bin_weight2_2nd[i_r][i_f][i_q][i_b] = change_bin_weight2_2nd[i_r][i_f][i_q + 1][i_b];
			}
		      }
		      logger << LOG_DEBUG_VERBOSE << "i_q = " << i_q << endl;
		    }
		    logger << LOG_DEBUG_VERBOSE << "i_b = " << i_b << endl;
		  }
		  for (int i_b = 0; i_b < distribution_no_bin[i_ddd].size(); i_b++){
		    logger << LOG_DEBUG_VERBOSE << "i_b = " << i_b << endl;
		    int i_q = 0;
		    int j_q = 0;
		    osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_ddd][distribution_no_bin[i_ddd][i_b]] += change_bin_weight[i_r][i_f][j_q][i_b];
		    osi_bin_weight2_TSV[i_s][i_q][i_r][i_f][i_ddd][distribution_no_bin[i_ddd][i_b]] += change_bin_weight2[i_r][i_f][j_q][i_b];
		    //		    logger << LOG_DEBUG_VERBOSE << "dat[" << i_d << "].symm = " << dat[i_d].symm << endl;
		    //		    if (!(dat[i_d].symm == 0 || osi_type_parton[0][1] == osi_type_parton[0][2])){
		    if (!(osi_type_parton[0][1] == osi_type_parton[0][2] || ((osi_dddat[i_d].distribution_1).symm == 0 && (osi_dddat[i_d].distribution_2).symm == 0))){
		      // introduce mirror bins (needed for symmetric disributions) !!!
		      osi_bin_weight_TSV[i_s][i_q][i_r][i_f][i_ddd][osi_dddat[i_d].n_bins - 1 - distribution_no_bin[i_ddd][i_b]] += change_bin_weight_2nd[i_r][i_f][j_q][i_b];
		      osi_bin_weight2_TSV[i_s][i_q][i_r][i_f][i_ddd][osi_dddat[i_d].n_bins - 1 - distribution_no_bin[i_ddd][i_b]] += change_bin_weight2_2nd[i_r][i_f][j_q][i_b];
		    }
		    
		    
		  }
		}
	      }
	    }
	  }
	  logger << LOG_DEBUG_VERBOSE << "osi_n_ps != 1:   2nd step   dat[" << i_d << "] = " << osi_dddat[i_d].name << "   done" << endl;
	  

	}
      }
    }
  

	/*
	if ((bin[dddat[d].d_1][0] == -1) || (bin[dddat[d].d_2][0] == -1)){bin[dat.size() + d][0] = -1;}
	else {bin[dat.size() + d][0] = bin[dddat[d].d_1][0] * (dddat[d].distribution_2).n_bins + bin[dddat[d].d_2][0];}
        if (bin[dat.size() + d][0] != -1){
	  int mirror_bin;
	  bin_value[dat.size() + d][bin[dat.size() + d][0]] += integrand_D[1][0] / dddat[d].step;
	  if (switch_bin_count == 1){bin_counts[dat.size() + d][bin[dat.size() + d][0]]++;}
	  if (osi_type_parton[0][1] != osi_type_parton[0][2]){
	    if (((dddat[d].distribution_1).symm == 0) && ((dddat[d].distribution_2).symm == 0)){ // asymmetric distribution 1, asymmetric distribution 2
	      mirror_bin = bin[dat.size() + d][0];
	      bin_value[dat.size() + d][mirror_bin] += (integrand_D[2][0]) / dddat[d].step;
	      if (switch_bin_count == 1){bin_counts[dat.size() + d][mirror_bin]++;}
	    }
	    else if (((dddat[d].distribution_1).symm == 0) && ((dddat[d].distribution_2).symm == 1)){ // asymmetric distribution 1, symmetric distribution 2
	      mirror_bin = bin[dddat[d].d_1][0] * (dddat[d].distribution_2).n_bins + ((dddat[d].distribution_2).n_bins - 1 - bin[dddat[d].d_2][0]);
	      bin_value[dat.size() + d][mirror_bin] += (integrand_D[2][0]) / dddat[d].step;
	      if (switch_bin_count == 1){bin_counts[dat.size() + d][mirror_bin]++;}
	    }
	    else if (((dddat[d].distribution_1).symm == 1) && ((dddat[d].distribution_2).symm == 0)){ // symmetric distribution 1, asymmetric distribution 2
	      mirror_bin = ((dddat[d].distribution_1).n_bins - 1 - bin[dddat[d].d_1][0]) * (dddat[d].distribution_2).n_bins + bin[dddat[d].d_2][0];
	      bin_value[dat.size() + d][mirror_bin] += (integrand_D[2][0]) / dddat[d].step;
	      if (switch_bin_count == 1){bin_counts[dat.size() + d][mirror_bin]++;}
	    }
	    else if (((dddat[d].distribution_1).symm == 1) && ((dddat[d].distribution_2).symm == 1)){ // symmetric distribution 1, symmetric distribution 2
	      mirror_bin = dat[d].n_bins - 1 - bin[dat.size() + d][0];
	      bin_value[dat.size() + d][mirror_bin] += (integrand_D[2][0]) / dddat[d].step;
	      if (switch_bin_count == 1){bin_counts[dat.size() + d][mirror_bin]++;}
	    }
	  }
	  bin_dev[dat.size() + d][bin[dat.size() + d][0]] += pow(integrand_D[1][0] / dddat[d].step, 2);
	  if (integrand_D[2][0] != 0.){bin_dev[dat.size() + d][mirror_bin] += pow(integrand_D[2][0] / dddat[d].step, 2);}
	}
      }
      else {
	vector<int> xbin_count(0), xbin_count_2(0);
	vector<double> xbin_dev(0), xbin_dev_2(0);
	for (int i_a = 0; i_a < osi_n_ps; i_a++){
	  if ((bin[dddat[d].d_1][i_a] == -1) || (bin[dddat[d].d_2][i_a] == -1)){bin[dat.size() + d][i_a] = -1;}
	  else {bin[dat.size() + d][i_a] = bin[dddat[d].d_1][i_a] * (dddat[d].distribution_2).n_bins + bin[dddat[d].d_2][i_a];}
	  
	  if (bin[dat.size() + d][i_a] != -1){
	    vector<int> mirror_bin(osi_n_ps);
	    bin_value[dat.size() + d][bin[dat.size() + d][i_a]] += (integrand_D[1][i_a]) / dddat[d].step;
	    if (switch_bin_count == 1){bin_counts[dat.size() + d][bin[dat.size() + d][i_a]]++;}
	    if (osi_type_parton[0][1] != osi_type_parton[0][2]){
	      if (((dddat[d].distribution_1).symm == 0) && ((dddat[d].distribution_2).symm == 0)){ // asymmetric distribution 1, asymmetric distribution 2
		mirror_bin[i_a] = bin[dat.size() + d][i_a];
		bin_value[dat.size() + d][mirror_bin[i_a]] += (integrand_D[2][i_a]) / dddat[d].step;
		if (switch_bin_count == 1){bin_counts[dat.size() + d][mirror_bin[i_a]]++;}
	      }
	      else if (((dddat[d].distribution_1).symm == 0) && ((dddat[d].distribution_2).symm == 1)){ // asymmetric distribution 1, symmetric distribution 2
		mirror_bin[i_a] = bin[dddat[d].d_1][i_a] * (dddat[d].distribution_2).n_bins + ((dddat[d].distribution_2).n_bins - 1 - bin[dddat[d].d_2][i_a]);
		bin_value[dat.size() + d][mirror_bin[i_a]] += (integrand_D[2][i_a]) / dddat[d].step;
		if (switch_bin_count == 1){bin_counts[dat.size() + d][mirror_bin[i_a]]++;}
	      }
	      else if (((dddat[d].distribution_1).symm == 1) && ((dddat[d].distribution_2).symm == 0)){ // symmetric distribution 1, asymmetric distribution 2
		mirror_bin[i_a] = ((dddat[d].distribution_1).n_bins - 1 - bin[dddat[d].d_1][i_a]) * (dddat[d].distribution_2).n_bins + bin[dddat[d].d_2][i_a];
		bin_value[dat.size() + d][mirror_bin[i_a]] += (integrand_D[2][i_a]) / dddat[d].step;
		if (switch_bin_count == 1){bin_counts[dat.size() + d][mirror_bin[i_a]]++;}
	      }
	      else if (((dddat[d].distribution_1).symm == 1) && ((dddat[d].distribution_2).symm == 1)){ // symmetric distribution 1, symmetric distribution 2
		mirror_bin[i_a] = dat[d].n_bins - 1 - bin[dat.size() + d][i_a];
		bin_value[dat.size() + d][mirror_bin[i_a]] += (integrand_D[2][i_a]) / dddat[d].step;
		if (switch_bin_count == 1){bin_counts[dat.size() + d][mirror_bin[i_a]]++;}
	      }
	    }
	    
	    //
	    // deviation
	    //
	    
	    int exist = -1;
	    for (int x = 0; x < xbin_count.size(); x++){
	      if (bin[dat.size() + d][i_a] == xbin_count[x]){exist = x; break;}
	    }
	    if (exist == -1){
	      xbin_count.push_back(bin[dat.size() + d][i_a]);
	      xbin_dev.push_back(integrand_D[1][i_a] / dddat[d].step);
	    }
	    else {
	      xbin_dev[exist] += integrand_D[1][i_a] / dddat[d].step;
	    }
	    if (integrand_D[2][i_a] != 0.){
	      exist = -1;
	      for (int x = 0; x < xbin_count_2.size(); x++){
		if (mirror_bin[i_a] == xbin_count_2[x]){exist = x; break;}
	      }
	      if (exist == -1){
		xbin_count_2.push_back(mirror_bin[i_a]);
		xbin_dev_2.push_back(integrand_D[2][i_a] / dddat[d].step);
	      }
	      else {
		xbin_dev_2[exist] += integrand_D[2][i_a] / dddat[d].step;
	      }
	    }
	  }
	}
	for (int x = 0; x < xbin_count.size(); x++){
	  bin_dev[dat.size() + d][xbin_count[x]] += pow(xbin_dev[x], 2);
	}
	for (int x = 0; x < xbin_count_2.size(); x++){
	  bin_dev[dat.size() + d][xbin_count_2[x]] += pow(xbin_dev_2[x], 2);
	}
      }
      */

    




    
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
