module resummation
   use types; use consts_dp
   use rad_tools
   use pdfs_tools
   use warnings_and_errors
   use emsn_tools
   use ew_parameters; use mass_corr
   use special_functions
   use sub_defs_io
   use gen_radiation

   implicit none

   private
   public :: resummed_sigma, resummed_sigma_inclusive

! TODO: there's really no need for this whole module - perhaps we can get rid of it, and call directly gen_rad????
contains
   !======================================================================
   subroutine resummed_sigma(order, nev, ncall1, ncall2, gen_seed, use_cuts)
      integer, intent(in) :: order
      logical, intent(in) :: use_cuts
      integer, intent(in) :: nev, ncall1, ncall2, gen_seed ! number of events and seed for numerical resummation
      !------------------------------

      call gen_rad(order, nev, ncall1, ncall2, gen_seed, use_cuts)

   end subroutine resummed_sigma

   subroutine resummed_sigma_inclusive(order, nev)
      integer, intent(in) :: order
      integer, intent(in) :: nev! number of events and seed for numerical resummation

      call gen_rad_inclusive(order, nev)

   end subroutine resummed_sigma_inclusive

end module resummation
