#include <iostream>
#include <iomanip>
#include "ampww.h"

using namespace std;

int main() {
  // a generic point:
  double s = 6.863701277323974;
  double t = -1.83989;
  double m2 = 1.0;
  // a difficult point:
  //double s = 5577.776648726018;     /*x2=0.0001793472183635458*/
  //double t =-0.0006513521259708399; /*y2=0.0006513521259708399*/
  //double m2 = 1.0;

  double f0_N, j0_N, k0_N;
  double f1_CF_N, j1_CF_N, k1_CF_N;
  double f11_CF2_N, j11_CF2_N, k11_CF2_N;
  double f2_CF2_N, j2_CF2_N, k2_CF2_N;
  double f2_CF, j2_CF, k2_CF;
  double f2_CF_N_Nf, j2_CF_N_Nf, k2_CF_N_Nf;
  double f2_CF_N_NfWW, j2_CF_N_NfWW;

  ampww(s, t, m2,
        f0_N, j0_N, k0_N,
        f1_CF_N, j1_CF_N, k1_CF_N,
        f11_CF2_N, j11_CF2_N, k11_CF2_N,
        f2_CF2_N, j2_CF2_N, k2_CF2_N,
        f2_CF, j2_CF, k2_CF,
        f2_CF_N_Nf, j2_CF_N_Nf, k2_CF_N_Nf,
        f2_CF_N_NfWW, j2_CF_N_NfWW);

  cout << "L=0:  " << f0_N << '\t' << j0_N  << '\t' << k0_N << endl;
  cout << "L=1:  " << f1_CF_N << '\t' << j1_CF_N << '\t' << k1_CF_N << endl;
  cout << "L=11: " << f11_CF2_N << '\t' << j11_CF2_N << '\t' << k11_CF2_N << endl;
  cout << "L=2:  " << f2_CF2_N << '\t' << j2_CF2_N << '\t' << k2_CF2_N << endl;
  cout << "      " << f2_CF << '\t' << j2_CF << '\t' << k2_CF << endl;
  cout << "      " << f2_CF_N_Nf << '\t' << j2_CF_N_Nf << '\t' << k2_CF_N_Nf << endl;
  cout << "      " << f2_CF_N_NfWW << '\t' << j2_CF_N_NfWW << endl;

  return 0;
}

